var searchIndex = {};
searchIndex["actix_web"] = {"doc":"Actix web is a small, pragmatic, and extremely fast web framework for Rust.","items":[[3,"App","actix_web","Structure that follows the builder pattern for building application instances.",null,null],[3,"HttpContext","","Execution context for http actors",null,null],[3,"Extensions","","A type map of request extensions.",null,null],[3,"Form","","Extract typed information from the request's body.",null,null],[12,"0","","",0,null],[3,"Path","","Extract typed information from the request's path.",null,null],[3,"Query","","Extract typed information from from the request's query.",null,null],[3,"State","","Access an application state",null,null],[3,"HttpRequest","","An HTTP Request",null,null],[3,"HttpResponse","","An HTTP Response",null,null],[3,"Json","","Json helper",null,null],[12,"0","","",1,null],[3,"Scope","","Resources scope",null,null],[3,"Request","","Request's context",null,null],[4,"Binary","","Represents various types of binary body. `Content-Length` header is set to length of the body.",null,null],[13,"Bytes","","Bytes body",2,null],[13,"Slice","","Static slice",2,null],[13,"SharedVec","","Shared vec body",2,null],[4,"Body","","Represents various types of http message body.",null,null],[13,"Empty","","Empty response. `Content-Length` header is set to `0`",3,null],[13,"Binary","","Specific response body.",3,null],[13,"Streaming","","Unspecified streaming response. Developer is responsible for setting right `Content-Length` or `Transfer-Encoding` headers.",3,null],[13,"Actor","","Special body type for actor response.",3,null],[4,"Either","","Combines two different responder types into a single type",null,null],[13,"A","","First branch of the type",4,null],[13,"B","","Second branch of the type",4,null],[11,"new","","Create application with empty state. Application can be configured with a builder-like pattern.",5,{"o":{"n":"app"}}],[11,"default","","",5,{"o":{"n":"self"}}],[11,"with_state","","Create application with specified state. Application can be configured with a builder-like pattern.",5,{"i":[{"n":"s"}],"o":{"n":"app"}}],[11,"state","","Get reference to the application state",5,{"i":[{"n":"self"}],"o":{"n":"s"}}],[11,"prefix","","Set application prefix.",5,{"i":[{"n":"self"},{"n":"p"}],"o":{"n":"app"}}],[11,"filter","","Add match predicate to application.",5,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"app"}}],[11,"route","","Configure route for a specific path.",5,{"i":[{"n":"self"},{"n":"str"},{"n":"method"},{"n":"f"}],"o":{"n":"app"}}],[11,"scope","","Configure scope for common root path.",5,{"i":[{"n":"self"},{"n":"str"},{"n":"f"}],"o":{"n":"app"}}],[11,"resource","","Configure resource for a specific path.",5,{"i":[{"n":"self"},{"n":"str"},{"n":"f"}],"o":{"n":"app"}}],[11,"default_resource","","Default resource to be used if no matching route could be found.",5,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"app"}}],[11,"default_encoding","","Set default content encoding. `ContentEncoding::Auto` is set by default.",5,{"i":[{"n":"self"},{"n":"contentencoding"}],"o":{"n":"app"}}],[11,"external_resource","","Register an external resource.",5,{"i":[{"n":"self"},{"n":"t"},{"n":"u"}],"o":{"n":"app"}}],[11,"handler","","Configure handler for specific path prefix.",5,{"i":[{"n":"self"},{"n":"str"},{"n":"h"}],"o":{"n":"app"}}],[11,"middleware","","Register a middleware.",5,{"i":[{"n":"self"},{"n":"m"}],"o":{"n":"app"}}],[11,"configure","","Run external configuration as part of the application building process",5,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"app"}}],[11,"finish","","Finish application configuration and create `HttpHandler` object.",5,{"i":[{"n":"self"}],"o":{"n":"httpapplication"}}],[11,"boxed","","Convenience method for creating `Box<HttpHandler>` instances.",5,{"i":[{"n":"self"}],"o":{"g":["httphandler"],"n":"box"}}],[11,"into_handler","","",5,{"i":[{"n":"self"}],"o":{"n":"httpapplication"}}],[11,"fmt","","",2,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",2,{"i":[{"n":"self"},{"n":"binary"}],"o":{"n":"bool"}}],[11,"ne","","",2,{"i":[{"n":"self"},{"n":"binary"}],"o":{"n":"bool"}}],[11,"is_streaming","","Does this body streaming.",3,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"is_binary","","Is this binary body.",3,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"is_empty","","Is this binary empy.",3,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"from_slice","","Create body from slice (copy)",3,null],[11,"eq","","",3,{"i":[{"n":"self"},{"n":"body"}],"o":{"n":"bool"}}],[11,"fmt","","",3,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","","",3,{"i":[{"n":"t"}],"o":{"n":"body"}}],[11,"from","","",3,{"i":[{"g":["actorhttpcontext"],"n":"box"}],"o":{"n":"body"}}],[11,"is_empty","","Returns `true` if body is empty",2,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"len","","Length of body in bytes",2,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"from_slice","","Create binary body from slice",2,null],[11,"take","","Convert Binary to a Bytes instance",2,{"i":[{"n":"self"}],"o":{"n":"bytes"}}],[11,"clone","","",2,{"i":[{"n":"self"}],"o":{"n":"binary"}}],[11,"into","","",2,{"i":[{"n":"self"}],"o":{"n":"bytes"}}],[11,"from","","",2,{"i":[{"n":"str"}],"o":{"n":"binary"}}],[11,"from","","",2,null],[11,"from","","",2,{"i":[{"g":["u8"],"n":"vec"}],"o":{"n":"binary"}}],[11,"from","","",2,{"i":[{"n":"string"}],"o":{"n":"binary"}}],[11,"from","","",2,{"i":[{"n":"string"}],"o":{"n":"binary"}}],[11,"from","","",2,{"i":[{"n":"bytes"}],"o":{"n":"binary"}}],[11,"from","","",2,{"i":[{"n":"bytesmut"}],"o":{"n":"binary"}}],[11,"from","","",2,{"i":[{"g":["string"],"n":"arc"}],"o":{"n":"binary"}}],[11,"from","","",2,{"i":[{"n":"arc"}],"o":{"n":"binary"}}],[11,"from","","",2,{"i":[{"g":["vec"],"n":"arc"}],"o":{"n":"binary"}}],[11,"from","","",2,{"i":[{"n":"arc"}],"o":{"n":"binary"}}],[11,"as_ref","","",2,null],[11,"respond_to","","",2,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["httpresponse","error"],"n":"result"}}],[11,"stop","","",6,{"i":[{"n":"self"}]}],[11,"terminate","","",6,{"i":[{"n":"self"}]}],[11,"state","","",6,{"i":[{"n":"self"}],"o":{"n":"actorstate"}}],[11,"spawn","","",6,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"spawnhandle"}}],[11,"wait","","",6,{"i":[{"n":"self"},{"n":"f"}]}],[11,"cancel_future","","",6,{"i":[{"n":"self"},{"n":"spawnhandle"}],"o":{"n":"bool"}}],[11,"address","","",6,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"create","","Create a new HTTP Context from a request and an actor",6,{"i":[{"n":"httprequest"},{"n":"a"}],"o":{"n":"body"}}],[11,"with_factory","","Create a new HTTP Context",6,{"i":[{"n":"httprequest"},{"n":"f"}],"o":{"n":"body"}}],[11,"state","","Shared application state",6,{"i":[{"n":"self"}],"o":{"n":"s"}}],[11,"request","","Incoming request",6,{"i":[{"n":"self"}],"o":{"n":"httprequest"}}],[11,"write","","Write payload",6,{"i":[{"n":"self"},{"n":"b"}]}],[11,"write_eof","","Indicate end of streaming payload. Also this method calls `Self::close`.",6,{"i":[{"n":"self"}]}],[11,"drain","","Returns drain future",6,{"i":[{"n":"self"}],"o":{"n":"drain"}}],[11,"connected","","Check if connection still open",6,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"handle","","Handle of the running future",6,{"i":[{"n":"self"}],"o":{"n":"spawnhandle"}}],[11,"parts","","",6,{"i":[{"n":"self"}],"o":{"n":"contextparts"}}],[11,"pack","","",6,{"i":[{"n":"m"},{"g":["sender"],"n":"option"}],"o":{"n":"envelope"}}],[11,"insert","","Insert a type into this `Extensions`.",7,{"i":[{"n":"self"},{"n":"t"}]}],[11,"get","","Get a reference to a type previously inserted on this `Extensions`.",7,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"get_mut","","Get a mutable reference to a type previously inserted on this `Extensions`.",7,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"remove","","Remove a type from this `Extensions`.",7,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"clear","","Clear the `Extensions` of all inserted extensions.",7,{"i":[{"n":"self"}]}],[11,"fmt","","",7,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"as_ref","","",8,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"deref","","",8,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"deref_mut","","",8,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"into_inner","","Deconstruct to an inner value",8,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"from_request","","",8,null],[11,"fmt","","",8,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",8,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"deref","","",9,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"deref_mut","","",9,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"into_inner","","Deconstruct to a inner value",9,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"from_request","","",9,null],[11,"fmt","","",9,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",9,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"into_inner","","Deconstruct to an inner value",0,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"deref","","",0,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"deref_mut","","",0,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"from_request","","",0,null],[11,"fmt","","",0,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",0,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",4,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"respond_to","","",4,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["asyncresult","error"],"n":"result"}}],[11,"poll","","",4,{"i":[{"n":"self"}],"o":{"n":"poll"}}],[11,"respond_to","","",10,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["asyncresult","error"],"n":"result"}}],[11,"deref","","",11,{"i":[{"n":"self"}],"o":{"n":"s"}}],[11,"from_request","","",11,null],[11,"Ok","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"Created","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"Accepted","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"NonAuthoritativeInformation","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"NoContent","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"ResetContent","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"PartialContent","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"MultiStatus","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"AlreadyReported","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"MultipleChoices","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"MovedPermanenty","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"MovedPermanently","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"Found","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"SeeOther","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"NotModified","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"UseProxy","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"TemporaryRedirect","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"PermanentRedirect","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"BadRequest","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"NotFound","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"Unauthorized","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"PaymentRequired","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"Forbidden","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"MethodNotAllowed","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"NotAcceptable","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"ProxyAuthenticationRequired","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"RequestTimeout","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"Conflict","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"Gone","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"LengthRequired","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"PreconditionFailed","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"PayloadTooLarge","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"UriTooLong","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"UnsupportedMediaType","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"RangeNotSatisfiable","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"ExpectationFailed","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"InternalServerError","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"NotImplemented","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"BadGateway","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"ServiceUnavailable","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"GatewayTimeout","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"VersionNotSupported","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"VariantAlsoNegotiates","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"InsufficientStorage","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"LoopDetected","","",10,{"o":{"n":"httpresponsebuilder"}}],[11,"headers","","",12,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"payload","","",12,{"i":[{"n":"self"}],"o":{"n":"payload"}}],[11,"deref","","",12,{"i":[{"n":"self"}],"o":{"n":"request"}}],[11,"state","","Shared application state",12,{"i":[{"n":"self"}],"o":{"n":"s"}}],[11,"request","","Server request",12,{"i":[{"n":"self"}],"o":{"n":"request"}}],[11,"extensions","","Request extensions",12,{"i":[{"n":"self"}],"o":{"g":["extensions"],"n":"ref"}}],[11,"extensions_mut","","Mutable reference to a the request's extensions",12,{"i":[{"n":"self"}],"o":{"g":["extensions"],"n":"refmut"}}],[11,"response","","Create http response",12,{"i":[{"n":"self"},{"n":"statuscode"},{"n":"body"}],"o":{"n":"httpresponse"}}],[11,"build_response","","Create http response builder",12,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"httpresponsebuilder"}}],[11,"uri","","Read the Request Uri.",12,{"i":[{"n":"self"}],"o":{"n":"uri"}}],[11,"method","","Read the Request method.",12,{"i":[{"n":"self"}],"o":{"n":"method"}}],[11,"version","","Read the Request Version.",12,{"i":[{"n":"self"}],"o":{"n":"version"}}],[11,"path","","The target path of this Request.",12,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"connection_info","","Get ConnectionInfo for the correct request.",12,{"i":[{"n":"self"}],"o":{"g":["connectioninfo"],"n":"ref"}}],[11,"url_for","","Generate url for named resource",12,{"i":[{"n":"self"},{"n":"str"},{"n":"u"}],"o":{"g":["url","urlgenerationerror"],"n":"result"}}],[11,"url_for_static","","Generate url for named resource",12,{"i":[{"n":"self"},{"n":"str"}],"o":{"g":["url","urlgenerationerror"],"n":"result"}}],[11,"resource","","This method returns reference to current `RouteInfo` object.",12,{"i":[{"n":"self"}],"o":{"n":"resourceinfo"}}],[11,"peer_addr","","Peer socket address",12,{"i":[{"n":"self"}],"o":{"g":["socketaddr"],"n":"option"}}],[11,"query","","url query parameters.",12,{"i":[{"n":"self"}],"o":{"g":["hashmap"],"n":"ref"}}],[11,"query_string","","The query string in the URL.",12,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"cookies","","Load request cookies.",12,{"i":[{"n":"self"}],"o":{"g":["ref","cookieparseerror"],"n":"result"}}],[11,"cookie","","Return request cookie.",12,{"i":[{"n":"self"},{"n":"str"}],"o":{"g":["cookie"],"n":"option"}}],[11,"match_info","","Get a reference to the Params object.",12,{"i":[{"n":"self"}],"o":{"n":"params"}}],[11,"set_read_buffer_capacity","","Set read buffer capacity",12,{"i":[{"n":"self"},{"n":"usize"}]}],[11,"drop","","",12,{"i":[{"n":"self"}]}],[11,"clone","","",12,{"i":[{"n":"self"}],"o":{"n":"httprequest"}}],[11,"from_request","","",12,null],[11,"fmt","","",12,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"build","","Create http response builder with specific status.",10,{"i":[{"n":"statuscode"}],"o":{"n":"httpresponsebuilder"}}],[11,"build_from","","Create http response builder",10,{"i":[{"n":"t"}],"o":{"n":"httpresponsebuilder"}}],[11,"new","","Constructs a response",10,{"i":[{"n":"statuscode"}],"o":{"n":"httpresponse"}}],[11,"with_body","","Constructs a response with body",10,{"i":[{"n":"statuscode"},{"n":"b"}],"o":{"n":"httpresponse"}}],[11,"from_error","","Constructs an error response",10,{"i":[{"n":"error"}],"o":{"n":"httpresponse"}}],[11,"into_builder","","Convert `HttpResponse` to a `HttpResponseBuilder`",10,{"i":[{"n":"self"}],"o":{"n":"httpresponsebuilder"}}],[11,"error","","The source `error` for this response",10,{"i":[{"n":"self"}],"o":{"g":["error"],"n":"option"}}],[11,"version","","Get the HTTP version of this response",10,{"i":[{"n":"self"}],"o":{"g":["version"],"n":"option"}}],[11,"headers","","Get the headers from the response",10,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"headers_mut","","Get a mutable reference to the headers",10,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"cookies","","Get an iterator for the cookies set by this response",10,{"i":[{"n":"self"}],"o":{"n":"cookieiter"}}],[11,"add_cookie","","Add a cookie to this response",10,{"i":[{"n":"self"},{"n":"cookie"}],"o":{"g":["httperror"],"n":"result"}}],[11,"del_cookie","","Remove all cookies with the given name from this response. Returns the number of cookies removed.",10,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"usize"}}],[11,"status","","Get the response status code",10,{"i":[{"n":"self"}],"o":{"n":"statuscode"}}],[11,"status_mut","","Set the `StatusCode` for this response",10,{"i":[{"n":"self"}],"o":{"n":"statuscode"}}],[11,"reason","","Get custom reason for the response",10,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"set_reason","","Set the custom reason for the response",10,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"self"}}],[11,"set_connection_type","","Set connection type",10,{"i":[{"n":"self"},{"n":"connectiontype"}],"o":{"n":"self"}}],[11,"upgrade","","Connection upgrade status",10,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"keep_alive","","Keep-alive status for this connection",10,{"i":[{"n":"self"}],"o":{"g":["bool"],"n":"option"}}],[11,"chunked","","is chunked encoding enabled",10,{"i":[{"n":"self"}],"o":{"g":["bool"],"n":"option"}}],[11,"content_encoding","","Content encoding",10,{"i":[{"n":"self"}],"o":{"g":["contentencoding"],"n":"option"}}],[11,"set_content_encoding","","Set content encoding",10,{"i":[{"n":"self"},{"n":"contentencoding"}],"o":{"n":"self"}}],[11,"body","","Get body os this response",10,{"i":[{"n":"self"}],"o":{"n":"body"}}],[11,"set_body","","Set a body",10,{"i":[{"n":"self"},{"n":"b"}]}],[11,"replace_body","","Set a body and return previous body value",10,{"i":[{"n":"self"},{"n":"b"}],"o":{"n":"body"}}],[11,"response_size","","Size of response in bytes, excluding HTTP headers",10,{"i":[{"n":"self"}],"o":{"n":"u64"}}],[11,"write_buffer_capacity","","Set write buffer capacity",10,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"set_write_buffer_capacity","","Set write buffer capacity",10,{"i":[{"n":"self"},{"n":"usize"}]}],[11,"fmt","","",10,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","","",10,{"i":[{"n":"result"}],"o":{"n":"self"}}],[11,"from","","",10,{"i":[{"n":"httpresponsebuilder"}],"o":{"n":"self"}}],[11,"from","","",10,{"i":[{"n":"str"}],"o":{"n":"self"}}],[11,"from","","",10,null],[11,"from","","",10,{"i":[{"n":"string"}],"o":{"n":"self"}}],[11,"from","","",10,{"i":[{"n":"string"}],"o":{"n":"self"}}],[11,"from","","",10,{"i":[{"n":"bytes"}],"o":{"n":"self"}}],[11,"from","","",10,{"i":[{"n":"bytesmut"}],"o":{"n":"self"}}],[11,"into_inner","","Deconstruct to an inner value",1,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"deref","","",1,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"deref_mut","","",1,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"fmt","","",1,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",1,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"respond_to","","",1,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["httpresponse","error"],"n":"result"}}],[11,"from_request","","",1,null],[11,"new","","Create a new scope",13,{"i":[{"n":"str"}],"o":{"n":"scope"}}],[11,"filter","","Add match predicate to scope.",13,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"self"}}],[11,"with_state","","Create nested scope with new state.",13,{"i":[{"n":"self"},{"n":"str"},{"n":"t"},{"n":"f"}],"o":{"n":"scope"}}],[11,"nested","","Create nested scope.",13,{"i":[{"n":"self"},{"n":"str"},{"n":"f"}],"o":{"n":"scope"}}],[11,"route","","Configure route for a specific path.",13,{"i":[{"n":"self"},{"n":"str"},{"n":"method"},{"n":"f"}],"o":{"n":"scope"}}],[11,"resource","","Configure resource for a specific path.",13,{"i":[{"n":"self"},{"n":"str"},{"n":"f"}],"o":{"n":"scope"}}],[11,"default_resource","","Default resource to be used if no matching route could be found.",13,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"scope"}}],[11,"middleware","","Register a scope middleware",13,{"i":[{"n":"self"},{"n":"m"}],"o":{"n":"scope"}}],[0,"client","","Http client api",null,null],[3,"ClientConnector","actix_web::client","`ClientConnector` type is responsible for transport layer of a client connection.",null,null],[3,"ClientConnectorStats","","Client connector usage stats",null,null],[12,"waits","","Number of waited-on connections",14,null],[12,"wait_queue","","Size of the wait queue",14,null],[12,"reused","","Number of reused connections",14,null],[12,"opened","","Number of opened connections",14,null],[12,"closed","","Number of closed connections",14,null],[12,"errors","","Number of connections with errors",14,null],[12,"timeouts","","Number of connection timeouts",14,null],[3,"Connect","","`Connect` type represents a message that can be sent to `ClientConnector` with a connection request.",null,null],[3,"Connection","","HTTP client connection",null,null],[3,"Pause","","Pause connection process for `ClientConnector`",null,null],[3,"Resume","","Resume connection process for `ClientConnector`",null,null],[3,"SendRequest","","`SendRequest` is a `Future` which represents an asynchronous request sending process.",null,null],[3,"ClientRequest","","An HTTP Client Request",null,null],[3,"ClientRequestBuilder","","An HTTP Client request builder",null,null],[3,"ClientResponse","","An HTTP Client response",null,null],[4,"ClientConnectorError","","A set of errors that can occur while connecting to an HTTP host",null,null],[13,"InvalidUrl","","Invalid URL",15,null],[13,"SslIsNotSupported","","SSL feature is not enabled",15,null],[13,"SslError","","SSL error",15,null],[13,"Resolver","","Resolver error",15,null],[13,"Timeout","","Connection took too long",15,null],[13,"Disconnected","","Connector has been disconnected",15,null],[13,"IoError","","Connection IO error",15,null],[4,"SendRequestError","","A set of errors that can occur during request sending and response reading",null,null],[13,"Timeout","","Response took too long",16,null],[13,"Connector","","Failed to connect to host",16,null],[13,"ParseError","","Error parsing response",16,null],[13,"Io","","Error reading response payload",16,null],[5,"get","","Create request builder for `GET` requests",null,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[5,"head","","Create request builder for `HEAD` requests",null,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[5,"post","","Create request builder for `POST` requests",null,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[5,"put","","Create request builder for `PUT` requests",null,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[5,"delete","","Create request builder for `DELETE` requests",null,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[11,"default","","",14,{"o":{"n":"clientconnectorstats"}}],[11,"fmt","","",17,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"new","","Create `Connect` message for specified `Uri`",17,{"i":[{"n":"u"}],"o":{"g":["connect","httperror"],"n":"result"}}],[11,"conn_timeout","","Connection timeout, i.e. max time to connect to remote host. Set to 1 second by default.",17,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"wait_timeout","","If connection pool limits are enabled, wait time indicates max time to wait for a connection to become available. Set to 5 seconds by default.",17,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"new","","Create message with pause duration parameter",18,{"i":[{"n":"duration"}],"o":{"n":"pause"}}],[11,"default","","",18,{"o":{"n":"pause"}}],[11,"cause","","",15,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",15,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",15,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",15,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","","",15,{"i":[{"n":"resolvererror"}],"o":{"n":"clientconnectorerror"}}],[11,"started","","",19,null],[11,"default","","",19,{"o":{"n":"clientconnector"}}],[11,"with_connector","","Create `ClientConnector` actor with custom `SslConnector` instance.",19,{"i":[{"n":"sslconnector"}],"o":{"n":"clientconnector"}}],[11,"limit","","Set total number of simultaneous connections.",19,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"limit_per_host","","Set total number of simultaneous connections to the same endpoint.",19,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"conn_keep_alive","","Set keep-alive period for opened connection.",19,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"conn_lifetime","","Set max lifetime period for connection.",19,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"stats","","Subscribe for connector stats. Only one subscriber is supported.",19,{"i":[{"n":"self"},{"g":["clientconnectorstats"],"n":"recipient"}],"o":{"n":"self"}}],[11,"resolver","","Use custom resolver actor",19,{"i":[{"n":"self"},{"g":["resolver"],"n":"addr"}],"o":{"n":"self"}}],[11,"handle","","",19,null],[11,"handle","","",19,null],[11,"handle","","",19,null],[11,"fmt","","",20,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"stream","","Raw IO stream",20,{"i":[{"n":"self"}],"o":{"n":"iostream"}}],[11,"from_stream","","Create a new connection from an IO Stream",20,{"i":[{"n":"t"}],"o":{"n":"connection"}}],[11,"close","","Close connection",20,{"i":[{"n":"self"}]}],[11,"release","","Release this connection to the connection pool",20,{"i":[{"n":"self"}]}],[11,"read","","",20,null],[11,"write","","",20,null],[11,"flush","","",20,{"i":[{"n":"self"}],"o":{"n":"result"}}],[11,"shutdown","","",20,{"i":[{"n":"self"}],"o":{"g":["error"],"n":"poll"}}],[11,"cause","","",16,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",16,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",16,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",16,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","","",16,{"i":[{"n":"error"}],"o":{"n":"sendrequesterror"}}],[11,"from","","",16,{"i":[{"n":"clientconnectorerror"}],"o":{"n":"sendrequesterror"}}],[11,"timeout","","Set request timeout",21,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"conn_timeout","","Set connection timeout",21,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"wait_timeout","","Set wait timeout",21,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"poll","","",21,{"i":[{"n":"self"}],"o":{"n":"poll"}}],[11,"default","","",22,{"o":{"n":"clientrequest"}}],[11,"get","","Create request builder for `GET` request",22,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[11,"head","","Create request builder for `HEAD` request",22,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[11,"post","","Create request builder for `POST` request",22,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[11,"put","","Create request builder for `PUT` request",22,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[11,"delete","","Create request builder for `DELETE` request",22,{"i":[{"n":"u"}],"o":{"n":"clientrequestbuilder"}}],[11,"build","","Create client request builder",22,{"o":{"n":"clientrequestbuilder"}}],[11,"build_from","","Create client request builder",22,{"i":[{"n":"t"}],"o":{"n":"clientrequestbuilder"}}],[11,"uri","","Get the request URI",22,{"i":[{"n":"self"}],"o":{"n":"uri"}}],[11,"set_uri","","Set client request URI",22,{"i":[{"n":"self"},{"n":"uri"}]}],[11,"method","","Get the request method",22,{"i":[{"n":"self"}],"o":{"n":"method"}}],[11,"set_method","","Set HTTP `Method` for the request",22,{"i":[{"n":"self"},{"n":"method"}]}],[11,"version","","Get HTTP version for the request",22,{"i":[{"n":"self"}],"o":{"n":"version"}}],[11,"set_version","","Set http `Version` for the request",22,{"i":[{"n":"self"},{"n":"version"}]}],[11,"headers","","Get the headers from the request",22,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"headers_mut","","Get a mutable reference to the headers",22,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"chunked","","is chunked encoding enabled",22,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"upgrade","","is upgrade request",22,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"content_encoding","","Content encoding",22,{"i":[{"n":"self"}],"o":{"n":"contentencoding"}}],[11,"response_decompress","","Decompress response payload",22,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"write_buffer_capacity","","Requested write buffer capacity",22,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"body","","Get body of this response",22,{"i":[{"n":"self"}],"o":{"n":"body"}}],[11,"set_body","","Set a body",22,{"i":[{"n":"self"},{"n":"b"}]}],[11,"send","","Send request",22,{"i":[{"n":"self"}],"o":{"n":"sendrequest"}}],[11,"fmt","","",22,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"uri","","Set HTTP URI of request.",23,{"i":[{"n":"self"},{"n":"u"}],"o":{"n":"self"}}],[11,"method","","Set HTTP method of this request.",23,{"i":[{"n":"self"},{"n":"method"}],"o":{"n":"self"}}],[11,"get_method","","Set HTTP method of this request.",23,{"i":[{"n":"self"}],"o":{"n":"method"}}],[11,"version","","Set HTTP version of this request.",23,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"self"}}],[11,"header","","Append a header.",23,{"i":[{"n":"self"},{"n":"k"},{"n":"v"}],"o":{"n":"self"}}],[11,"set_header","","Set a header.",23,{"i":[{"n":"self"},{"n":"k"},{"n":"v"}],"o":{"n":"self"}}],[11,"set_header_if_none","","Set a header only if it is not yet set.",23,{"i":[{"n":"self"},{"n":"k"},{"n":"v"}],"o":{"n":"self"}}],[11,"content_encoding","","Set content encoding.",23,{"i":[{"n":"self"},{"n":"contentencoding"}],"o":{"n":"self"}}],[11,"chunked","","Enables automatic chunked transfer encoding",23,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"upgrade","","Enable connection upgrade",23,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"content_type","","Set request's content type",23,{"i":[{"n":"self"},{"n":"v"}],"o":{"n":"self"}}],[11,"content_length","","Set content length",23,{"i":[{"n":"self"},{"n":"u64"}],"o":{"n":"self"}}],[11,"cookie","","Set a cookie",23,{"i":[{"n":"self"},{"n":"cookie"}],"o":{"n":"self"}}],[11,"no_default_headers","","Do not add default request headers. By default `Accept-Encoding` and `User-Agent` headers are set.",23,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"disable_decompress","","Disable automatic decompress response body",23,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"write_buffer_capacity","","Set write buffer capacity",23,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"timeout","","Set request timeout",23,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"with_connector","","Send request using custom connector",23,{"i":[{"n":"self"},{"g":["clientconnector"],"n":"addr"}],"o":{"n":"self"}}],[11,"with_connection","","Send request using existing `Connection`",23,{"i":[{"n":"self"},{"n":"connection"}],"o":{"n":"self"}}],[11,"if_true","","This method calls provided closure with builder reference if value is `true`.",23,{"i":[{"n":"self"},{"n":"bool"},{"n":"f"}],"o":{"n":"self"}}],[11,"if_some","","This method calls provided closure with builder reference if value is `Some`.",23,{"i":[{"n":"self"},{"n":"option"},{"n":"f"}],"o":{"n":"self"}}],[11,"body","","Set a body and generate `ClientRequest`.",23,{"i":[{"n":"self"},{"n":"b"}],"o":{"g":["clientrequest","error"],"n":"result"}}],[11,"json","","Set a JSON body and generate `ClientRequest`",23,{"i":[{"n":"self"},{"n":"t"}],"o":{"g":["clientrequest","error"],"n":"result"}}],[11,"form","","Set a urlencoded body and generate `ClientRequest`",23,{"i":[{"n":"self"},{"n":"t"}],"o":{"g":["clientrequest","error"],"n":"result"}}],[11,"streaming","","Set a streaming body and generate `ClientRequest`.",23,{"i":[{"n":"self"},{"n":"s"}],"o":{"g":["clientrequest","error"],"n":"result"}}],[11,"finish","","Set an empty body and generate `ClientRequest`",23,{"i":[{"n":"self"}],"o":{"g":["clientrequest","error"],"n":"result"}}],[11,"take","","This method construct new `ClientRequestBuilder`",23,{"i":[{"n":"self"}],"o":{"n":"clientrequestbuilder"}}],[11,"fmt","","",23,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","","",23,{"i":[{"n":"httprequest"}],"o":{"n":"clientrequestbuilder"}}],[11,"headers","","Get the headers from the response.",24,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"payload","","",24,{"i":[{"n":"self"}],"o":{"g":["pipeline"],"n":"box"}}],[11,"version","","Get the HTTP version of this response.",24,{"i":[{"n":"self"}],"o":{"n":"version"}}],[11,"status","","Get the status from the server.",24,{"i":[{"n":"self"}],"o":{"n":"statuscode"}}],[11,"cookies","","Load response cookies.",24,{"i":[{"n":"self"}],"o":{"g":["vec","cookieparseerror"],"n":"result"}}],[11,"cookie","","Return request cookie.",24,{"i":[{"n":"self"},{"n":"str"}],"o":{"g":["cookie"],"n":"option"}}],[11,"fmt","","",24,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",16,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[0,"error","actix_web","Error and Result module",null,null],[4,"UrlParseError","actix_web::error","Errors that can occur during parsing.",null,null],[13,"EmptyHost","","",25,null],[13,"IdnaError","","",25,null],[13,"InvalidPort","","",25,null],[13,"InvalidIpv4Address","","",25,null],[13,"InvalidIpv6Address","","",25,null],[13,"InvalidDomainCharacter","","",25,null],[13,"RelativeUrlWithoutBase","","",25,null],[13,"RelativeUrlWithCannotBeABaseBase","","",25,null],[13,"SetHostOnCannotBeABaseUrl","","",25,null],[13,"Overflow","","",25,null],[4,"CookieParseError","","Enum corresponding to a parsing error.",null,null],[13,"MissingPair","","The cookie did not contain a name/value pair.",26,null],[13,"EmptyName","","The cookie's name was empty.",26,null],[13,"Utf8Error","","Decoding the cookie's name or value resulted in invalid UTF-8.",26,null],[3,"Error","","General purpose actix web error.",null,null],[3,"InternalError","","Helper type that can wrap any error and generate custom response.",null,null],[4,"ParseError","","A set of errors that can occur during parsing HTTP streams",null,null],[13,"Method","","An invalid `Method`, such as `GE.T`.",27,null],[13,"Uri","","An invalid `Uri`, such as `exam ple.domain`.",27,null],[13,"Version","","An invalid `HttpVersion`, such as `HTP/1.1`",27,null],[13,"Header","","An invalid `Header`.",27,null],[13,"TooLarge","","A message head is too large to be reasonable.",27,null],[13,"Incomplete","","A message reached EOF, but is not complete.",27,null],[13,"Status","","An invalid `Status`, such as `1337 ELITE`.",27,null],[13,"Timeout","","A timeout occurred waiting for an IO event.",27,null],[13,"Io","","An `io::Error` that occurred while trying to read or write to a network stream.",27,null],[13,"Utf8","","Parsing a field as string failed",27,null],[4,"PayloadError","","A set of errors that can occur during payload parsing",null,null],[13,"Incomplete","","A payload reached EOF, but is not complete.",28,null],[13,"EncodingCorrupted","","Content encoding stream corruption",28,null],[13,"Overflow","","A payload reached size limit.",28,null],[13,"UnknownLength","","A payload length is unknown.",28,null],[13,"Io","","Io error",28,null],[13,"Http2","","Http2 error",28,null],[4,"MultipartError","","A set of errors that can occur during parsing multipart streams",null,null],[13,"NoContentType","","Content-Type header is not found",29,null],[13,"ParseContentType","","Can not parse Content-Type header",29,null],[13,"Boundary","","Multipart boundary is not found",29,null],[13,"Incomplete","","Multipart stream is incomplete",29,null],[13,"Parse","","Error during field parsing",29,null],[13,"Payload","","Payload error",29,null],[4,"ExpectError","","Error during handling `Expect` header",null,null],[13,"Encoding","","Expect header value can not be converted to utf8",30,null],[13,"UnknownExpect","","Unknown expect value",30,null],[4,"ContentTypeError","","A set of error that can occure during parsing content type",null,null],[13,"ParseError","","Can not parse content type",31,null],[13,"UnknownEncoding","","Unknown content encoding",31,null],[4,"UrlencodedError","","A set of errors that can occur during parsing urlencoded payloads",null,null],[13,"Chunked","","Can not decode chunked transfer encoding",32,null],[13,"Overflow","","Payload size is bigger than allowed. (default: 256kB)",32,null],[13,"UnknownLength","","Payload size is now known",32,null],[13,"ContentType","","Content type error",32,null],[13,"Parse","","Parse error",32,null],[13,"Payload","","Payload error",32,null],[4,"JsonPayloadError","","A set of errors that can occur during parsing json payloads",null,null],[13,"Overflow","","Payload size is bigger than allowed. (default: 256kB)",33,null],[13,"ContentType","","Content type error",33,null],[13,"Deserialize","","Deserialize error",33,null],[13,"Payload","","Payload error",33,null],[4,"ReadlinesError","","Error type returned when reading body as lines.",null,null],[13,"EncodingError","","Error when decoding a line.",34,null],[13,"PayloadError","","Payload error.",34,null],[13,"LimitOverflow","","Line limit exceeded.",34,null],[13,"ContentTypeError","","ContentType error.",34,null],[4,"UriSegmentError","","Errors which can occur when attempting to interpret a segment string as a valid path segment.",null,null],[13,"BadStart","","The segment started with the wrapped invalid character.",35,null],[13,"BadChar","","The segment contained the wrapped invalid character.",35,null],[13,"BadEnd","","The segment ended with the wrapped invalid character.",35,null],[4,"UrlGenerationError","","Errors which can occur when attempting to generate resource uri.",null,null],[13,"ResourceNotFound","","Resource not found",36,null],[13,"NotEnoughElements","","Not all path pattern covered",36,null],[13,"ParseError","","URL parse error",36,null],[4,"StaticFileError","","Errors which can occur when serving static files.",null,null],[13,"IsNotDirectory","","Path is not a directory",37,null],[13,"IsDirectory","","Cannot render directory",37,null],[5,"ErrorBadRequest","","Helper function that creates wrapper of any error and generate BAD REQUEST response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorUnauthorized","","Helper function that creates wrapper of any error and generate UNAUTHORIZED response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorForbidden","","Helper function that creates wrapper of any error and generate FORBIDDEN response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorNotFound","","Helper function that creates wrapper of any error and generate NOT FOUND response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorMethodNotAllowed","","Helper function that creates wrapper of any error and generate METHOD NOT ALLOWED response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorRequestTimeout","","Helper function that creates wrapper of any error and generate REQUEST TIMEOUT response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorConflict","","Helper function that creates wrapper of any error and generate CONFLICT response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorGone","","Helper function that creates wrapper of any error and generate GONE response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorPreconditionFailed","","Helper function that creates wrapper of any error and generate PRECONDITION FAILED response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorExpectationFailed","","Helper function that creates wrapper of any error and generate EXPECTATION FAILED response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorInternalServerError","","Helper function that creates wrapper of any error and generate INTERNAL SERVER ERROR response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorNotImplemented","","Helper function that creates wrapper of any error and generate NOT IMPLEMENTED response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorBadGateway","","Helper function that creates wrapper of any error and generate BAD GATEWAY response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorServiceUnavailable","","Helper function that creates wrapper of any error and generate SERVICE UNAVAILABLE response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[5,"ErrorGatewayTimeout","","Helper function that creates wrapper of any error and generate GATEWAY TIMEOUT response.",null,{"i":[{"n":"t"}],"o":{"n":"error"}}],[6,"Result","","A specialized `Result` for actix web operations",null,null],[8,"ResponseError","","Error that can be converted to `HttpResponse`",null,null],[11,"error_response","","Create response for error",38,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"cause","","Deprecated way to reference the underlying response error.",39,{"i":[{"n":"self"}],"o":{"n":"responseerror"}}],[11,"as_fail","","Returns a reference to the underlying cause of this `Error` as `Fail`",39,{"i":[{"n":"self"}],"o":{"n":"fail"}}],[11,"as_response_error","","Returns the reference to the underlying `ResponseError`.",39,{"i":[{"n":"self"}],"o":{"n":"responseerror"}}],[11,"backtrace","","Returns a reference to the Backtrace carried by this error, if it carries one.",39,{"i":[{"n":"self"}],"o":{"n":"backtrace"}}],[11,"downcast_ref","","Attempts to downcast this `Error` to a particular `Fail` type by reference.",39,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"fmt","","",39,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",39,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","actix_web","",10,{"i":[{"n":"error"}],"o":{"n":"self"}}],[11,"from","actix_web::error","",39,{"i":[{"n":"t"}],"o":{"n":"error"}}],[11,"from","","",39,{"i":[{"n":"error"}],"o":{"n":"error"}}],[11,"cause","","",27,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",27,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",27,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",27,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",27,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"from","","",27,{"i":[{"n":"ioerror"}],"o":{"n":"parseerror"}}],[11,"from","","",27,{"i":[{"n":"invaliduri"}],"o":{"n":"parseerror"}}],[11,"from","","",27,{"i":[{"n":"utf8error"}],"o":{"n":"parseerror"}}],[11,"from","","",27,{"i":[{"n":"fromutf8error"}],"o":{"n":"parseerror"}}],[11,"from","","",27,{"i":[{"n":"error"}],"o":{"n":"parseerror"}}],[11,"cause","","",28,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",28,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",28,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",28,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","","",28,{"i":[{"n":"ioerror"}],"o":{"n":"payloaderror"}}],[11,"error_response","","",28,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"error_response","","",26,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"cause","","",29,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",29,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",29,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",29,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","","",29,{"i":[{"n":"parseerror"}],"o":{"n":"multiparterror"}}],[11,"from","","",29,{"i":[{"n":"payloaderror"}],"o":{"n":"multiparterror"}}],[11,"error_response","","",29,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"cause","","",30,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",30,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",30,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",30,{"i":[{"n":"self"},{"n":"expecterror"}],"o":{"n":"bool"}}],[11,"fmt","","",30,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",30,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"cause","","",31,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",31,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",31,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",31,{"i":[{"n":"self"},{"n":"contenttypeerror"}],"o":{"n":"bool"}}],[11,"fmt","","",31,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",31,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"cause","","",32,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",32,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",32,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",32,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",32,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"from","","",32,{"i":[{"n":"payloaderror"}],"o":{"n":"urlencodederror"}}],[11,"cause","","",33,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",33,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",33,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",33,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",33,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"from","","",33,{"i":[{"n":"payloaderror"}],"o":{"n":"jsonpayloaderror"}}],[11,"from","","",33,{"i":[{"n":"jsonerror"}],"o":{"n":"jsonpayloaderror"}}],[11,"from","","",34,{"i":[{"n":"payloaderror"}],"o":{"n":"self"}}],[11,"from","","",34,{"i":[{"n":"contenttypeerror"}],"o":{"n":"self"}}],[11,"cause","","",35,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",35,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",35,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",35,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",35,{"i":[{"n":"self"},{"n":"urisegmenterror"}],"o":{"n":"bool"}}],[11,"ne","","",35,{"i":[{"n":"self"},{"n":"urisegmenterror"}],"o":{"n":"bool"}}],[11,"error_response","","",35,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"cause","","",36,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",36,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",36,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",36,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",36,{"i":[{"n":"self"},{"n":"urlgenerationerror"}],"o":{"n":"bool"}}],[11,"ne","","",36,{"i":[{"n":"self"},{"n":"urlgenerationerror"}],"o":{"n":"bool"}}],[11,"from","","",36,{"i":[{"n":"urlparseerror"}],"o":{"n":"self"}}],[11,"cause","","",37,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",37,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",37,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",37,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",37,{"i":[{"n":"self"},{"n":"staticfileerror"}],"o":{"n":"bool"}}],[11,"error_response","","",37,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"new","","Create `InternalError` instance",40,{"i":[{"n":"t"},{"n":"statuscode"}],"o":{"n":"self"}}],[11,"from_response","","Create `InternalError` with predefined `HttpResponse`.",40,{"i":[{"n":"t"},{"n":"httpresponse"}],"o":{"n":"self"}}],[11,"backtrace","","",40,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",40,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",40,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",40,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"respond_to","","",40,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["httpresponse","error"],"n":"result"}}],[0,"fs","actix_web","Static files support",null,null],[3,"DefaultConfig","actix_web::fs","Default content disposition as described in StaticFileConfig",null,null],[3,"NamedFile","","A file with an associated name.",null,null],[3,"ChunkedReadFile","","A helper created from a `std::fs::File` which reads the file chunk-by-chunk on a `CpuPool`.",null,null],[3,"Directory","","A directory; responds with the generated directory listing.",null,null],[12,"base","","Base directory",41,null],[12,"path","","Path of subdirectory to generate listing for",41,null],[3,"StaticFiles","","Static files handling",null,null],[5,"file_extension_to_mime","","Return the MIME type associated with a filename extension (case-insensitive). If `ext` is empty or no associated type for the extension was found, returns the type `application/octet-stream`.",null,{"i":[{"n":"str"}],"o":{"n":"mime"}}],[8,"StaticFileConfig","","Describes `StaticFiles` configiration",null,null],[11,"content_disposition_map","","Describes mapping for mime type to content disposition header",42,{"i":[{"n":"name"}],"o":{"n":"dispositiontype"}}],[11,"is_use_etag","","Describes whether Actix should attempt to calculate `ETag`",42,{"o":{"n":"bool"}}],[11,"is_use_last_modifier","","Describes whether Actix should use last modified date of file.",42,{"o":{"n":"bool"}}],[11,"is_method_allowed","","Describes allowed methods to access static resources.",42,{"i":[{"n":"method"}],"o":{"n":"bool"}}],[11,"default","","",43,{"o":{"n":"defaultconfig"}}],[11,"fmt","","",44,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"open","","Attempts to open a file in read-only mode.",44,{"i":[{"n":"p"}],"o":{"g":["namedfile"],"n":"result"}}],[11,"open_with_config","","Attempts to open a file in read-only mode using provided configiration.",44,{"i":[{"n":"p"},{"n":"c"}],"o":{"g":["namedfile"],"n":"result"}}],[11,"file","","Returns reference to the underlying `File` object.",44,{"i":[{"n":"self"}],"o":{"n":"file"}}],[11,"path","","Retrieve the path of this file.",44,{"i":[{"n":"self"}],"o":{"n":"path"}}],[11,"set_cpu_pool","","Set `CpuPool` to use",44,{"i":[{"n":"self"},{"n":"cpupool"}],"o":{"n":"self"}}],[11,"set_status_code","","Set response Status Code",44,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"self"}}],[11,"set_content_type","","Set the MIME Content-Type for serving this file. By default the Content-Type is inferred from the filename extension.",44,{"i":[{"n":"self"},{"n":"mime"}],"o":{"n":"self"}}],[11,"set_content_disposition","","Set the Content-Disposition for serving this file. This allows changing the inline/attachment disposition as well as the filename sent to the peer. By default the disposition is `inline` for text, image, and video content types, and `attachment` otherwise, and the filename is taken from the path provided in the `open` method after converting it to UTF-8 using to_string_lossy.",44,{"i":[{"n":"self"},{"n":"contentdisposition"}],"o":{"n":"self"}}],[11,"set_content_encoding","","Set content encoding for serving this file",44,{"i":[{"n":"self"},{"n":"contentencoding"}],"o":{"n":"self"}}],[11,"deref","","",44,{"i":[{"n":"self"}],"o":{"n":"file"}}],[11,"deref_mut","","",44,{"i":[{"n":"self"}],"o":{"n":"file"}}],[11,"respond_to","","",44,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["httpresponse","error"],"n":"result"}}],[11,"poll","","",45,{"i":[{"n":"self"}],"o":{"g":["option","error"],"n":"poll"}}],[11,"fmt","","",41,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"new","","Create a new directory",41,{"i":[{"n":"pathbuf"},{"n":"pathbuf"}],"o":{"n":"directory"}}],[11,"is_visible","","Is this entry visible from this directory?",41,{"i":[{"n":"self"},{"n":"result"}],"o":{"n":"bool"}}],[11,"new","","Create new `StaticFiles` instance for specified base directory.",46,{"i":[{"n":"t"}],"o":{"g":["staticfiles","error"],"n":"result"}}],[11,"with_pool","","Create new `StaticFiles` instance for specified base directory and `CpuPool`.",46,{"i":[{"n":"t"},{"n":"cpupool"}],"o":{"g":["staticfiles","error"],"n":"result"}}],[11,"with_config","","Create new `StaticFiles` instance for specified base directory.",46,{"i":[{"n":"t"},{"n":"c"}],"o":{"g":["staticfiles","error"],"n":"result"}}],[11,"with_config_pool","","Create new `StaticFiles` instance for specified base directory with config and `CpuPool`.",46,{"i":[{"n":"t"},{"n":"cpupool"},{"n":"c"}],"o":{"g":["staticfiles","error"],"n":"result"}}],[11,"show_files_listing","","Show files listing for directories.",46,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"files_listing_renderer","","Set custom directory renderer",46,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"self"}}],[11,"index_file","","Set index file",46,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"staticfiles"}}],[11,"default_handler","","Sets default handler which is used when no matched file could be found.",46,{"i":[{"n":"self"},{"n":"h"}],"o":{"n":"staticfiles"}}],[11,"handle","","",46,null],[0,"middleware","actix_web","Middlewares",null,null],[3,"DefaultHeaders","actix_web::middleware","`Middleware` for setting default response headers.",null,null],[3,"ErrorHandlers","","`Middleware` for allowing custom handlers for responses.",null,null],[3,"Logger","","`Middleware` for logging request and response info to the terminal.",null,null],[4,"Started","","Middleware start result",null,null],[13,"Done","","Middleware is completed, continue to next middleware",47,null],[13,"Response","","New http response got generated. If middleware generates response handler execution halts.",47,null],[13,"Future","","Execution completed, runs future to completion.",47,null],[4,"Response","","Middleware execution result",null,null],[13,"Done","","New http response got generated",48,null],[13,"Future","","Result is a future that resolves to a new http response",48,null],[4,"Finished","","Middleware finish result",null,null],[13,"Done","","Execution completed",49,null],[13,"Future","","Execution completed, but run future to completion",49,null],[11,"new","","Create `Logger` middleware with the specified `format`.",50,{"i":[{"n":"str"}],"o":{"n":"logger"}}],[11,"exclude","","Ignore and do not log access info for specified path.",50,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"self"}}],[11,"default","","Create `Logger` middleware with format:",50,{"o":{"n":"logger"}}],[11,"start","","",50,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["started"],"n":"result"}}],[11,"finish","","",50,{"i":[{"n":"self"},{"n":"httprequest"},{"n":"httpresponse"}],"o":{"n":"finished"}}],[0,"cors","","Cross-origin resource sharing (CORS) for Actix applications",null,null],[3,"Cors","actix_web::middleware::cors","`Middleware` for Cross-origin resource sharing support",null,null],[3,"CorsBuilder","","Structure that follows the builder pattern for building `Cors` middleware structs.",null,null],[4,"CorsError","","A set of errors that can occur during processing CORS",null,null],[13,"MissingOrigin","","The HTTP request header `Origin` is required but was not provided",51,null],[13,"BadOrigin","","The HTTP request header `Origin` could not be parsed correctly.",51,null],[13,"MissingRequestMethod","","The request header `Access-Control-Request-Method` is required but is missing",51,null],[13,"BadRequestMethod","","The request header `Access-Control-Request-Method` has an invalid value",51,null],[13,"BadRequestHeaders","","The request header `Access-Control-Request-Headers`  has an invalid value",51,null],[13,"MissingRequestHeaders","","The request header `Access-Control-Request-Headers`  is required but is missing.",51,null],[13,"OriginNotAllowed","","Origin is not allowed to make this request",51,null],[13,"MethodNotAllowed","","Requested method is not allowed",51,null],[13,"HeadersNotAllowed","","One or more headers requested are not allowed",51,null],[4,"AllOrSome","","An enum signifying that some of type T is allowed, or `All` (everything is allowed).",null,null],[13,"All","","Everything is allowed. Usually equivalent to the \"*\" value.",52,null],[13,"Some","","Only some of `T` is allowed",52,null],[11,"fmt","","",51,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"cause","","",51,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",51,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",51,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",51,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"clone","","",52,{"i":[{"n":"self"}],"o":{"n":"allorsome"}}],[11,"fmt","","",52,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",52,{"i":[{"n":"self"},{"n":"allorsome"}],"o":{"n":"bool"}}],[11,"ne","","",52,{"i":[{"n":"self"},{"n":"allorsome"}],"o":{"n":"bool"}}],[11,"default","","",52,{"o":{"n":"self"}}],[11,"is_all","","Returns whether this is an `All` variant",52,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"is_some","","Returns whether this is a `Some` variant",52,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"as_ref","","Returns &T",52,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"clone","","",53,{"i":[{"n":"self"}],"o":{"n":"cors"}}],[11,"default","","",53,{"o":{"n":"cors"}}],[11,"build","","Build a new CORS middleware instance",53,{"o":{"n":"corsbuilder"}}],[11,"for_app","","Create CorsBuilder for a specified application.",53,{"i":[{"n":"app"}],"o":{"n":"corsbuilder"}}],[11,"register","","This method register cors middleware with resource and adds route for OPTIONS preflight requests.",53,{"i":[{"n":"self"},{"n":"resource"}]}],[11,"start","","",53,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["started"],"n":"result"}}],[11,"response","","",53,{"i":[{"n":"self"},{"n":"httprequest"},{"n":"httpresponse"}],"o":{"g":["response"],"n":"result"}}],[11,"allowed_origin","","Add an origin that are allowed to make requests. Will be verified against the `Origin` request header.",54,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"corsbuilder"}}],[11,"allowed_methods","","Set a list of methods which the allowed origins are allowed to access for requests.",54,{"i":[{"n":"self"},{"n":"u"}],"o":{"n":"corsbuilder"}}],[11,"allowed_header","","Set an allowed header",54,{"i":[{"n":"self"},{"n":"h"}],"o":{"n":"corsbuilder"}}],[11,"allowed_headers","","Set a list of header field names which can be used when this resource is accessed by allowed origins.",54,{"i":[{"n":"self"},{"n":"u"}],"o":{"n":"corsbuilder"}}],[11,"expose_headers","","Set a list of headers which are safe to expose to the API of a CORS API specification. This corresponds to the `Access-Control-Expose-Headers` response header.",54,{"i":[{"n":"self"},{"n":"u"}],"o":{"n":"corsbuilder"}}],[11,"max_age","","Set a maximum time for which this CORS request maybe cached. This value is set as the `Access-Control-Max-Age` header.",54,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"corsbuilder"}}],[11,"send_wildcard","","Set a wildcard origins",54,{"i":[{"n":"self"}],"o":{"n":"corsbuilder"}}],[11,"supports_credentials","","Allows users to make authenticated requests",54,{"i":[{"n":"self"}],"o":{"n":"corsbuilder"}}],[11,"disable_vary_header","","Disable `Vary` header support.",54,{"i":[{"n":"self"}],"o":{"n":"corsbuilder"}}],[11,"disable_preflight","","Disable preflight request support.",54,{"i":[{"n":"self"}],"o":{"n":"corsbuilder"}}],[11,"resource","","Configure resource for a specific path.",54,{"i":[{"n":"self"},{"n":"str"},{"n":"f"}],"o":{"n":"corsbuilder"}}],[11,"finish","","Finishes building and returns the built `Cors` instance.",54,{"i":[{"n":"self"}],"o":{"n":"cors"}}],[11,"register","","Finishes building Cors middleware and register middleware for application",54,{"i":[{"n":"self"}],"o":{"n":"app"}}],[0,"csrf","actix_web::middleware","A filter for cross-site request forgery (CSRF).",null,null],[3,"CsrfFilter","actix_web::middleware::csrf","A middleware that filters cross-site requests.",null,null],[4,"CsrfError","","Potential cross-site request forgery detected.",null,null],[13,"MissingOrigin","","The HTTP request header `Origin` was required but not provided.",55,null],[13,"BadOrigin","","The HTTP request header `Origin` could not be parsed correctly.",55,null],[13,"CsrDenied","","The cross-site request was denied.",55,null],[11,"fmt","","",55,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"cause","","",55,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",55,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",55,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",55,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"default","","",56,{"o":{"n":"csrffilter"}}],[11,"new","","Start building a `CsrfFilter`.",56,{"o":{"n":"csrffilter"}}],[11,"allowed_origin","","Add an origin that is allowed to make requests. Will be verified against the `Origin` request header.",56,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"csrffilter"}}],[11,"allow_xhr","","Allow all requests with an `X-Requested-With` header.",56,{"i":[{"n":"self"}],"o":{"n":"csrffilter"}}],[11,"allow_missing_origin","","Allow requests if the expected `Origin` header is missing (and there is no `Referer` to fall back on).",56,{"i":[{"n":"self"}],"o":{"n":"csrffilter"}}],[11,"allow_upgrade","","Allow cross-site upgrade requests (for example to open a WebSocket).",56,{"i":[{"n":"self"}],"o":{"n":"csrffilter"}}],[11,"start","","",56,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["started"],"n":"result"}}],[11,"default","actix_web::middleware","",57,{"o":{"n":"self"}}],[11,"new","","Construct `DefaultHeaders` middleware.",57,{"o":{"n":"defaultheaders"}}],[11,"header","","Set a header.",57,{"i":[{"n":"self"},{"n":"k"},{"n":"v"}],"o":{"n":"self"}}],[11,"content_type","","Set CONTENT-TYPE header if response does not contain this header.",57,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"response","","",57,{"i":[{"n":"self"},{"n":"httprequest"},{"n":"httpresponse"}],"o":{"g":["response"],"n":"result"}}],[11,"default","","",58,{"o":{"n":"self"}}],[11,"new","","Construct new `ErrorHandlers` instance",58,{"o":{"n":"self"}}],[11,"handler","","Register error handler for specified status code",58,{"i":[{"n":"self"},{"n":"statuscode"},{"n":"f"}],"o":{"n":"self"}}],[11,"response","","",58,{"i":[{"n":"self"},{"n":"httprequest"},{"n":"httpresponse"}],"o":{"g":["response"],"n":"result"}}],[0,"identity","","Request identity service for Actix applications.",null,null],[3,"IdentityService","actix_web::middleware::identity","Request identity middleware",null,null],[3,"CookieIdentityPolicy","","Use cookies for request identity storage.",null,null],[8,"RequestIdentity","","The helper trait to obtain your identity from a request.",null,null],[10,"identity","","Return the claimed identity of the user associated request or `None` if no identity can be found associated with the request.",59,{"i":[{"n":"self"}],"o":{"g":["string"],"n":"option"}}],[10,"remember","","Remember identity.",59,{"i":[{"n":"self"},{"n":"string"}]}],[10,"forget","","This method is used to 'forget' the current identity on subsequent requests.",59,{"i":[{"n":"self"}]}],[8,"Identity","","An identity",null,null],[10,"identity","","Return the claimed identity of the user associated request or `None` if no identity can be found associated with the request.",60,{"i":[{"n":"self"}],"o":{"g":["str"],"n":"option"}}],[10,"remember","","Remember identity.",60,{"i":[{"n":"self"},{"n":"string"}]}],[10,"forget","","This method is used to 'forget' the current identity on subsequent requests.",60,{"i":[{"n":"self"}]}],[10,"write","","Write session to storage backend.",60,{"i":[{"n":"self"},{"n":"httpresponse"}],"o":{"g":["response"],"n":"result"}}],[8,"IdentityPolicy","","Identity policy definition.",null,null],[16,"Identity","","The associated identity",61,null],[16,"Future","","The return type of the middleware",61,null],[10,"from_request","","Parse the session from request and load data from a service identity.",61,null],[11,"identity","actix_web","",12,{"i":[{"n":"self"}],"o":{"g":["string"],"n":"option"}}],[11,"remember","","",12,{"i":[{"n":"self"},{"n":"string"}]}],[11,"forget","","",12,{"i":[{"n":"self"}]}],[11,"new","actix_web::middleware::identity","Create new identity service with specified backend.",62,{"i":[{"n":"t"}],"o":{"n":"self"}}],[11,"start","","",62,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["started"],"n":"result"}}],[11,"response","","",62,{"i":[{"n":"self"},{"n":"httprequest"},{"n":"httpresponse"}],"o":{"g":["response"],"n":"result"}}],[11,"new","","Construct new `CookieIdentityPolicy` instance.",63,null],[11,"path","","Sets the `path` field in the session cookie being built.",63,{"i":[{"n":"self"},{"n":"s"}],"o":{"n":"cookieidentitypolicy"}}],[11,"name","","Sets the `name` field in the session cookie being built.",63,{"i":[{"n":"self"},{"n":"s"}],"o":{"n":"cookieidentitypolicy"}}],[11,"domain","","Sets the `domain` field in the session cookie being built.",63,{"i":[{"n":"self"},{"n":"s"}],"o":{"n":"cookieidentitypolicy"}}],[11,"secure","","Sets the `secure` field in the session cookie being built.",63,{"i":[{"n":"self"},{"n":"bool"}],"o":{"n":"cookieidentitypolicy"}}],[11,"max_age","","Sets the `max-age` field in the session cookie being built.",63,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"cookieidentitypolicy"}}],[11,"from_request","","",63,null],[0,"session","actix_web::middleware","User sessions.",null,null],[3,"Session","actix_web::middleware::session","The high-level interface you use to modify session data.",null,null],[3,"SessionStorage","","Session storage middleware",null,null],[3,"CookieSession","","Session that uses signed cookies as session storage",null,null],[3,"CookieSessionBackend","","Use cookies for session storage.",null,null],[4,"CookieSessionError","","Errors that can occur during handling cookie session",null,null],[13,"Overflow","","Size of the serialized session is greater than 4000 bytes.",64,null],[13,"Serialize","","Fail to serialize session.",64,null],[8,"RequestSession","","The helper trait to obtain your session data from a request.",null,null],[10,"session","","Get the session from the request",65,{"i":[{"n":"self"}],"o":{"n":"session"}}],[11,"session","actix_web","",12,{"i":[{"n":"self"}],"o":{"n":"session"}}],[11,"get","actix_web::middleware::session","Get a `value` from the session.",66,{"i":[{"n":"self"},{"n":"str"}],"o":{"g":["option"],"n":"result"}}],[11,"set","","Set a `value` from the session.",66,{"i":[{"n":"self"},{"n":"str"},{"n":"t"}],"o":{"n":"result"}}],[11,"remove","","Remove value from the session.",66,{"i":[{"n":"self"},{"n":"str"}]}],[11,"clear","","Clear the session.",66,{"i":[{"n":"self"}]}],[11,"from_request","","",66,null],[11,"new","","Create session storage",67,{"i":[{"n":"t"}],"o":{"n":"sessionstorage"}}],[11,"start","","",67,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["started"],"n":"result"}}],[11,"response","","",67,{"i":[{"n":"self"},{"n":"httprequest"},{"n":"httpresponse"}],"o":{"g":["response"],"n":"result"}}],[11,"cause","","",64,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",64,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",64,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",64,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"signed","","Construct new signed `CookieSessionBackend` instance.",68,null],[11,"private","","Construct new private `CookieSessionBackend` instance.",68,null],[11,"path","","Sets the `path` field in the session cookie being built.",68,{"i":[{"n":"self"},{"n":"s"}],"o":{"n":"cookiesessionbackend"}}],[11,"name","","Sets the `name` field in the session cookie being built.",68,{"i":[{"n":"self"},{"n":"s"}],"o":{"n":"cookiesessionbackend"}}],[11,"domain","","Sets the `domain` field in the session cookie being built.",68,{"i":[{"n":"self"},{"n":"s"}],"o":{"n":"cookiesessionbackend"}}],[11,"secure","","Sets the `secure` field in the session cookie being built.",68,{"i":[{"n":"self"},{"n":"bool"}],"o":{"n":"cookiesessionbackend"}}],[11,"same_site","","Sets the `same_site` field in the session cookie being built.",68,{"i":[{"n":"self"},{"n":"samesite"}],"o":{"n":"cookiesessionbackend"}}],[11,"max_age","","Sets the `max-age` field in the session cookie being built.",68,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"cookiesessionbackend"}}],[8,"Middleware","actix_web::middleware","Middleware definition",null,null],[11,"start","","Method is called when request is ready. It may return future, which should resolve before next middleware get called.",69,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["started"],"n":"result"}}],[11,"response","","Method is called when handler returns response, but before sending http message to peer.",69,{"i":[{"n":"self"},{"n":"httprequest"},{"n":"httpresponse"}],"o":{"g":["response"],"n":"result"}}],[11,"finish","","Method is called after body stream get sent to peer.",69,{"i":[{"n":"self"},{"n":"httprequest"},{"n":"httpresponse"}],"o":{"n":"finished"}}],[0,"multipart","actix_web","Multipart requests support",null,null],[3,"Multipart","actix_web::multipart","The server-side implementation of `multipart/form-data` requests.",null,null],[3,"Field","","A single field in a multipart stream",null,null],[4,"MultipartItem","","",null,null],[13,"Field","","Multipart field",70,null],[13,"Nested","","Nested multipart stream",70,null],[11,"boundary","","Extract boundary info from headers.",71,{"i":[{"n":"headermap"}],"o":{"g":["string","multiparterror"],"n":"result"}}],[11,"new","","Create multipart instance for boundary.",71,{"i":[{"g":["string","multiparterror"],"n":"result"},{"n":"s"}],"o":{"n":"multipart"}}],[11,"poll","","",71,{"i":[{"n":"self"}],"o":{"g":["option"],"n":"poll"}}],[11,"headers","","Get a map of headers",72,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"content_type","","Get the content type of the field",72,{"i":[{"n":"self"}],"o":{"n":"mime"}}],[11,"content_disposition","","Get the content disposition of the field, if it exists",72,{"i":[{"n":"self"}],"o":{"g":["contentdisposition"],"n":"option"}}],[11,"poll","","",72,{"i":[{"n":"self"}],"o":{"g":["option"],"n":"poll"}}],[11,"fmt","","",72,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[0,"pred","actix_web","Route match predicates",null,null],[3,"AnyPredicate","actix_web::pred","Matches if any of supplied predicate matches.",null,null],[3,"AllPredicate","","Matches if all of supplied predicate matches.",null,null],[5,"Any","","Return predicate that matches if any of supplied predicate matches.",null,{"i":[{"n":"p"}],"o":{"n":"anypredicate"}}],[5,"All","","Return predicate that matches if all of supplied predicate matches.",null,{"i":[{"n":"p"}],"o":{"n":"allpredicate"}}],[5,"Not","","Return predicate that matches if supplied predicate does not match.",null,{"i":[{"n":"p"}],"o":{"n":"notpredicate"}}],[5,"Get","","Predicate to match GET http method",null,{"o":{"n":"methodpredicate"}}],[5,"Post","","Predicate to match POST http method",null,{"o":{"n":"methodpredicate"}}],[5,"Put","","Predicate to match PUT http method",null,{"o":{"n":"methodpredicate"}}],[5,"Delete","","Predicate to match DELETE http method",null,{"o":{"n":"methodpredicate"}}],[5,"Head","","Predicate to match HEAD http method",null,{"o":{"n":"methodpredicate"}}],[5,"Options","","Predicate to match OPTIONS http method",null,{"o":{"n":"methodpredicate"}}],[5,"Connect","","Predicate to match CONNECT http method",null,{"o":{"n":"methodpredicate"}}],[5,"Patch","","Predicate to match PATCH http method",null,{"o":{"n":"methodpredicate"}}],[5,"Trace","","Predicate to match TRACE http method",null,{"o":{"n":"methodpredicate"}}],[5,"Method","","Predicate to match specified http method",null,{"i":[{"n":"method"}],"o":{"n":"methodpredicate"}}],[5,"Header","","Return predicate that matches if request contains specified header and value.",null,{"i":[{"n":"str"},{"n":"str"}],"o":{"n":"headerpredicate"}}],[5,"Host","","Return predicate that matches if request contains specified Host name.",null,{"i":[{"n":"h"}],"o":{"n":"hostpredicate"}}],[8,"Predicate","","Trait defines resource route predicate. Predicate can modify request object. It is also possible to to store extra attributes on request by using `Extensions` container, Extensions container available via `HttpRequest::extensions()` method.",null,null],[10,"check","","Check if request matches predicate",73,{"i":[{"n":"self"},{"n":"request"},{"n":"s"}],"o":{"n":"bool"}}],[11,"or","","Add new predicate to list of predicates to check",74,{"i":[{"n":"self"},{"n":"p"}],"o":{"n":"self"}}],[11,"check","","",74,{"i":[{"n":"self"},{"n":"request"},{"n":"s"}],"o":{"n":"bool"}}],[11,"and","","Add new predicate to list of predicates to check",75,{"i":[{"n":"self"},{"n":"p"}],"o":{"n":"self"}}],[11,"check","","",75,{"i":[{"n":"self"},{"n":"request"},{"n":"s"}],"o":{"n":"bool"}}],[0,"server","actix_web","Http server",null,null],[3,"Request","actix_web::server","Request's context",null,null],[3,"ServerSettings","","Various server settings",null,null],[3,"HttpServer","","An HTTP Server",null,null],[3,"PauseServer","","Pause accepting incoming connections",null,null],[3,"ResumeServer","","Resume accepting incoming connections",null,null],[3,"StopServer","","Stop incoming connection processing, stop all workers and exit.",null,null],[12,"graceful","","Whether to try and shut down gracefully",76,null],[4,"KeepAlive","","Server keep-alive setting",null,null],[13,"Timeout","","Keep alive in seconds",77,null],[13,"Tcp","","Use `SO_KEEPALIVE` socket option, value in seconds",77,null],[13,"Os","","Relay on OS to shutdown tcp connection",77,null],[13,"Disabled","","Disabled",77,null],[5,"new","","Create new http server with application factory.",null,{"i":[{"n":"f"}],"o":{"n":"httpserver"}}],[11,"headers","actix_web","",78,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"payload","","",78,{"i":[{"n":"self"}],"o":{"n":"payload"}}],[11,"uri","","Read the Request Uri.",78,{"i":[{"n":"self"}],"o":{"n":"uri"}}],[11,"method","","Read the Request method.",78,{"i":[{"n":"self"}],"o":{"n":"method"}}],[11,"version","","Read the Request Version.",78,{"i":[{"n":"self"}],"o":{"n":"version"}}],[11,"path","","The target path of this Request.",78,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"headers","","Returns Request's headers.",78,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"headers_mut","","Returns mutable Request's headers.",78,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"peer_addr","","Peer socket address",78,{"i":[{"n":"self"}],"o":{"g":["socketaddr"],"n":"option"}}],[11,"keep_alive","","Checks if a connection should be kept alive.",78,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"extensions","","Request extensions",78,{"i":[{"n":"self"}],"o":{"g":["extensions"],"n":"ref"}}],[11,"extensions_mut","","Mutable reference to a the request's extensions",78,{"i":[{"n":"self"}],"o":{"g":["extensions"],"n":"refmut"}}],[11,"upgrade","","Check if request requires connection upgrade",78,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"connection_info","","Get ConnectionInfo for the correct request.",78,{"i":[{"n":"self"}],"o":{"g":["connectioninfo"],"n":"ref"}}],[11,"server_settings","","Server settings",78,{"i":[{"n":"self"}],"o":{"n":"serversettings"}}],[11,"clone","actix_web::server","",79,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"default","","",79,{"o":{"n":"self"}}],[11,"local_addr","","Returns the socket address of the local half of this TCP connection",79,{"i":[{"n":"self"}],"o":{"g":["socketaddr"],"n":"option"}}],[11,"secure","","Returns true if connection is secure(https)",79,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"host","","Returns host header value",79,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"cpu_pool","","Returns default `CpuPool` for server",79,{"i":[{"n":"self"}],"o":{"n":"cpupool"}}],[11,"new","","Create new http server with application factory",80,{"i":[{"n":"f"}],"o":{"n":"self"}}],[11,"workers","","Set number of workers to start.",80,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"backlog","","Set the maximum number of pending connections.",80,{"i":[{"n":"self"},{"n":"i32"}],"o":{"n":"self"}}],[11,"keep_alive","","Set server keep-alive setting.",80,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"self"}}],[11,"server_hostname","","Set server host name.",80,{"i":[{"n":"self"},{"n":"string"}],"o":{"n":"self"}}],[11,"system_exit","","Stop actix system.",80,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"signals","","Set alternative address for `ProcessSignals` actor.",80,{"i":[{"n":"self"},{"g":["processsignals"],"n":"addr"}],"o":{"n":"self"}}],[11,"disable_signals","","Disable signal handling",80,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"shutdown_timeout","","Timeout for graceful workers shutdown.",80,{"i":[{"n":"self"},{"n":"u16"}],"o":{"n":"self"}}],[11,"no_http2","","Disable `HTTP/2` support",80,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"addrs","","Get addresses of bound sockets.",80,{"i":[{"n":"self"}],"o":{"g":["socketaddr"],"n":"vec"}}],[11,"addrs_with_scheme","","Get addresses of bound sockets and the scheme for it.",80,{"i":[{"n":"self"}],"o":{"n":"vec"}}],[11,"listen","","Use listener for accepting incoming connection requests",80,{"i":[{"n":"self"},{"n":"tcplistener"}],"o":{"n":"self"}}],[11,"listen_tls","","Use listener for accepting incoming tls connection requests",80,{"i":[{"n":"self"},{"n":"tcplistener"},{"n":"tlsacceptor"}],"o":{"n":"self"}}],[11,"listen_ssl","","Use listener for accepting incoming tls connection requests",80,{"i":[{"n":"self"},{"n":"tcplistener"},{"n":"sslacceptorbuilder"}],"o":{"n":"result"}}],[11,"bind","","The socket address to bind",80,{"i":[{"n":"self"},{"n":"s"}],"o":{"n":"result"}}],[11,"bind_tls","","The ssl socket address to bind",80,{"i":[{"n":"self"},{"n":"s"},{"n":"tlsacceptor"}],"o":{"n":"result"}}],[11,"bind_ssl","","Start listening for incoming tls connections.",80,{"i":[{"n":"self"},{"n":"s"},{"n":"sslacceptorbuilder"}],"o":{"n":"result"}}],[11,"start","","Start listening for incoming connections.",80,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"run","","Spawn new thread and start listening for incoming connections.",80,{"i":[{"n":"self"}]}],[11,"start_incoming","","Start listening for incoming connections from a stream.",80,{"i":[{"n":"self"},{"n":"s"},{"n":"bool"}],"o":{"n":"addr"}}],[11,"handle","","",80,{"i":[{"n":"self"},{"n":"signal"},{"n":"context"}]}],[11,"handle","","",80,{"i":[{"n":"self"},{"n":"pauseserver"},{"n":"context"}]}],[11,"handle","","",80,{"i":[{"n":"self"},{"n":"resumeserver"},{"n":"context"}]}],[11,"handle","","",80,null],[8,"HttpHandler","","Low level http request handler",null,null],[16,"Task","","Request handling task",81,null],[10,"handle","","Handle request",81,{"i":[{"n":"self"},{"n":"request"}],"o":{"g":["request"],"n":"result"}}],[8,"HttpHandlerTask","","Low level http request handler",null,null],[11,"poll_completed","","Poll task, this method is used before or after io object is available",82,{"i":[{"n":"self"}],"o":{"g":["error"],"n":"poll"}}],[10,"poll_io","","Poll task when io object is available",82,{"i":[{"n":"self"},{"n":"writer"}],"o":{"g":["bool","error"],"n":"poll"}}],[11,"disconnected","","Connection is disconnected",82,{"i":[{"n":"self"}]}],[8,"IntoHttpHandler","","Conversion helper trait",null,null],[16,"Handler","","The associated type which is result of conversion.",83,null],[10,"into_handler","","Convert into `HttpHandler` object.",83,null],[11,"fmt","","",77,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",77,{"i":[{"n":"self"},{"n":"keepalive"}],"o":{"n":"bool"}}],[11,"ne","","",77,{"i":[{"n":"self"},{"n":"keepalive"}],"o":{"n":"bool"}}],[11,"clone","","",77,{"i":[{"n":"self"}],"o":{"n":"keepalive"}}],[11,"from","","",77,{"i":[{"n":"usize"}],"o":{"n":"self"}}],[11,"from","","",77,{"i":[{"g":["usize"],"n":"option"}],"o":{"n":"self"}}],[0,"test","actix_web","Various helpers for Actix applications to use during testing.",null,null],[3,"TestServer","actix_web::test","The `TestServer` type.",null,null],[3,"TestServerBuilder","","An `TestServer` builder",null,null],[3,"TestApp","","Test application helper for testing request handlers.",null,null],[3,"TestRequest","","Test `HttpRequest` builder",null,null],[11,"new","","Start new test server",84,{"i":[{"n":"f"}],"o":{"n":"self"}}],[11,"build","","Create test server builder",84,{"o":{"n":"testserverbuilder"}}],[11,"build_with_state","","Create test server builder with specific state factory",84,{"i":[{"n":"f"}],"o":{"n":"testserverbuilder"}}],[11,"with_factory","","Start new test server with application factory",84,{"i":[{"n":"f"}],"o":{"n":"self"}}],[11,"unused_addr","","Get firat available unused address",84,{"o":{"n":"socketaddr"}}],[11,"addr","","Construct test server url",84,{"i":[{"n":"self"}],"o":{"n":"socketaddr"}}],[11,"url","","Construct test server url",84,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"string"}}],[11,"execute","","Execute future on current core",84,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"result"}}],[11,"ws","","Connect to websocket server",84,{"i":[{"n":"self"}],"o":{"g":["clienterror"],"n":"result"}}],[11,"get","","Create `GET` request",84,{"i":[{"n":"self"}],"o":{"n":"clientrequestbuilder"}}],[11,"post","","Create `POST` request",84,{"i":[{"n":"self"}],"o":{"n":"clientrequestbuilder"}}],[11,"head","","Create `HEAD` request",84,{"i":[{"n":"self"}],"o":{"n":"clientrequestbuilder"}}],[11,"client","","Connect to test http server",84,{"i":[{"n":"self"},{"n":"method"},{"n":"str"}],"o":{"n":"clientrequestbuilder"}}],[11,"drop","","",84,{"i":[{"n":"self"}]}],[11,"new","","Create a new test server",85,{"i":[{"n":"f"}],"o":{"n":"testserverbuilder"}}],[11,"ssl","","Create ssl server",85,{"i":[{"n":"self"},{"n":"sslacceptorbuilder"}],"o":{"n":"self"}}],[11,"start","","Configure test application and run test server",85,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"testserver"}}],[11,"handler","","Register handler for \"/\"",86,{"i":[{"n":"self"},{"n":"f"}]}],[11,"middleware","","Register middleware",86,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"testapp"}}],[11,"resource","","Register resource. This method is similar to `App::resource()` method.",86,{"i":[{"n":"self"},{"n":"str"},{"n":"f"}],"o":{"n":"testapp"}}],[11,"into_handler","","",86,{"i":[{"n":"self"}],"o":{"n":"httpapplication"}}],[11,"default","","",87,{"o":{"n":"testrequest"}}],[11,"with_uri","","Create TestRequest and set request uri",87,{"i":[{"n":"str"}],"o":{"n":"testrequest"}}],[11,"with_hdr","","Create TestRequest and set header",87,{"i":[{"n":"h"}],"o":{"n":"testrequest"}}],[11,"with_header","","Create TestRequest and set header",87,{"i":[{"n":"k"},{"n":"v"}],"o":{"n":"testrequest"}}],[11,"with_state","","Start HttpRequest build process with application state",87,{"i":[{"n":"s"}],"o":{"n":"testrequest"}}],[11,"version","","Set HTTP version of this request",87,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"self"}}],[11,"method","","Set HTTP method of this request",87,{"i":[{"n":"self"},{"n":"method"}],"o":{"n":"self"}}],[11,"uri","","Set HTTP Uri of this request",87,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"self"}}],[11,"set","","Set a header",87,{"i":[{"n":"self"},{"n":"h"}],"o":{"n":"self"}}],[11,"header","","Set a header",87,{"i":[{"n":"self"},{"n":"k"},{"n":"v"}],"o":{"n":"self"}}],[11,"param","","Set request path pattern parameter",87,{"i":[{"n":"self"},{"n":"str"},{"n":"str"}],"o":{"n":"self"}}],[11,"set_payload","","Set request payload",87,{"i":[{"n":"self"},{"n":"b"}],"o":{"n":"self"}}],[11,"prefix","","Set request's prefix",87,{"i":[{"n":"self"},{"n":"u16"}],"o":{"n":"self"}}],[11,"finish","","Complete request creation and generate `HttpRequest` instance",87,{"i":[{"n":"self"}],"o":{"n":"httprequest"}}],[11,"request","","Complete request creation and generate server `Request` instance",87,{"i":[{"n":"self"}],"o":{"n":"request"}}],[11,"run","","This method generates `HttpRequest` instance and runs handler with generated request.",87,{"i":[{"n":"self"},{"n":"h"}],"o":{"g":["httpresponse","error"],"n":"result"}}],[11,"run_async","","This method generates `HttpRequest` instance and runs handler with generated request.",87,{"i":[{"n":"self"},{"n":"h"}],"o":{"g":["httpresponse"],"n":"result"}}],[0,"ws","actix_web","`WebSocket` support for Actix",null,null],[3,"Client","actix_web::ws","`WebSocket` client",null,null],[3,"ClientHandshake","","Future that implementes client websocket handshake process.",null,null],[3,"ClientReader","","Websocket reader client",null,null],[3,"ClientWriter","","Websocket writer client",null,null],[3,"WebsocketContext","","Execution context for `WebSockets` actors",null,null],[3,"Frame","","A struct representing a `WebSocket` frame.",null,null],[3,"FramedMessage","","`WebSocket` message with framing.",null,null],[3,"CloseReason","","Reason for closing the connection",null,null],[12,"code","","Exit code",88,null],[12,"description","","Optional description of the exit code",88,null],[3,"WsStream","","Maps `Payload` stream into stream of `ws::Message` items",null,null],[4,"ClientError","","Websocket client error",null,null],[13,"InvalidUrl","","Invalid url",89,null],[13,"InvalidResponseStatus","","Invalid response status",89,null],[13,"InvalidUpgradeHeader","","Invalid upgrade header",89,null],[13,"InvalidConnectionHeader","","Invalid connection header",89,null],[13,"MissingConnectionHeader","","Missing CONNECTION header",89,null],[13,"MissingWebSocketAcceptHeader","","Missing SEC-WEBSOCKET-ACCEPT header",89,null],[13,"InvalidChallengeResponse","","Invalid challenge response",89,null],[13,"Http","","Http parsing error",89,null],[13,"Url","","Url parsing error",89,null],[13,"ResponseParseError","","Response parsing error",89,null],[13,"SendRequest","","Send request error",89,null],[13,"Protocol","","Protocol error",89,null],[13,"Io","","IO Error",89,null],[13,"Disconnected","","\"Disconnected\"",89,null],[4,"CloseCode","","Status code used to indicate why an endpoint is closing the `WebSocket` connection.",null,null],[13,"Normal","","Indicates a normal closure, meaning that the purpose for which the connection was established has been fulfilled.",90,null],[13,"Away","","Indicates that an endpoint is \"going away\", such as a server going down or a browser having navigated away from a page.",90,null],[13,"Protocol","","Indicates that an endpoint is terminating the connection due to a protocol error.",90,null],[13,"Unsupported","","Indicates that an endpoint is terminating the connection because it has received a type of data it cannot accept (e.g., an endpoint that understands only text data MAY send this if it receives a binary message).",90,null],[13,"Abnormal","","Indicates an abnormal closure. If the abnormal closure was due to an error, this close code will not be used. Instead, the `on_error` method of the handler will be called with the error. However, if the connection is simply dropped, without an error, this close code will be sent to the handler.",90,null],[13,"Invalid","","Indicates that an endpoint is terminating the connection because it has received data within a message that was not consistent with the type of the message (e.g., non-UTF-8 [RFC3629] data within a text message).",90,null],[13,"Policy","","Indicates that an endpoint is terminating the connection because it has received a message that violates its policy.  This is a generic status code that can be returned when there is no other more suitable status code (e.g., Unsupported or Size) or if there is a need to hide specific details about the policy.",90,null],[13,"Size","","Indicates that an endpoint is terminating the connection because it has received a message that is too big for it to process.",90,null],[13,"Extension","","Indicates that an endpoint (client) is terminating the connection because it has expected the server to negotiate one or more extension, but the server didn't return them in the response message of the WebSocket handshake.  The list of extensions that are needed should be given as the reason for closing. Note that this status code is not used by the server, because it can fail the WebSocket handshake instead.",90,null],[13,"Error","","Indicates that a server is terminating the connection because it encountered an unexpected condition that prevented it from fulfilling the request.",90,null],[13,"Restart","","Indicates that the server is restarting. A client may choose to reconnect, and if it does, it should use a randomized delay of 5-30 seconds between attempts.",90,null],[13,"Again","","Indicates that the server is overloaded and the client should either connect to a different IP (when multiple targets exist), or reconnect to the same IP when a user has performed an action.",90,null],[4,"OpCode","","Operation codes as part of rfc6455.",null,null],[13,"Continue","","Indicates a continuation frame of a fragmented message.",91,null],[13,"Text","","Indicates a text data frame.",91,null],[13,"Binary","","Indicates a binary data frame.",91,null],[13,"Close","","Indicates a close control frame.",91,null],[13,"Ping","","Indicates a ping control frame.",91,null],[13,"Pong","","Indicates a pong control frame.",91,null],[13,"Bad","","Indicates an invalid opcode was received.",91,null],[4,"ProtocolError","","Websocket protocol errors",null,null],[13,"UnmaskedFrame","","Received an unmasked frame from client",92,null],[13,"MaskedFrame","","Received a masked frame from server",92,null],[13,"InvalidOpcode","","Encountered invalid opcode",92,null],[13,"InvalidLength","","Invalid control frame length",92,null],[13,"BadOpCode","","Bad web socket op code",92,null],[13,"Overflow","","A payload reached size limit.",92,null],[13,"NoContinuation","","Continuation is not supported",92,null],[13,"BadEncoding","","Bad utf-8 encoding",92,null],[13,"Payload","","Payload error",92,null],[4,"HandshakeError","","Websocket handshake errors",null,null],[13,"GetMethodRequired","","Only get method is allowed",93,null],[13,"NoWebsocketUpgrade","","Upgrade header if not set to websocket",93,null],[13,"NoConnectionUpgrade","","Connection header is not set to upgrade",93,null],[13,"NoVersionHeader","","Websocket version header is not set",93,null],[13,"UnsupportedVersion","","Unsupported websocket version",93,null],[13,"BadWebsocketKey","","Websocket key is not set or wrong",93,null],[4,"Message","","`WebSocket` Message",null,null],[13,"Text","","Text message",94,null],[13,"Binary","","Binary message",94,null],[13,"Ping","","Ping message",94,null],[13,"Pong","","Pong message",94,null],[13,"Close","","Close message with optional reason",94,null],[5,"start","","Do websocket handshake and start actor",null,{"i":[{"n":"httprequest"},{"n":"a"}],"o":{"g":["httpresponse","error"],"n":"result"}}],[5,"handshake","","Prepare `WebSocket` handshake response.",null,{"i":[{"n":"httprequest"}],"o":{"g":["httpresponsebuilder","handshakeerror"],"n":"result"}}],[11,"cause","","",89,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",89,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",89,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",89,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","","",89,{"i":[{"n":"error"}],"o":{"n":"clienterror"}}],[11,"from","","",89,{"i":[{"n":"urlparseerror"}],"o":{"n":"clienterror"}}],[11,"from","","",89,{"i":[{"n":"sendrequesterror"}],"o":{"n":"clienterror"}}],[11,"from","","",89,{"i":[{"n":"protocolerror"}],"o":{"n":"clienterror"}}],[11,"from","","",89,{"i":[{"n":"error"}],"o":{"n":"clienterror"}}],[11,"new","","Create new websocket connection",95,{"i":[{"n":"s"}],"o":{"n":"client"}}],[11,"with_connector","","Create new websocket connection with custom `ClientConnector`",95,{"i":[{"n":"s"},{"g":["clientconnector"],"n":"addr"}],"o":{"n":"client"}}],[11,"protocols","","Set supported websocket protocols",95,{"i":[{"n":"self"},{"n":"u"}],"o":{"n":"self"}}],[11,"cookie","","Set cookie for handshake request",95,{"i":[{"n":"self"},{"n":"cookie"}],"o":{"n":"self"}}],[11,"origin","","Set request Origin",95,{"i":[{"n":"self"},{"n":"v"}],"o":{"n":"self"}}],[11,"max_frame_size","","Set max frame size",95,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"write_buffer_capacity","","Set write buffer capacity",95,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"no_masking","","Disable payload masking. By default ws client masks frame payload.",95,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"header","","Set request header",95,{"i":[{"n":"self"},{"n":"k"},{"n":"v"}],"o":{"n":"self"}}],[11,"timeout","","Set websocket handshake timeout",95,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"connect","","Connect to websocket server and do ws handshake",95,{"i":[{"n":"self"}],"o":{"n":"clienthandshake"}}],[11,"timeout","","Set handshake timeout",96,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"conn_timeout","","Set connection timeout",96,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"self"}}],[11,"poll","","",96,{"i":[{"n":"self"}],"o":{"n":"poll"}}],[11,"fmt","","",97,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"poll","","",97,{"i":[{"n":"self"}],"o":{"g":["option"],"n":"poll"}}],[11,"text","","Send text frame",98,{"i":[{"n":"self"},{"n":"t"}]}],[11,"binary","","Send binary frame",98,{"i":[{"n":"self"},{"n":"b"}]}],[11,"ping","","Send ping frame",98,{"i":[{"n":"self"},{"n":"str"}]}],[11,"pong","","Send pong frame",98,{"i":[{"n":"self"},{"n":"str"}]}],[11,"close","","Send close frame",98,{"i":[{"n":"self"},{"g":["closereason"],"n":"option"}]}],[11,"send_text","","Send text frame",98,{"i":[{"n":"self"},{"n":"t"}]}],[11,"send_binary","","Send binary frame",98,{"i":[{"n":"self"},{"n":"b"}]}],[11,"send_ping","","Send ping frame",98,{"i":[{"n":"self"},{"n":"str"}]}],[11,"send_pong","","Send pong frame",98,{"i":[{"n":"self"},{"n":"str"}]}],[11,"send_close","","Send close frame",98,{"i":[{"n":"self"},{"g":["closereason"],"n":"option"}]}],[11,"stop","","",99,{"i":[{"n":"self"}]}],[11,"terminate","","",99,{"i":[{"n":"self"}]}],[11,"state","","",99,{"i":[{"n":"self"}],"o":{"n":"actorstate"}}],[11,"spawn","","",99,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"spawnhandle"}}],[11,"wait","","",99,{"i":[{"n":"self"},{"n":"f"}]}],[11,"cancel_future","","",99,{"i":[{"n":"self"},{"n":"spawnhandle"}],"o":{"n":"bool"}}],[11,"address","","",99,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"create","","Create a new Websocket context from a request and an actor",99,{"i":[{"n":"httprequest"},{"n":"a"},{"n":"wsstream"}],"o":{"n":"body"}}],[11,"with_factory","","Create a new Websocket context",99,{"i":[{"n":"httprequest"},{"n":"f"}],"o":{"n":"body"}}],[11,"write_raw","","Write payload",99,{"i":[{"n":"self"},{"n":"framedmessage"}]}],[11,"state","","Shared application state",99,{"i":[{"n":"self"}],"o":{"n":"s"}}],[11,"request","","Incoming request",99,{"i":[{"n":"self"}],"o":{"n":"httprequest"}}],[11,"drain","","Returns drain future",99,{"i":[{"n":"self"}],"o":{"n":"drain"}}],[11,"text","","Send text frame",99,{"i":[{"n":"self"},{"n":"t"}]}],[11,"binary","","Send binary frame",99,{"i":[{"n":"self"},{"n":"b"}]}],[11,"ping","","Send ping frame",99,{"i":[{"n":"self"},{"n":"str"}]}],[11,"pong","","Send pong frame",99,{"i":[{"n":"self"},{"n":"str"}]}],[11,"close","","Send close frame",99,{"i":[{"n":"self"},{"g":["closereason"],"n":"option"}]}],[11,"connected","","Check if connection still open",99,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"handle","","Handle of the running future",99,{"i":[{"n":"self"}],"o":{"n":"spawnhandle"}}],[11,"send_text","","Send text frame",99,{"i":[{"n":"self"},{"n":"t"}]}],[11,"send_binary","","Send binary frame",99,{"i":[{"n":"self"},{"n":"b"}]}],[11,"send_ping","","Send ping frame",99,{"i":[{"n":"self"},{"n":"str"}]}],[11,"send_pong","","Send pong frame",99,{"i":[{"n":"self"},{"n":"str"}]}],[11,"send_close","","Send close frame",99,{"i":[{"n":"self"},{"g":["closereason"],"n":"option"}]}],[11,"parts","","",99,{"i":[{"n":"self"}],"o":{"n":"contextparts"}}],[11,"pack","","",99,{"i":[{"n":"m"},{"g":["sender"],"n":"option"}],"o":{"n":"envelope"}}],[11,"fmt","","",100,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"unpack","","Destruct frame",100,null],[11,"close","","Create a new Close control frame.",100,{"i":[{"g":["closereason"],"n":"option"},{"n":"bool"}],"o":{"n":"framedmessage"}}],[11,"parse","","Parse the input stream into a frame.",100,{"i":[{"n":"payloadbuffer"},{"n":"bool"},{"n":"usize"}],"o":{"g":["option","protocolerror"],"n":"poll"}}],[11,"parse_close_payload","","Parse the payload of a close frame.",100,{"i":[{"n":"binary"}],"o":{"g":["closereason"],"n":"option"}}],[11,"message","","Generate binary representation",100,{"i":[{"n":"b"},{"n":"opcode"},{"n":"bool"},{"n":"bool"}],"o":{"n":"framedmessage"}}],[11,"default","","",100,{"o":{"n":"frame"}}],[11,"fmt","","",100,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",101,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",91,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",91,{"i":[{"n":"self"},{"n":"opcode"}],"o":{"n":"bool"}}],[11,"clone","","",91,{"i":[{"n":"self"}],"o":{"n":"opcode"}}],[11,"fmt","","",91,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"into","","",91,{"i":[{"n":"self"}],"o":{"n":"u8"}}],[11,"from","","",91,{"i":[{"n":"u8"}],"o":{"n":"opcode"}}],[11,"fmt","","",90,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",90,{"i":[{"n":"self"},{"n":"closecode"}],"o":{"n":"bool"}}],[11,"ne","","",90,{"i":[{"n":"self"},{"n":"closecode"}],"o":{"n":"bool"}}],[11,"clone","","",90,{"i":[{"n":"self"}],"o":{"n":"closecode"}}],[11,"into","","",90,{"i":[{"n":"self"}],"o":{"n":"u16"}}],[11,"from","","",90,{"i":[{"n":"u16"}],"o":{"n":"closecode"}}],[11,"fmt","","",88,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",88,{"i":[{"n":"self"},{"n":"closereason"}],"o":{"n":"bool"}}],[11,"ne","","",88,{"i":[{"n":"self"},{"n":"closereason"}],"o":{"n":"bool"}}],[11,"clone","","",88,{"i":[{"n":"self"}],"o":{"n":"closereason"}}],[11,"from","","",88,{"i":[{"n":"closecode"}],"o":{"n":"self"}}],[11,"from","","",88,null],[8,"WsWriter","","Common writing methods for a websocket.",null,null],[10,"send_text","","Send a text",102,{"i":[{"n":"self"},{"n":"t"}]}],[10,"send_binary","","Send a binary",102,{"i":[{"n":"self"},{"n":"b"}]}],[10,"send_ping","","Send a ping message",102,{"i":[{"n":"self"},{"n":"str"}]}],[10,"send_pong","","Send a pong message",102,{"i":[{"n":"self"},{"n":"str"}]}],[10,"send_close","","Close the connection",102,{"i":[{"n":"self"},{"g":["closereason"],"n":"option"}]}],[11,"cause","","",92,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",92,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",92,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"fmt","","",92,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from","","",92,{"i":[{"n":"payloaderror"}],"o":{"n":"protocolerror"}}],[11,"cause","","",93,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",93,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"fmt","","",93,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",93,{"i":[{"n":"self"},{"n":"handshakeerror"}],"o":{"n":"bool"}}],[11,"fmt","","",93,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"error_response","","",93,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"fmt","","",94,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",94,{"i":[{"n":"self"},{"n":"message"}],"o":{"n":"bool"}}],[11,"ne","","",94,{"i":[{"n":"self"},{"n":"message"}],"o":{"n":"bool"}}],[11,"new","","Create new websocket frames stream",103,{"i":[{"n":"s"}],"o":{"n":"wsstream"}}],[11,"max_size","","Set max frame size",103,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"poll","","",103,{"i":[{"n":"self"}],"o":{"g":["option"],"n":"poll"}}],[0,"actix","actix_web","Re-exports actix's prelude",null,null],[0,"resolver","actix_web::actix","DNS resolver and connector utility actor",null,null],[6,"Connector","actix_web::actix::resolver","",null,null],[6,"ConnectorError","","",null,null],[3,"Resolve","","",null,null],[3,"Connect","","",null,null],[3,"ConnectAddr","","",null,null],[12,"0","","",104,null],[4,"ResolverError","","",null,null],[13,"Resolver","","Failed to resolve the hostname",105,null],[13,"InvalidInput","","Address is invalid",105,null],[13,"Timeout","","Connecting took too long",105,null],[13,"IoError","","Connection io error",105,null],[3,"Resolver","","",null,null],[3,"TcpConnector","","Tcp stream connector",null,null],[0,"signal","actix_web::actix","An actor implementation of Unix signal handling",null,null],[4,"SignalType","actix_web::actix::signal","Different types of process signals",null,null],[13,"Hup","","SIGHUP",106,null],[13,"Int","","SIGINT",106,null],[13,"Term","","SIGTERM",106,null],[13,"Quit","","SIGQUIT",106,null],[13,"Child","","SIGCHILD",106,null],[3,"Signal","","Process signal message",null,null],[12,"0","","",107,null],[3,"ProcessSignals","","An actor implementation of Unix signal handling",null,null],[3,"Subscribe","","Subscribe to process signals.",null,null],[12,"0","","",108,null],[3,"DefaultSignalsHandler","","Default signals handler. This actor sends `SystemExit` message to `System` actor for each of `SIGINT`, `SIGTERM`, `SIGQUIT` signals.",null,null],[0,"fut","actix_web::actix","Custom `Future` implementation with `Actix` support",null,null],[8,"ActorFuture","actix_web::actix::fut","Trait for types which are a placeholder of a value that may become available at some later point in time.",null,null],[16,"Item","","The type of value that this future will resolved with if it is successful.",109,null],[16,"Error","","The type of error that this future will resolve with if it fails in a normal fashion.",109,null],[16,"Actor","","The actor within which this future runs",109,null],[10,"poll","","",109,null],[11,"map","","Map this future's result to a different type, returning a new future of the resulting type.",109,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"map"}}],[11,"map_err","","Map this future's error to a different error, returning a new future.",109,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"maperr"}}],[11,"drop_err","","Drop this future's error, returning a new future.",109,{"i":[{"n":"self"}],"o":{"n":"droperr"}}],[11,"from_err","","Map this future's error to any error implementing `From` for this future's `Error`, returning a new future.",109,{"i":[{"n":"self"}],"o":{"n":"fromerr"}}],[11,"then","","Chain on a computation for when a future finished, passing the result of the future to the provided closure `f`.",109,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"then"}}],[11,"and_then","","Execute another future after this one has resolved successfully.",109,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"andthen"}}],[11,"timeout","","Add timeout to futures chain.",109,null],[8,"ActorStream","","A stream of values, not all of which may have been produced yet.",null,null],[16,"Item","","The type of item this stream will yield on success.",110,null],[16,"Error","","The type of error this stream may generate.",110,null],[16,"Actor","","The actor within which this stream runs.",110,null],[10,"poll","","",110,null],[11,"map","","Converts a stream of type `T` to a stream of type `U`.",110,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"streammap"}}],[11,"map_err","","Converts a stream of error type `T` to a stream of error type `E`.",110,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"streammaperr"}}],[11,"then","","Chain on a computation for when a value is ready, passing the resulting item to the provided closure `f`.",110,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"streamthen"}}],[11,"and_then","","Chain on a computation for when a value is ready, passing the successful results to the provided closure `f`.",110,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"streamandthen"}}],[11,"fold","","Execute an accumulating computation over a stream, collecting all the values into one final result.",110,{"i":[{"n":"self"},{"n":"t"},{"n":"f"}],"o":{"n":"streamfold"}}],[11,"timeout","","Add timeout to stream.",110,null],[11,"finish","","Converts a stream to a future that resolves when stream finishes.",110,{"i":[{"n":"self"}],"o":{"n":"streamfinish"}}],[8,"IntoActorFuture","","Class of types which can be converted into an actor future.",null,null],[16,"Future","","The future that this type can be converted into.",111,null],[16,"Item","","The item that the future may resolve with.",111,null],[16,"Error","","The error that the future may resolve with.",111,null],[16,"Actor","","The actor within which this future runs",111,null],[10,"into_future","","Consumes this object and produces a future.",111,null],[8,"WrapFuture","","Helper trait that allows conversion of normal future into `ActorFuture`",null,null],[16,"Future","","The future that this type can be converted into.",112,null],[16,"Item","","The item that the future may resolve with.",112,null],[16,"Error","","The error that the future may resolve with.",112,null],[10,"into_actor","","Convert normal future to a ActorFuture",112,null],[3,"FutureWrap","","",null,null],[5,"wrap_future","","Converts normal future into `ActorFuture`",null,{"i":[{"n":"f"}],"o":{"n":"futurewrap"}}],[8,"WrapStream","","Helper trait that allows conversion of normal stream into `ActorStream`",null,null],[16,"Stream","","The stream that this type can be converted into.",113,null],[16,"Item","","The item that the future may resolve with.",113,null],[16,"Error","","The error that the future may resolve with.",113,null],[10,"into_actor","","Convert normal stream to a ActorStream",113,null],[3,"StreamWrap","","",null,null],[5,"wrap_stream","","Converts normal stream into `ActorStream`",null,{"i":[{"n":"s"}],"o":{"n":"streamwrap"}}],[5,"result","","Creates a new \"leaf future\" which will resolve with the given result.",null,{"i":[{"n":"result"}],"o":{"n":"futureresult"}}],[3,"AndThen","","Future for the `and_then` combinator, chaining a computation onto the end of another future which completes successfully.",null,null],[3,"FutureResult","","A future representing a value that is immediately ready.",null,null],[3,"Timeout","","Future for the `timeout` combinator, interrupts computations if it takes more than `timeout`.",null,null],[3,"StreamMap","","A stream combinator which will change the type of a stream from one type to another.",null,null],[3,"Then","","Future for the `then` combinator, chaining computations on the end of another future regardless of its outcome.",null,null],[3,"MapErr","","Future for the `map_err` combinator, changing the error type of a future.",null,null],[3,"Finish","","A combinator used to convert stream into a future, future resolves when stream completes.",null,null],[3,"StreamFold","","A future used to collect all the results of a stream into one generic type.",null,null],[3,"FromErr","","Future for the `from_err` combinator, changing the error type of a future.",null,null],[3,"StreamTimeout","","Future for the `timeout` combinator, interrupts computations if it takes more than `timeout`.",null,null],[5,"ok","","Creates a \"leaf future\" from an immediate value of a finished and successful computation.",null,{"i":[{"n":"t"}],"o":{"n":"futureresult"}}],[3,"StreamFinish","","A combinator used to convert stream into a future, future resolves when stream completes.",null,null],[3,"StreamThen","","A stream combinator which chains a computation onto each item produced by a stream.",null,null],[3,"StreamAndThen","","A stream combinator which chains a computation onto values produced by a stream.",null,null],[4,"Either","","Combines two different futures yielding the same item and error types into a single type.",null,null],[13,"A","","First branch of the type",114,null],[13,"B","","Second branch of the type",114,null],[3,"DropErr","","",null,null],[5,"err","","Creates a \"leaf future\" from an immediate value of a failed computation.",null,{"i":[{"n":"e"}],"o":{"n":"futureresult"}}],[3,"StreamMapErr","","A stream combinator which will change the error type of a stream from one type to another.",null,null],[3,"Map","","Future for the `map` combinator, changing the type of a future.",null,null],[0,"msgs","actix_web::actix","Actix system messages",null,null],[3,"StopArbiter","actix_web::actix::msgs","Stop arbiter execution",null,null],[12,"0","","",115,null],[3,"StartActor","","Start actor in arbiter's thread",null,null],[3,"Execute","","Execute function in arbiter's thread",null,null],[0,"actix","actix_web::actix","",null,null],[3,"SyncArbiter","actix_web::actix::actix","Sync arbiter",null,null],[3,"Condition","","",null,null],[6,"ResponseActFuture","","A specialized actor future for async message handler",null,null],[8,"Actor","","Actors are objects which encapsulate state and behavior.",null,null],[16,"Context","","Actor execution context type",116,null],[11,"started","","Method is called when actor get polled first time.",116,null],[11,"stopping","","Method is called after an actor is in `Actor::Stopping` state. There could be several reasons for stopping. `Context::stop` get called by the actor itself. All addresses to current actor get dropped and no more evented objects left in the context.",116,null],[11,"stopped","","Method is called after an actor is stopped, it can be used to perform any needed cleanup work or spawning more actors. This is final state, after this call actor get dropped.",116,null],[11,"start","","Start new asynchronous actor, returns address of newly created actor.",116,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"start_default","","Start new asynchronous actor, returns address of newly created actor.",116,{"o":{"n":"addr"}}],[11,"create","","Use `create` method, if you need `Context` object during actor initialization.",116,{"i":[{"n":"f"}],"o":{"n":"addr"}}],[4,"Running","","",null,null],[13,"Stop","","",117,null],[13,"Continue","","",117,null],[4,"ActorState","","Actor execution state",null,null],[13,"Started","","Actor is started.",118,null],[13,"Running","","Actor is running.",118,null],[13,"Stopping","","Actor is stopping.",118,null],[13,"Stopped","","Actor is stopped.",118,null],[3,"Context","","Actor execution context",null,null],[8,"ContextFutureSpawner","","Helper trait which can spawn future into actor's context",null,null],[10,"spawn","","spawn future into `Context<A>`",119,null],[10,"wait","","Spawn future into the context. Stop processing any of incoming events until this future resolves.",119,null],[8,"Supervised","","Actors with ability to restart after failure",null,null],[11,"restarting","","Method called when supervisor restarting failed actor",120,null],[4,"MailboxError","","Set of error that can occurred during message delivery process",null,null],[13,"Closed","","",121,null],[13,"Timeout","","",121,null],[3,"MessageResult","","Helper type that implements `MessageResponse` trait",null,null],[12,"0","","",122,null],[0,"io","","",null,null],[8,"WriteHandler","actix_web::actix::actix::io","Write handler",null,null],[11,"error","","Method is called when writer emits error.",123,null],[11,"finished","","Method is called when writer finishes.",123,null],[3,"Writer","","Wrapper for `AsyncWrite` types",null,null],[3,"FramedWrite","","Wrapper for `AsyncWrite` and `Encoder` types",null,null],[8,"WrapFuture","actix_web::actix::actix","Helper trait that allows conversion of normal future into `ActorFuture`",null,null],[16,"Future","","The future that this type can be converted into.",112,null],[16,"Item","","The item that the future may resolve with.",112,null],[16,"Error","","The error that the future may resolve with.",112,null],[10,"into_actor","","Convert normal future to a ActorFuture",112,null],[3,"Supervisor","","Actor supervisor",null,null],[8,"SystemService","","Trait defines system's service.",null,null],[11,"start_service","","Construct and srtart system service",124,{"i":[{"n":"addr"}],"o":{"n":"addr"}}],[11,"service_started","","Method is called during service initialization.",124,null],[11,"from_registry","","Get actor's address from system registry",124,{"o":{"n":"addr"}}],[3,"Addr","","Address of the actor",null,null],[4,"SendError","","",null,null],[13,"Full","","",125,null],[13,"Closed","","",125,null],[0,"dev","","The `actix` prelude for library developers",null,null],[3,"ContextParts","actix_web::actix::actix::dev","",null,null],[8,"ActorContext","","Actor execution context",null,null],[10,"stop","","Immediately stop processing incoming messages and switch to a `stopping` state",126,null],[10,"terminate","","Terminate actor execution",126,null],[10,"state","","Actor execution state",126,{"i":[{"n":"self"}],"o":{"n":"actorstate"}}],[3,"ContextFut","","",null,null],[8,"ActorStream","","A stream of values, not all of which may have been produced yet.",null,null],[16,"Item","","The type of item this stream will yield on success.",110,null],[16,"Error","","The type of error this stream may generate.",110,null],[16,"Actor","","The actor within which this stream runs.",110,null],[10,"poll","","",110,null],[11,"map","","Converts a stream of type `T` to a stream of type `U`.",110,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"streammap"}}],[11,"map_err","","Converts a stream of error type `T` to a stream of error type `E`.",110,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"streammaperr"}}],[11,"then","","Chain on a computation for when a value is ready, passing the resulting item to the provided closure `f`.",110,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"streamthen"}}],[11,"and_then","","Chain on a computation for when a value is ready, passing the successful results to the provided closure `f`.",110,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"streamandthen"}}],[11,"fold","","Execute an accumulating computation over a stream, collecting all the values into one final result.",110,{"i":[{"n":"self"},{"n":"t"},{"n":"f"}],"o":{"n":"streamfold"}}],[11,"timeout","","Add timeout to stream.",110,null],[11,"finish","","Converts a stream to a future that resolves when stream finishes.",110,{"i":[{"n":"self"}],"o":{"n":"streamfinish"}}],[0,"actors","","Helper actors",null,null],[0,"resolver","actix_web::actix::actix::dev::actors","DNS resolver and connector utility actor",null,null],[6,"Connector","actix_web::actix::actix::dev::actors::resolver","",null,null],[6,"ConnectorError","","",null,null],[3,"Resolve","","",null,null],[3,"Connect","","",null,null],[3,"ConnectAddr","","",null,null],[12,"0","","",104,null],[4,"ResolverError","","",null,null],[13,"Resolver","","Failed to resolve the hostname",105,null],[13,"InvalidInput","","Address is invalid",105,null],[13,"Timeout","","Connecting took too long",105,null],[13,"IoError","","Connection io error",105,null],[3,"Resolver","","",null,null],[3,"TcpConnector","","Tcp stream connector",null,null],[0,"signal","actix_web::actix::actix::dev::actors","An actor implementation of Unix signal handling",null,null],[4,"SignalType","actix_web::actix::actix::dev::actors::signal","Different types of process signals",null,null],[13,"Hup","","SIGHUP",106,null],[13,"Int","","SIGINT",106,null],[13,"Term","","SIGTERM",106,null],[13,"Quit","","SIGQUIT",106,null],[13,"Child","","SIGCHILD",106,null],[3,"Signal","","Process signal message",null,null],[12,"0","","",107,null],[3,"ProcessSignals","","An actor implementation of Unix signal handling",null,null],[3,"Subscribe","","Subscribe to process signals.",null,null],[12,"0","","",108,null],[3,"DefaultSignalsHandler","","Default signals handler. This actor sends `SystemExit` message to `System` actor for each of `SIGINT`, `SIGTERM`, `SIGQUIT` signals.",null,null],[3,"SpawnHandle","actix_web::actix::actix::dev","Spawned future handle. Could be used for cancelling spawned future.",null,null],[3,"ActorResponse","","Helper type for representing different type of message responses",null,null],[8,"StreamHandler","","Stream handler",null,null],[10,"handle","","Method is called for every message received by this Actor",127,null],[11,"started","","Method is called when stream get polled first time.",127,null],[11,"error","","Method is called when stream emits error.",127,null],[11,"finished","","Method is called when stream finishes.",127,null],[11,"add_stream","","This method register stream to an actor context and allows to handle `Stream` in similar way as normal actor messages.",127,null],[3,"Registry","","Actors registry",null,null],[3,"Response","","Helper type for representing different type of message responses",null,null],[3,"Mailbox","","",null,null],[3,"System","","System is an actor which manages runtime.",null,null],[8,"ActorFuture","","Trait for types which are a placeholder of a value that may become available at some later point in time.",null,null],[16,"Item","","The type of value that this future will resolved with if it is successful.",109,null],[16,"Error","","The type of error that this future will resolve with if it fails in a normal fashion.",109,null],[16,"Actor","","The actor within which this future runs",109,null],[10,"poll","","",109,null],[11,"map","","Map this future's result to a different type, returning a new future of the resulting type.",109,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"map"}}],[11,"map_err","","Map this future's error to a different error, returning a new future.",109,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"maperr"}}],[11,"drop_err","","Drop this future's error, returning a new future.",109,{"i":[{"n":"self"}],"o":{"n":"droperr"}}],[11,"from_err","","Map this future's error to any error implementing `From` for this future's `Error`, returning a new future.",109,{"i":[{"n":"self"}],"o":{"n":"fromerr"}}],[11,"then","","Chain on a computation for when a future finished, passing the result of the future to the provided closure `f`.",109,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"then"}}],[11,"and_then","","Execute another future after this one has resolved successfully.",109,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"andthen"}}],[11,"timeout","","Add timeout to futures chain.",109,null],[3,"Recipient","","`Recipient` type allows to send one specific message to an actor.",null,null],[8,"WrapStream","","Helper trait that allows conversion of normal stream into `ActorStream`",null,null],[16,"Stream","","The stream that this type can be converted into.",113,null],[16,"Item","","The item that the future may resolve with.",113,null],[16,"Error","","The error that the future may resolve with.",113,null],[10,"into_actor","","Convert normal stream to a ActorStream",113,null],[0,"msgs","","Actix system messages",null,null],[3,"StopArbiter","actix_web::actix::actix::dev::msgs","Stop arbiter execution",null,null],[12,"0","","",115,null],[3,"StartActor","","Start actor in arbiter's thread",null,null],[3,"Execute","","Execute function in arbiter's thread",null,null],[8,"AsyncContextParts","actix_web::actix::actix::dev","",null,null],[10,"parts","","",128,{"i":[{"n":"self"}],"o":{"n":"contextparts"}}],[8,"ResponseChannel","","Trait defines message response channel",null,null],[10,"is_canceled","","",129,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[10,"send","","",129,null],[8,"ArbiterService","","Trait defines arbiter's service.",null,null],[11,"start_service","","Construct and srtart arbiter service",130,{"o":{"n":"addr"}}],[11,"service_started","","Method is called during service initialization.",130,null],[11,"from_registry","","Get actor's address from arbiter registry",130,{"o":{"n":"addr"}}],[3,"RecipientRequest","","`RecipientRequest` is a `Future` which represents asynchronous message sending process.",null,null],[8,"Message","","Message type",null,null],[16,"Result","","The type of value that this message will resolved with if it is successful.",131,null],[0,"fut","","Custom `Future` implementation with `Actix` support",null,null],[8,"IntoActorFuture","actix_web::actix::actix::dev::fut","Class of types which can be converted into an actor future.",null,null],[16,"Future","","The future that this type can be converted into.",111,null],[16,"Item","","The item that the future may resolve with.",111,null],[16,"Error","","The error that the future may resolve with.",111,null],[16,"Actor","","The actor within which this future runs",111,null],[10,"into_future","","Consumes this object and produces a future.",111,null],[3,"FutureWrap","","",null,null],[5,"wrap_future","","Converts normal future into `ActorFuture`",null,{"i":[{"n":"f"}],"o":{"n":"futurewrap"}}],[3,"StreamWrap","","",null,null],[5,"wrap_stream","","Converts normal stream into `ActorStream`",null,{"i":[{"n":"s"}],"o":{"n":"streamwrap"}}],[5,"result","","Creates a new \"leaf future\" which will resolve with the given result.",null,{"i":[{"n":"result"}],"o":{"n":"futureresult"}}],[3,"AndThen","","Future for the `and_then` combinator, chaining a computation onto the end of another future which completes successfully.",null,null],[3,"FutureResult","","A future representing a value that is immediately ready.",null,null],[3,"Timeout","","Future for the `timeout` combinator, interrupts computations if it takes more than `timeout`.",null,null],[3,"StreamMap","","A stream combinator which will change the type of a stream from one type to another.",null,null],[3,"Then","","Future for the `then` combinator, chaining computations on the end of another future regardless of its outcome.",null,null],[3,"MapErr","","Future for the `map_err` combinator, changing the error type of a future.",null,null],[3,"Finish","","A combinator used to convert stream into a future, future resolves when stream completes.",null,null],[3,"StreamFold","","A future used to collect all the results of a stream into one generic type.",null,null],[3,"FromErr","","Future for the `from_err` combinator, changing the error type of a future.",null,null],[3,"StreamTimeout","","Future for the `timeout` combinator, interrupts computations if it takes more than `timeout`.",null,null],[5,"ok","","Creates a \"leaf future\" from an immediate value of a finished and successful computation.",null,{"i":[{"n":"t"}],"o":{"n":"futureresult"}}],[3,"StreamFinish","","A combinator used to convert stream into a future, future resolves when stream completes.",null,null],[3,"StreamThen","","A stream combinator which chains a computation onto each item produced by a stream.",null,null],[3,"StreamAndThen","","A stream combinator which chains a computation onto values produced by a stream.",null,null],[4,"Either","","Combines two different futures yielding the same item and error types into a single type.",null,null],[13,"A","","First branch of the type",114,null],[13,"B","","Second branch of the type",114,null],[3,"DropErr","","",null,null],[5,"err","","Creates a \"leaf future\" from an immediate value of a failed computation.",null,{"i":[{"n":"e"}],"o":{"n":"futureresult"}}],[3,"StreamMapErr","","A stream combinator which will change the error type of a stream from one type to another.",null,null],[3,"Map","","Future for the `map` combinator, changing the type of a future.",null,null],[8,"ToEnvelope","actix_web::actix::actix::dev","Converter trait, packs message to suitable envelope",null,null],[10,"pack","","Pack message into suitable envelope",132,{"i":[{"n":"m"},{"g":["sender"],"n":"option"}],"o":{"n":"envelope"}}],[3,"SystemRegistry","","System wide actors registry",null,null],[3,"SyncContext","","Sync actor execution context",null,null],[3,"Request","","`Request` is a `Future` which represents asynchronous message sending process.",null,null],[6,"ResponseFuture","","A specialized future for async message handler",null,null],[8,"AsyncContext","","Asynchronous execution context",null,null],[10,"address","","Return `Address` of the context",133,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[10,"spawn","","Spawn async future into context. Returns handle of the item, could be used for cancelling execution.",133,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"spawnhandle"}}],[10,"wait","","Spawn future into the context. Stop processing any of incoming events until this future resolves.",133,null],[10,"waiting","","Check if context is paused (waiting for future completion or stopping)",133,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[10,"cancel_future","","Cancel future. handle is a value returned by `spawn` method.",133,{"i":[{"n":"self"},{"n":"spawnhandle"}],"o":{"n":"bool"}}],[11,"add_stream","","This method register stream to an actor context and allows to handle `Stream` in similar way as normal actor messages.",133,{"i":[{"n":"self"},{"n":"s"}],"o":{"n":"spawnhandle"}}],[11,"add_message_stream","","This method is similar to `add_stream` but it skips stream errors.",133,null],[11,"notify","","Send message `msg` to self.",133,null],[11,"notify_later","","Send message `msg` to self after specified period of time. Returns spawn handle which could be used for cancellation. Notification get cancelled if context's stop method get called.",133,{"i":[{"n":"self"},{"n":"m"},{"n":"duration"}],"o":{"n":"spawnhandle"}}],[11,"run_later","","Execute closure after specified period of time within same Actor and Context. Execution get cancelled if context's stop method get called.",133,{"i":[{"n":"self"},{"n":"duration"},{"n":"f"}],"o":{"n":"spawnhandle"}}],[11,"run_interval","","Spawns job to execute closure with specified interval",133,{"i":[{"n":"self"},{"n":"duration"},{"n":"f"}],"o":{"n":"spawnhandle"}}],[8,"MessageResponse","","Trait which defines message response",null,null],[10,"handle","","",134,null],[3,"Arbiter","","Event loop controller",null,null],[8,"Handler","","Message handler",null,null],[16,"Result","","The type of value that this handle will return",135,null],[10,"handle","","Method is called for every message received by this Actor",135,null],[3,"Envelope","","",null,null],[5,"run","actix_web::actix","Start the System and execute supplied future.",null,null],[5,"spawn","","Spawns a future on the current arbiter.",null,null],[0,"dev","actix_web","The `actix-web` prelude for library developers",null,null],[3,"Drain","actix_web::dev","Consume a future",null,null],[3,"FormConfig","","Form extractor configuration",null,null],[3,"PayloadConfig","","Payload configuration for request's payload.",null,null],[3,"AsyncResult","","Represents async result",null,null],[3,"MessageBody","","Future that resolves to a complete http message body.",null,null],[3,"UrlEncoded","","Future that resolves to a parsed urlencoded values.",null,null],[3,"HttpResponseBuilder","","An HTTP response builder",null,null],[3,"ConnectionInfo","","`HttpRequest` connection information",null,null],[3,"JsonBody","","Request payload json parser that resolves to a deserialized `T` value.",null,null],[3,"JsonConfig","","Json extractor configuration",null,null],[3,"Params","","Route match information",null,null],[3,"Payload","","Buffered stream of bytes chunks",null,null],[3,"PayloadBuffer","","Payload buffer",null,null],[3,"Resource","","Resource is an entry in route table which corresponds to requested URL.",null,null],[3,"Route","","Resource route definition",null,null],[3,"ResourceDef","","Resource type describes an entry in resources table",null,null],[3,"ResourceInfo","","Information about current resource",null,null],[3,"Router","","Interface for application router.",null,null],[4,"ResourceType","","Resource type",null,null],[13,"Normal","","Normal resource",136,null],[13,"Default","","Resource for application default handler",136,null],[13,"External","","External resource",136,null],[13,"Unset","","Unknown resource type",136,null],[6,"BodyStream","","Type represent streaming body",null,null],[8,"Handler","","Trait defines object that could be registered as route handler",null,null],[16,"Result","","The type of value that handler will return.",137,null],[10,"handle","","Handle request",137,null],[8,"FromParam","","A trait to abstract the idea of creating a new instance of a type from a path parameter.",null,null],[16,"Err","","The associated error which can be returned from parsing.",138,null],[10,"from_param","","Parses a string `s` to return a value of this type.",138,{"i":[{"n":"str"}],"o":{"n":"result"}}],[0,"http","actix_web","Various HTTP related types",null,null],[3,"Method","actix_web::http","The Request Method (VERB)",null,null],[3,"StatusCode","","An HTTP status code (`status-code` in RFC 7230 et al.).",null,null],[3,"Version","","Represents a version of the HTTP spec.",null,null],[3,"Cookie","","Representation of an HTTP cookie.",null,null],[3,"CookieBuilder","","Structure that follows the builder pattern for building `Cookie` structs.",null,null],[3,"NormalizePath","","Path normalization helper",null,null],[4,"ContentEncoding","","Represents supported types of content encodings",null,null],[13,"Auto","","Automatically select encoding based on encoding negotiation",139,null],[13,"Br","","A format using the Brotli algorithm",139,null],[13,"Deflate","","A format using the zlib structure with deflate algorithm",139,null],[13,"Gzip","","Gzip algorithm",139,null],[13,"Identity","","Indicates the identity function (i.e. no compression, nor modification)",139,null],[4,"ConnectionType","","Represents various types of connection",null,null],[13,"Close","","Close connection after response",140,null],[13,"KeepAlive","","Keep connection alive after response",140,null],[13,"Upgrade","","Connection is upgraded to different type",140,null],[0,"header","","Various http headers",null,null],[17,"CACHE_CONTROL","actix_web::http::header","Specifies directives for caching mechanisms in both requests and responses.",null,null],[17,"CONTENT_RANGE","","Indicates where in a full body message a partial message belongs.",null,null],[17,"LINK","","Allows the server to point an interested client to another resource containing metadata about the requested resource.",null,null],[3,"InvalidHeaderValue","","A possible error when converting a `HeaderValue` from a string or byte slice.",null,null],[17,"REFERER","","Contains the address of the previous web page from which a link to the currently requested page was followed.",null,null],[17,"FORWARDED","","Contains information from the client-facing side of proxy servers that is altered or lost when a proxy is involved in the path of the request.",null,null],[17,"ACCESS_CONTROL_ALLOW_HEADERS","","Preflight response indicating permitted HTTP headers.",null,null],[17,"ACCESS_CONTROL_ALLOW_CREDENTIALS","","Preflight response indicating if the response to the request can be exposed to the page.",null,null],[3,"GetAll","","A view to all values stored in a single entry.",null,null],[17,"AUTHORIZATION","","Contains the credentials to authenticate a user agent with a server.",null,null],[3,"IntoIter","","An owning iterator over the entries of a `HeaderMap`.",null,null],[17,"CONTENT_LENGTH","","Indicates the size fo the entity-body.",null,null],[17,"ACCESS_CONTROL_REQUEST_METHOD","","Informs the server know which HTTP method will be used when the actual request is made.",null,null],[3,"OccupiedEntry","","A view into a single occupied location in a `HeaderMap`.",null,null],[17,"STRICT_TRANSPORT_SECURITY","","Tells the client to communicate with HTTPS instead of using HTTP.",null,null],[8,"IntoHeaderName","","A marker trait used to identify values that can be used as insert keys to a `HeaderMap`.",null,null],[17,"PUBLIC_KEY_PINS_REPORT_ONLY","","Sends reports of pinning violation to the report-uri specified in the header.",null,null],[3,"VacantEntry","","A view into a single empty location in a `HeaderMap`.",null,null],[17,"SEC_WEBSOCKET_ACCEPT","","The |Sec-WebSocket-Accept| header field is used in the WebSocket opening handshake. It is sent from the server to the client to confirm that the server is willing to initiate the WebSocket connection.",null,null],[17,"SEC_WEBSOCKET_VERSION","","The |Sec-WebSocket-Version| header field is used in the WebSocket opening handshake.  It is sent from the client to the server to indicate the protocol version of the connection.  This enables servers to correctly interpret the opening handshake and subsequent data being sent from the data, and close the connection if the server cannot interpret that data in a safe manner.",null,null],[3,"InvalidHeaderNameBytes","","A possible error when converting a `HeaderName` from another type.",null,null],[17,"UPGRADE","","Used as part of the exchange to upgrade the protocol.",null,null],[17,"VARY","","Determines how to match future requests with cached responses.",null,null],[17,"TRANSFER_ENCODING","","Specifies the form of encoding used to safely transfer the entity to the client.",null,null],[17,"PROXY_AUTHENTICATE","","Defines the authentication method that should be used to gain access to a proxy.",null,null],[17,"CONTENT_ENCODING","","Used to compress the media-type.",null,null],[17,"CONTENT_LOCATION","","Indicates an alternate location for the returned data.",null,null],[17,"X_FRAME_OPTIONS","","Indicates whether or not a browser should be allowed to render a page in a frame.",null,null],[17,"DATE","","Contains the date and time at which the message was originated.",null,null],[17,"ACCESS_CONTROL_MAX_AGE","","Indicates how long the results of a preflight request can be cached.",null,null],[17,"DNT","","Indicates the client's tracking preference.",null,null],[3,"Values","","`HeaderMap` value iterator.",null,null],[17,"SEC_WEBSOCKET_KEY","","The |Sec-WebSocket-Key| header field is used in the WebSocket opening handshake. It is sent from the client to the server to provide part of the information used by the server to prove that it received a valid WebSocket opening handshake. This helps ensure that the server does not accept connections from non-WebSocket clients (e.g., HTTP clients) that are being abused to send data to unsuspecting WebSocket servers.",null,null],[17,"HOST","","Specifies the domain name of the server and (optionally) the TCP port number on which the server is listening.",null,null],[17,"IF_NONE_MATCH","","Makes a request conditional based on the E-Tag.",null,null],[17,"PRAGMA","","HTTP/1.0 header usually used for backwards compatibility.",null,null],[17,"ORIGIN","","Indicates where a fetch originates from.",null,null],[17,"PUBLIC_KEY_PINS","","Associates a specific cryptographic public key with a certain server.",null,null],[17,"CONTENT_TYPE","","Used to indicate the media type of the resource.",null,null],[17,"ACCEPT_ENCODING","","Advertises which content encoding the client is able to understand.",null,null],[17,"RETRY_AFTER","","The Retry-After response HTTP header indicates how long the user agent should wait before making a follow-up request. There are two main cases this header is used:",null,null],[17,"ACCESS_CONTROL_EXPOSE_HEADERS","","Indicates which headers can be exposed as part of the response by listing their names.",null,null],[3,"ValueIterMut","","A mutable iterator of all values associated with a single header name.",null,null],[17,"SET_COOKIE","","Used to send cookies from the server to the user agent.",null,null],[17,"TRAILER","","Allows the sender to include additional fields at the end of chunked messages.",null,null],[17,"IF_MODIFIED_SINCE","","Makes a request conditional based on the modification date.",null,null],[17,"ALT_SVC","","Advertises the availability of alternate services to clients.",null,null],[17,"CONNECTION","","Controls whether or not the network connection stays open after the current transaction finishes.",null,null],[17,"CONTENT_SECURITY_POLICY","","Allows controlling resources the user agent is allowed to load for a given page.",null,null],[4,"Entry","","A view into a single location in a `HeaderMap`, which may be vacant or occupied.",null,null],[13,"Occupied","","An occupied entry",141,null],[13,"Vacant","","A vacant entry",141,null],[3,"HeaderName","","Represents an HTTP header field name",null,null],[17,"WARNING","","General HTTP header contains information about possible problems with the status of the message.",null,null],[17,"REFERRER_POLICY","","Governs which referrer information should be included with requests made.",null,null],[3,"Iter","","`HeaderMap` entry iterator.",null,null],[17,"AGE","","Indicates the time in seconds the object has been in a proxy cache.",null,null],[17,"USER_AGENT","","Contains a string that allows identifying the requesting client's software.",null,null],[17,"TE","","Informs the server of transfer encodings willing to be accepted as part of the response.",null,null],[17,"LAST_MODIFIED","","Content-Types that are acceptable for the response.",null,null],[17,"MAX_FORWARDS","","Indicates the max number of intermediaries the request should be sent through.",null,null],[17,"RANGE","","Indicates the part of a document that the server should return.",null,null],[17,"EXPIRES","","Contains the date/time after which the response is considered stale.",null,null],[17,"EXPECT","","Indicates expectations that need to be fulfilled by the server in order to properly handle the request.",null,null],[17,"ACCEPT_RANGES","","Marker used by the server to advertise partial request support.",null,null],[3,"HeaderValue","","Represents an HTTP header field value.",null,null],[17,"UPGRADE_INSECURE_REQUESTS","","Sends a signal to the server expressing the client’s preference for an encrypted and authenticated response.",null,null],[17,"VIA","","Added by proxies to track routing.",null,null],[17,"PROXY_AUTHORIZATION","","Contains the credentials to authenticate a user agent to a proxy server.",null,null],[17,"IF_UNMODIFIED_SINCE","","Makes the request conditional based on the last modification date.",null,null],[17,"IF_RANGE","","Makes a request conditional based on range.",null,null],[17,"LOCATION","","Indicates the URL to redirect a page to.",null,null],[17,"CONTENT_LANGUAGE","","Used to describe the languages intended for the audience.",null,null],[17,"ACCEPT_CHARSET","","Advertises which character set the client is able to understand.",null,null],[17,"ETAG","","Identifier for a specific version of a resource.",null,null],[17,"ACCESS_CONTROL_ALLOW_ORIGIN","","Indicates whether the response can be shared with resources with the given origin.",null,null],[17,"ACCESS_CONTROL_REQUEST_HEADERS","","Informs the server which HTTP headers will be used when an actual request is made.",null,null],[17,"ACCEPT_LANGUAGE","","Advertises which languages the client is able to understand.",null,null],[3,"Drain","","A drain iterator for `HeaderMap`.",null,null],[17,"SEC_WEBSOCKET_PROTOCOL","","The |Sec-WebSocket-Protocol| header field is used in the WebSocket opening handshake. It is sent from the client to the server and back from the server to the client to confirm the subprotocol of the connection.  This enables scripts to both select a subprotocol and be sure that the server agreed to serve that subprotocol.",null,null],[17,"COOKIE","","Contains stored HTTP cookies previously sent by the server with the Set-Cookie header.",null,null],[17,"CONTENT_DISPOSITION","","Indicates if the content is expected to be displayed inline.",null,null],[17,"ACCEPT","","Advertises which content types the client is able to understand.",null,null],[3,"ToStrError","","A possible error when converting a `HeaderValue` to a string representation.",null,null],[8,"AsHeaderName","","A marker trait used to identify values that can be used as search keys to a `HeaderMap`.",null,null],[3,"ValueDrain","","An drain iterator of all values associated with a single header name.",null,null],[17,"X_DNS_PREFETCH_CONTROL","","Controls DNS prefetching.",null,null],[17,"X_XSS_PROTECTION","","Stop pages from loading when an XSS attack is detected.",null,null],[3,"Keys","","An iterator over `HeaderMap` keys.",null,null],[17,"SEC_WEBSOCKET_EXTENSIONS","","The |Sec-WebSocket-Extensions| header field is used in the WebSocket opening handshake. It is initially sent from the client to the server, and then subsequently sent from the server to the client, to agree on a set of protocol-level extensions to use for the duration of the connection.",null,null],[17,"FROM","","Contains an Internet email address for a human user who controls the requesting user agent.",null,null],[3,"InvalidHeaderName","","A possible error when converting a `HeaderName` from another type.",null,null],[3,"InvalidHeaderValueBytes","","A possible error when converting a `HeaderValue` from a string or byte slice.",null,null],[3,"HeaderMap","","A set of HTTP headers",null,null],[17,"X_CONTENT_TYPE_OPTIONS","","Marker used by the server to indicate that the MIME types advertised in the `content-type` headers should not be changed and be followed.",null,null],[17,"WWW_AUTHENTICATE","","Defines the authentication method that should be used to gain access to a resource.",null,null],[17,"REFRESH","","Informs the web browser that the current page or frame should be refreshed.",null,null],[3,"ValueIter","","An iterator of all values associated with a single header name.",null,null],[17,"SERVER","","Contains information about the software used by the origin server to handle the request.",null,null],[17,"CONTENT_SECURITY_POLICY_REPORT_ONLY","","Allows experimenting with policies by monitoring their effects.",null,null],[17,"ACCESS_CONTROL_ALLOW_METHODS","","Preflight header response indicating permitted access methods.",null,null],[17,"IF_MATCH","","Makes a request conditional based on the E-Tag.",null,null],[17,"ALLOW","","Lists the set of methods support by a resource.",null,null],[3,"LanguageTag","","A language tag as described in BCP47.",null,null],[12,"language","","Language subtags are used to indicate the language, ignoring all other aspects such as script, region or spefic invariants.",142,null],[12,"extlangs","","Extended language subtags are used to identify certain specially selected languages that, for various historical and compatibility reasons, are closely identified with or tagged using an existing primary language subtag.",142,null],[12,"script","","Script subtags are used to indicate the script or writing system variations that distinguish the written forms of a language or its dialects.",142,null],[12,"region","","Region subtags are used to indicate linguistic variations associated with or appropriate to a specific country, territory, or region. Typically, a region subtag is used to indicate variations such as regional dialects or usage, or region-specific spelling conventions. It can also be used to indicate that content is expressed in a way that is appropriate for use throughout a region, for instance, Spanish content tailored to be useful throughout Latin America.",142,null],[12,"variants","","Variant subtags are used to indicate additional, well-recognized variations that define a language or its dialects that are not covered by other available subtags.",142,null],[12,"extensions","","Extensions provide a mechanism for extending language tags for use in various applications.  They are intended to identify information that is commonly used in association with languages or language tags but that is not part of language identification.",142,null],[12,"privateuse","","Private use subtags are used to indicate distinctions in language that are important in a given context by private agreement.",142,null],[3,"ExtendedValue","","An extended header parameter value (i.e., tagged with a character set and optionally, a language), as defined in RFC 5987.",null,null],[12,"charset","","The character set that is used to encode the `value` to a string.",143,null],[12,"language_tag","","The human language details of the `value`, if available.",143,null],[12,"value","","The parameter value, as expressed in octets.",143,null],[3,"ContentDisposition","","A `Content-Disposition` header, (re)defined in RFC6266.",null,null],[12,"disposition","","The disposition",144,null],[12,"parameters","","Disposition parameters",144,null],[4,"ContentEncoding","","Represents supported types of content encodings",null,null],[13,"Auto","","Automatically select encoding based on encoding negotiation",139,null],[13,"Br","","A format using the Brotli algorithm",139,null],[13,"Deflate","","A format using the zlib structure with deflate algorithm",139,null],[13,"Gzip","","Gzip algorithm",139,null],[13,"Identity","","Indicates the identity function (i.e. no compression, nor modification)",139,null],[4,"DispositionType","","The implied disposition of the content of the HTTP body.",null,null],[13,"Inline","","Inline implies default processing",145,null],[13,"Attachment","","Attachment implies that the recipient should prompt the user to save the response locally, rather than process it normally (as per its media type).",145,null],[13,"Ext","","Extension type.  Should be handled by recipients the same way as Attachment",145,null],[4,"DispositionParam","","A parameter to the disposition type.",null,null],[13,"Filename","","A Filename consisting of a Charset, an optional LanguageTag, and finally a sequence of bytes representing the filename",146,null],[13,"Ext","","Extension type consisting of token and value.  Recipients should ignore unrecognized parameters.",146,null],[4,"Charset","","A Mime charset.",null,null],[13,"Us_Ascii","","US ASCII",147,null],[13,"Iso_8859_1","","ISO-8859-1",147,null],[13,"Iso_8859_2","","ISO-8859-2",147,null],[13,"Iso_8859_3","","ISO-8859-3",147,null],[13,"Iso_8859_4","","ISO-8859-4",147,null],[13,"Iso_8859_5","","ISO-8859-5",147,null],[13,"Iso_8859_6","","ISO-8859-6",147,null],[13,"Iso_8859_7","","ISO-8859-7",147,null],[13,"Iso_8859_8","","ISO-8859-8",147,null],[13,"Iso_8859_9","","ISO-8859-9",147,null],[13,"Iso_8859_10","","ISO-8859-10",147,null],[13,"Shift_Jis","","Shift_JIS",147,null],[13,"Euc_Jp","","EUC-JP",147,null],[13,"Iso_2022_Kr","","ISO-2022-KR",147,null],[13,"Euc_Kr","","EUC-KR",147,null],[13,"Iso_2022_Jp","","ISO-2022-JP",147,null],[13,"Iso_2022_Jp_2","","ISO-2022-JP-2",147,null],[13,"Iso_8859_6_E","","ISO-8859-6-E",147,null],[13,"Iso_8859_6_I","","ISO-8859-6-I",147,null],[13,"Iso_8859_8_E","","ISO-8859-8-E",147,null],[13,"Iso_8859_8_I","","ISO-8859-8-I",147,null],[13,"Gb2312","","GB2312",147,null],[13,"Big5","","Big5",147,null],[13,"Koi8_R","","KOI8-R",147,null],[13,"Ext","","An arbitrary charset specified as a string",147,null],[5,"parse_extended_value","","Parses extended header parameter values (`ext-value`), as defined in RFC 5987.",null,{"i":[{"n":"str"}],"o":{"g":["extendedvalue","parseerror"],"n":"result"}}],[5,"http_percent_encode","","Percent encode a sequence of bytes with a character set defined in [https://tools.ietf.org/html/rfc5987#section-3.2][url]",null,null],[6,"FutureResponse","actix_web","Convenience type alias",null,null],[8,"AsyncResponder","","Convenience trait that converts `Future` object to a `Boxed` future",null,null],[10,"responder","","Convert to a boxed future",148,{"i":[{"n":"self"}],"o":{"g":["future"],"n":"box"}}],[8,"FromRequest","","Trait implemented by types that can be extracted from request.",null,null],[16,"Config","","Configuration for conversion process",149,null],[16,"Result","","Future that resolves to a Self",149,null],[10,"from_request","","Convert request to a Self",149,null],[11,"extract","","Convert request to a Self",149,null],[8,"Responder","","Trait implemented by types that generate responses for clients.",null,null],[16,"Item","","The associated item which can be returned.",150,null],[16,"Error","","The associated error which can be returned.",150,null],[10,"respond_to","","Convert itself to `AsyncResult` or `Error`.",150,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"n":"result"}}],[8,"HttpMessage","","Trait that implements general purpose operations on http messages",null,null],[16,"Stream","","Type of message payload stream",151,null],[10,"headers","","Read the message headers.",151,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[10,"payload","","Message payload stream",151,null],[11,"content_type","","Read the request content type. If request does not contain Content-Type header, empty str get returned.",151,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"encoding","","Get content type encoding",151,{"i":[{"n":"self"}],"o":{"g":["encodingref","contenttypeerror"],"n":"result"}}],[11,"mime_type","","Convert the request content type to a known mime type.",151,{"i":[{"n":"self"}],"o":{"g":["option","contenttypeerror"],"n":"result"}}],[11,"chunked","","Check if request has chunked transfer encoding",151,{"i":[{"n":"self"}],"o":{"g":["bool","parseerror"],"n":"result"}}],[11,"body","","Load http message body.",151,{"i":[{"n":"self"}],"o":{"n":"messagebody"}}],[11,"urlencoded","","Parse `application/x-www-form-urlencoded` encoded request's body. Return `UrlEncoded` future. Form can be deserialized to any type that implements `Deserialize` trait from serde.",151,{"i":[{"n":"self"}],"o":{"n":"urlencoded"}}],[11,"json","","Parse `application/json` encoded body. Return `JsonBody<T>` future. It resolves to a `T` value.",151,{"i":[{"n":"self"}],"o":{"n":"jsonbody"}}],[11,"multipart","","Return stream to http payload processes as multipart.",151,{"i":[{"n":"self"}],"o":{"n":"multipart"}}],[11,"readlines","","Return stream of lines.",151,{"i":[{"n":"self"}],"o":{"n":"readlines"}}],[14,"header","","",null,null],[11,"new","actix_web::dev","Create a drain from a future",152,{"i":[{"n":"receiver"}],"o":{"n":"self"}}],[11,"poll","","",152,null],[11,"limit","","Change max size of payload. By default max size is 256Kb",153,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"error_handler","","Set custom error handler",153,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"self"}}],[11,"default","","",153,{"o":{"n":"self"}}],[11,"limit","","Change max size of payload. By default max size is 256Kb",154,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"mimetype","","Set required mime-type of the request. By default mime type is not enforced.",154,{"i":[{"n":"self"},{"n":"mime"}],"o":{"n":"self"}}],[11,"default","","",154,{"o":{"n":"self"}}],[11,"extract","actix_web","Convert request to a Self",149,null],[11,"poll","actix_web::dev","",155,{"i":[{"n":"self"}],"o":{"n":"poll"}}],[11,"async","","Create async response",155,{"i":[{"g":["future"],"n":"box"}],"o":{"n":"asyncresult"}}],[11,"ok","","Send response",155,{"i":[{"n":"r"}],"o":{"n":"asyncresult"}}],[11,"err","","Send error",155,{"i":[{"n":"r"}],"o":{"n":"asyncresult"}}],[11,"respond_to","","",155,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["asyncresult","error"],"n":"result"}}],[11,"from","","",155,{"i":[{"n":"t"}],"o":{"n":"asyncresult"}}],[11,"from","","",155,{"i":[{"g":["asyncresult"],"n":"result"}],"o":{"n":"self"}}],[11,"from","","",155,{"i":[{"n":"result"}],"o":{"n":"self"}}],[11,"from","","",155,{"i":[{"g":["box"],"n":"result"}],"o":{"n":"self"}}],[11,"from","","",155,{"i":[{"g":["future"],"n":"box"}],"o":{"n":"asyncresult"}}],[11,"from","actix_web::error","",26,{"i":[{"n":"utf8error"}],"o":{"n":"parseerror"}}],[11,"fmt","","",26,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http","Formats the cookie `self` as a `Set-Cookie` header value.",156,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::error","",26,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http","",156,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",157,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"description","actix_web::error","",26,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"eq","","",26,{"i":[{"n":"self"},{"n":"parseerror"}],"o":{"n":"bool"}}],[11,"ne","","",26,{"i":[{"n":"self"},{"n":"parseerror"}],"o":{"n":"bool"}}],[11,"eq","actix_web::http","",156,{"i":[{"n":"self"},{"n":"cookie"}],"o":{"n":"bool"}}],[11,"clone","","",156,{"i":[{"n":"self"}],"o":{"n":"cookie"}}],[11,"clone","actix_web::error","",26,{"i":[{"n":"self"}],"o":{"n":"parseerror"}}],[11,"clone","actix_web::http","",157,{"i":[{"n":"self"}],"o":{"n":"cookiebuilder"}}],[11,"from_str","","",156,{"i":[{"n":"str"}],"o":{"g":["cookie","parseerror"],"n":"result"}}],[11,"from","actix_web::error","",25,{"i":[{"n":"errors"}],"o":{"n":"parseerror"}}],[11,"fmt","","",25,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",25,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"description","","",25,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"eq","","",25,{"i":[{"n":"self"},{"n":"parseerror"}],"o":{"n":"bool"}}],[11,"clone","","",25,{"i":[{"n":"self"}],"o":{"n":"parseerror"}}],[11,"cmp","actix_web::http","",158,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"ordering"}}],[11,"cmp","actix_web::http::header","",159,{"i":[{"n":"self"},{"n":"headervalue"}],"o":{"n":"ordering"}}],[11,"cmp","actix_web::http","",160,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"ordering"}}],[11,"into_iter","actix_web::http::header","Creates a consuming iterator, that is, one that moves keys and values out of the map in arbitary order. The map cannot be used after calling this.",161,{"i":[{"n":"self"}],"o":{"n":"intoiter"}}],[11,"into_iter","","",162,{"i":[{"n":"self"}],"o":{"n":"valueitermut"}}],[11,"into_iter","","",163,{"i":[{"n":"self"}],"o":{"n":"valueiter"}}],[11,"borrow","","",164,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"from","","",159,{"i":[{"n":"u64"}],"o":{"n":"headervalue"}}],[11,"from","","",164,{"i":[{"n":"headername"}],"o":{"n":"headername"}}],[11,"from","","",159,{"i":[{"n":"i64"}],"o":{"n":"headervalue"}}],[11,"from","","",159,{"i":[{"n":"usize"}],"o":{"n":"headervalue"}}],[11,"from","","",159,{"i":[{"n":"i32"}],"o":{"n":"headervalue"}}],[11,"from","","",159,{"i":[{"n":"headername"}],"o":{"n":"headervalue"}}],[11,"from","","",159,{"i":[{"n":"i16"}],"o":{"n":"headervalue"}}],[11,"from","","",159,{"i":[{"n":"isize"}],"o":{"n":"headervalue"}}],[11,"from","","",159,{"i":[{"n":"u32"}],"o":{"n":"headervalue"}}],[11,"from","","",159,{"i":[{"n":"u16"}],"o":{"n":"headervalue"}}],[11,"next","","",165,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"next","","",166,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"next","","",167,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"next","","",168,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"next","","",169,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"next","","",170,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"next","","",171,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"next","","",172,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"from_iter","","",161,{"i":[{"n":"i"}],"o":{"n":"headermap"}}],[11,"fmt","","",173,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",174,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",175,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http","",160,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http::header","",176,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http","",177,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http::header","",178,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",164,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",163,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",161,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",173,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",172,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http","",160,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http::header","",176,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",178,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",141,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",174,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http","",158,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http::header","",169,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http","",177,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::http::header","",170,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",168,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",175,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",167,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",179,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",166,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",171,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",159,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",162,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",165,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"drop","","",165,null],[11,"drop","","",172,null],[11,"drop","","",167,null],[11,"from_str","","",164,{"i":[{"n":"str"}],"o":{"g":["headername","invalidheadername"],"n":"result"}}],[11,"from_str","actix_web::http","",177,{"i":[{"n":"str"}],"o":{"g":["method"],"n":"result"}}],[11,"from_str","actix_web::http::header","",159,{"i":[{"n":"str"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"from_str","actix_web::http","",160,{"i":[{"n":"str"}],"o":{"g":["statuscode","invalidstatuscode"],"n":"result"}}],[11,"partial_cmp","actix_web::http::header","",159,null],[11,"partial_cmp","","",159,{"i":[{"n":"self"},{"n":"str"}],"o":{"g":["ordering"],"n":"option"}}],[11,"partial_cmp","actix_web::http","",158,{"i":[{"n":"self"},{"n":"version"}],"o":{"g":["ordering"],"n":"option"}}],[11,"lt","","",158,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"bool"}}],[11,"le","","",158,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"bool"}}],[11,"gt","","",158,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"bool"}}],[11,"ge","","",158,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"bool"}}],[11,"partial_cmp","actix_web::http::header","",159,{"i":[{"n":"self"},{"n":"t"}],"o":{"g":["ordering"],"n":"option"}}],[11,"partial_cmp","","",159,{"i":[{"n":"self"},{"n":"headervalue"}],"o":{"g":["ordering"],"n":"option"}}],[11,"partial_cmp","","",159,{"i":[{"n":"self"},{"n":"string"}],"o":{"g":["ordering"],"n":"option"}}],[11,"partial_cmp","actix_web::http","",160,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"g":["ordering"],"n":"option"}}],[11,"lt","","",160,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"bool"}}],[11,"le","","",160,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"bool"}}],[11,"gt","","",160,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"bool"}}],[11,"ge","","",160,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"bool"}}],[11,"try_from","","",177,null],[11,"try_from","","",177,{"i":[{"n":"method"}],"o":{"g":["method"],"n":"result"}}],[11,"try_from","actix_web::http::header","",164,{"i":[{"n":"str"}],"o":{"g":["headername"],"n":"result"}}],[11,"try_from","","",159,{"i":[{"n":"headervalue"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",159,{"i":[{"n":"u64"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",159,{"i":[{"n":"u32"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","actix_web::http","",160,{"i":[{"n":"statuscode"}],"o":{"g":["statuscode"],"n":"result"}}],[11,"try_from","actix_web::http::header","",159,{"i":[{"n":"usize"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",164,null],[11,"try_from","actix_web::http","",160,null],[11,"try_from","actix_web::http::header","",159,null],[11,"try_from","actix_web::http","",177,{"i":[{"n":"str"}],"o":{"g":["method"],"n":"result"}}],[11,"try_from","actix_web::http::header","",159,{"i":[{"n":"bytes"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",159,{"i":[{"n":"i32"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",159,{"i":[{"n":"headername"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",159,{"i":[{"n":"u16"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",159,{"i":[{"n":"str"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",164,{"i":[{"n":"bytes"}],"o":{"g":["headername"],"n":"result"}}],[11,"try_from","actix_web::http","",160,{"i":[{"n":"u16"}],"o":{"g":["statuscode"],"n":"result"}}],[11,"try_from","actix_web::http::header","",159,{"i":[{"n":"isize"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",159,{"i":[{"n":"i16"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","actix_web::http","",160,{"i":[{"n":"str"}],"o":{"g":["statuscode"],"n":"result"}}],[11,"try_from","actix_web::http::header","",159,{"i":[{"n":"i64"}],"o":{"g":["headervalue"],"n":"result"}}],[11,"try_from","","",164,{"i":[{"n":"headername"}],"o":{"g":["headername"],"n":"result"}}],[11,"default","actix_web::http","",177,{"o":{"n":"method"}}],[11,"default","actix_web::http::header","",161,{"o":{"n":"headermap"}}],[11,"default","actix_web::http","",160,{"o":{"n":"statuscode"}}],[11,"default","","",158,{"o":{"n":"version"}}],[11,"description","actix_web::http::header","",174,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"description","","",178,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"description","","",176,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"description","","",175,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"description","","",173,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"as_ref","","",164,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"as_ref","","",159,null],[11,"as_ref","actix_web::http","",177,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"as_ref","actix_web::http::header","",164,null],[11,"eq","actix_web::http","",177,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"bool"}}],[11,"eq","","",177,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"bool"}}],[11,"eq","actix_web::http::header","Performs a case-insensitive comparison of the string against the header name",164,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"bool"}}],[11,"eq","","",163,{"i":[{"n":"self"},{"n":"getall"}],"o":{"n":"bool"}}],[11,"eq","","Performs a case-insensitive comparison of the string against the header name",164,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"bool"}}],[11,"eq","","",159,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"bool"}}],[11,"eq","","",159,{"i":[{"n":"self"},{"n":"string"}],"o":{"n":"bool"}}],[11,"eq","actix_web::http","",177,{"i":[{"n":"self"},{"n":"method"}],"o":{"n":"bool"}}],[11,"ne","","",177,{"i":[{"n":"self"},{"n":"method"}],"o":{"n":"bool"}}],[11,"eq","actix_web::http::header","",159,null],[11,"eq","actix_web::http","",160,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"bool"}}],[11,"ne","","",160,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"bool"}}],[11,"eq","actix_web::http::header","",159,{"i":[{"n":"self"},{"n":"headervalue"}],"o":{"n":"bool"}}],[11,"eq","","",164,{"i":[{"n":"self"},{"n":"headername"}],"o":{"n":"bool"}}],[11,"eq","","",164,{"i":[{"n":"self"},{"n":"headername"}],"o":{"n":"bool"}}],[11,"ne","","",164,{"i":[{"n":"self"},{"n":"headername"}],"o":{"n":"bool"}}],[11,"eq","","",161,{"i":[{"n":"self"},{"n":"headermap"}],"o":{"n":"bool"}}],[11,"eq","actix_web::http","",160,{"i":[{"n":"self"},{"n":"u16"}],"o":{"n":"bool"}}],[11,"eq","","",158,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"bool"}}],[11,"ne","","",158,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"bool"}}],[11,"eq","actix_web::http::header","",159,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"bool"}}],[11,"extend","","",161,null],[11,"extend","","Extend a `HeaderMap` with the contents of another `HeaderMap`.",161,null],[11,"clone","","",164,{"i":[{"n":"self"}],"o":{"n":"headername"}}],[11,"clone","actix_web::http","",160,{"i":[{"n":"self"}],"o":{"n":"statuscode"}}],[11,"clone","","",158,{"i":[{"n":"self"}],"o":{"n":"version"}}],[11,"clone","actix_web::http::header","",161,{"i":[{"n":"self"}],"o":{"n":"headermap"}}],[11,"clone","actix_web::http","",177,{"i":[{"n":"self"}],"o":{"n":"method"}}],[11,"clone","actix_web::http::header","",159,{"i":[{"n":"self"}],"o":{"n":"headervalue"}}],[11,"hash","actix_web::http","",160,null],[11,"hash","","",177,null],[11,"hash","actix_web::http::header","",164,null],[11,"hash","","",159,null],[11,"hash","actix_web::http","",158,null],[11,"next_back","actix_web::http::header","",169,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"next_back","","",170,{"i":[{"n":"self"}],"o":{"n":"option"}}],[11,"index","","",161,{"i":[{"n":"self"},{"n":"k"}],"o":{"n":"t"}}],[11,"default","","",142,{"o":{"n":"languagetag"}}],[11,"fmt","","",142,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",142,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"eq","","",142,{"i":[{"n":"self"},{"n":"languagetag"}],"o":{"n":"bool"}}],[11,"clone","","",142,{"i":[{"n":"self"}],"o":{"n":"languagetag"}}],[11,"from_str","","",142,{"i":[{"n":"str"}],"o":{"g":["languagetag","error"],"n":"result"}}],[11,"poll","actix_web::actix::actix::dev::fut","",180,null],[11,"poll","","",181,null],[11,"poll","","",182,null],[11,"poll","","",183,null],[11,"poll","","",184,null],[11,"poll","","",185,null],[11,"stop","actix_web::actix::actix::dev","Stop current actor. SyncContext creates and starts new actor.",186,null],[11,"terminate","","Terminate actor execution. SyncContext creates and starts new actor.",186,null],[11,"state","","Actor execution state",186,{"i":[{"n":"self"}],"o":{"n":"actorstate"}}],[11,"stop","actix_web::actix::actix","",187,null],[11,"terminate","","",187,null],[11,"state","","",187,{"i":[{"n":"self"}],"o":{"n":"actorstate"}}],[11,"from","actix_web::actix::actix::dev::fut","",188,{"i":[{"n":"result"}],"o":{"n":"futureresult"}}],[11,"poll","","",114,null],[11,"poll","","",188,null],[11,"poll","","",189,null],[11,"poll","actix_web::actix::actix::dev::actors::resolver","",190,{"i":[{"n":"self"},{"n":"resolver"},{"n":"context"}],"o":{"g":["async"],"n":"result"}}],[11,"poll","actix_web::actix::actix::dev::fut","",191,null],[11,"poll","","",192,null],[11,"poll","","",193,null],[11,"poll","","",194,null],[11,"poll","","",195,null],[11,"poll","","",196,null],[11,"poll","","",197,null],[11,"poll","","",198,null],[11,"poll","","",199,null],[11,"fmt","actix_web::actix::actix","",121,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::actors::resolver","",105,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix","",125,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"handle","actix_web::actix::actix::dev::actors::resolver","",200,null],[11,"handle","actix_web::actix::actix::dev","",201,null],[11,"handle","actix_web::actix::actix::dev::actors::signal","",202,null],[11,"handle","actix_web::actix::actix::dev::actors::resolver","",200,null],[11,"handle","actix_web::actix::actix::dev","",201,{"i":[{"n":"self"},{"n":"startactor"},{"n":"context"}],"o":{"n":"addr"}}],[11,"handle","actix_web::actix::actix::dev::actors::signal","",203,null],[11,"handle","actix_web::actix::actix::dev::actors::resolver","",200,null],[11,"handle","actix_web::actix::actix::dev","",201,{"i":[{"n":"self"},{"n":"execute"},{"n":"context"}],"o":{"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::fut","",183,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::actors::signal","",107,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::fut","",189,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",199,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",180,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix","",117,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::fut","",193,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",204,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix","",118,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::fut","",194,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",185,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",184,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::actors::resolver","",104,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix","",121,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::actors::resolver","",105,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev","",205,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::fut","",192,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::actors::signal","",106,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::fut","",191,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",182,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix","",125,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::actors::resolver","",206,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::fut","",196,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",188,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::actors::resolver","",207,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","actix_web::actix::actix::dev::fut","",114,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"fmt","","",197,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"g":["error"],"n":"result"}}],[11,"parts","actix_web::actix::actix","",187,{"i":[{"n":"self"}],"o":{"n":"contextparts"}}],[11,"default","actix_web::actix::actix::dev","",205,{"o":{"n":"spawnhandle"}}],[11,"default","actix_web::actix::actix::dev::actors::signal","",202,{"o":{"n":"processsignals"}}],[11,"default","actix_web::actix::actix::dev","",208,{"o":{"n":"mailbox"}}],[11,"default","actix_web::actix::actix::dev::actors::resolver","",200,{"o":{"n":"resolver"}}],[11,"default","actix_web::actix::actix::dev::actors::signal","",203,{"o":{"n":"defaultsignalshandler"}}],[11,"default","actix_web::actix::actix","",209,{"o":{"n":"condition"}}],[11,"spawn","","",187,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"spawnhandle"}}],[11,"wait","","",187,null],[11,"waiting","","",187,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"cancel_future","","",187,{"i":[{"n":"self"},{"n":"spawnhandle"}],"o":{"n":"bool"}}],[11,"address","","",187,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"service_started","actix_web::actix::actix::dev::actors::signal","",202,null],[11,"clone","actix_web::actix::actix","",117,{"i":[{"n":"self"}],"o":{"n":"running"}}],[11,"clone","","",118,{"i":[{"n":"self"}],"o":{"n":"actorstate"}}],[11,"clone","actix_web::actix::actix::dev","",205,{"i":[{"n":"self"}],"o":{"n":"spawnhandle"}}],[11,"clone","","",210,{"i":[{"n":"self"}],"o":{"n":"systemregistry"}}],[11,"clone","actix_web::actix::actix::dev::actors::signal","",106,{"i":[{"n":"self"}],"o":{"n":"signaltype"}}],[11,"clone","actix_web::actix::actix::dev","",211,{"i":[{"n":"self"}],"o":{"n":"recipient"}}],[11,"clone","","",212,{"i":[{"n":"self"}],"o":{"n":"system"}}],[11,"clone","","",213,{"i":[{"n":"self"}],"o":{"n":"registry"}}],[11,"clone","actix_web::actix::actix","",214,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"poll","actix_web::actix::actix::dev","",215,{"i":[{"n":"self"}],"o":{"g":["async"],"n":"result"}}],[11,"poll","","",216,{"i":[{"n":"self"}],"o":{"g":["async"],"n":"result"}}],[11,"poll","actix_web::actix::actix::dev::fut","",204,{"i":[{"n":"self"}],"o":{"g":["async"],"n":"result"}}],[11,"drop","actix_web::actix::actix::dev","",201,null],[11,"handle","actix_web::actix::actix","",214,null],[11,"handle","actix_web::actix::actix::dev","",217,null],[11,"handle","","",218,null],[11,"handle","actix_web::actix::actix","",122,null],[11,"started","actix_web::actix::actix::dev::actors::signal","",203,null],[11,"started","actix_web::actix::actix::dev::actors::resolver","",200,null],[11,"cause","actix_web::actix::actix","",121,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",121,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"cause","actix_web::actix::actix::dev::actors::resolver","",105,{"i":[{"n":"self"}],"o":{"g":["fail"],"n":"option"}}],[11,"backtrace","","",105,{"i":[{"n":"self"}],"o":{"g":["backtrace"],"n":"option"}}],[11,"eq","actix_web::actix::actix::dev","",211,{"i":[{"n":"self"},{"n":"recipient"}],"o":{"n":"bool"}}],[11,"eq","actix_web::actix::actix","",118,{"i":[{"n":"self"},{"n":"actorstate"}],"o":{"n":"bool"}}],[11,"eq","","",214,{"i":[{"n":"self"},{"n":"addr"}],"o":{"n":"bool"}}],[11,"eq","actix_web::actix::actix::dev::actors::resolver","",206,{"i":[{"n":"self"},{"n":"resolve"}],"o":{"n":"bool"}}],[11,"ne","","",206,{"i":[{"n":"self"},{"n":"resolve"}],"o":{"n":"bool"}}],[11,"eq","actix_web::actix::actix::dev","",205,{"i":[{"n":"self"},{"n":"spawnhandle"}],"o":{"n":"bool"}}],[11,"ne","","",205,{"i":[{"n":"self"},{"n":"spawnhandle"}],"o":{"n":"bool"}}],[11,"eq","actix_web::actix::actix::dev::actors::resolver","",104,{"i":[{"n":"self"},{"n":"connectaddr"}],"o":{"n":"bool"}}],[11,"ne","","",104,{"i":[{"n":"self"},{"n":"connectaddr"}],"o":{"n":"bool"}}],[11,"eq","","",207,{"i":[{"n":"self"},{"n":"connect"}],"o":{"n":"bool"}}],[11,"ne","","",207,{"i":[{"n":"self"},{"n":"connect"}],"o":{"n":"bool"}}],[11,"eq","actix_web::actix::actix::dev::actors::signal","",106,{"i":[{"n":"self"},{"n":"signaltype"}],"o":{"n":"bool"}}],[11,"eq","actix_web::actix::actix","",117,{"i":[{"n":"self"},{"n":"running"}],"o":{"n":"bool"}}],[11,"pack","actix_web::actix::actix::dev","",186,{"i":[{"n":"m"},{"g":["sender"],"n":"option"}],"o":{"n":"envelope"}}],[11,"pack","actix_web::actix::actix","",187,{"i":[{"n":"m"},{"g":["sender"],"n":"option"}],"o":{"n":"envelope"}}],[11,"hash","actix_web::actix::actix::dev","",211,null],[11,"hash","actix_web::actix::actix","",214,null],[11,"hash","actix_web::actix::actix::dev","",205,null],[11,"iter","actix_web::http::header","Returns an iterator visiting all values associated with the entry.",163,{"i":[{"n":"self"}],"o":{"n":"valueiter"}}],[11,"key","","Returns a reference to the entry's key.",162,{"i":[{"n":"self"}],"o":{"n":"headername"}}],[11,"get","","Get a reference to the first value in the entry.",162,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"get_mut","","Get a mutable reference to the first value in the entry.",162,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"into_mut","","Converts the `OccupiedEntry` into a mutable reference to the first value.",162,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"insert","","Sets the value of the entry.",162,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"t"}}],[11,"insert_mult","","Sets the value of the entry.",162,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"valuedrain"}}],[11,"append","","Insert the value into the entry.",162,null],[11,"remove","","Remove the entry from the map.",162,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"remove_entry","","Remove the entry from the map.",162,null],[11,"remove_entry_mult","","Remove the entry from the map.",162,null],[11,"iter","","Returns an iterator visiting all values associated with the entry.",162,{"i":[{"n":"self"}],"o":{"n":"valueiter"}}],[11,"iter_mut","","Returns an iterator mutably visiting all values associated with the entry.",162,{"i":[{"n":"self"}],"o":{"n":"valueitermut"}}],[11,"key","","Returns a reference to the entry's key",179,{"i":[{"n":"self"}],"o":{"n":"headername"}}],[11,"into_key","","Take ownership of the key",179,{"i":[{"n":"self"}],"o":{"n":"headername"}}],[11,"insert","","Insert the value into the entry.",179,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"t"}}],[11,"insert_entry","","Insert the value into the entry.",179,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"occupiedentry"}}],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty.",141,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"t"}}],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default function if empty.",141,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"t"}}],[11,"key","","Returns a reference to the entry's key",141,{"i":[{"n":"self"}],"o":{"n":"headername"}}],[11,"from_bytes","","Converts a slice of bytes to an HTTP header name.",164,null],[11,"from_lowercase","","Converts a slice of bytes to an HTTP header name.",164,null],[11,"from_static","","Converts a static string to a HTTP header name.",164,{"i":[{"n":"str"}],"o":{"n":"headername"}}],[11,"as_str","","Returns a `str` representation of the header.",164,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"from_static","","Convert a static string to a `HeaderValue`.",159,{"i":[{"n":"str"}],"o":{"n":"headervalue"}}],[11,"from_str","","Attempt to convert a string to a `HeaderValue`.",159,{"i":[{"n":"str"}],"o":{"g":["headervalue","invalidheadervalue"],"n":"result"}}],[11,"from_name","","Converts a HeaderName into a HeaderValue",159,{"i":[{"n":"headername"}],"o":{"n":"headervalue"}}],[11,"from_bytes","","Attempt to convert a byte slice to a `HeaderValue`.",159,null],[11,"from_shared","","Attempt to convert a `Bytes` buffer to a `HeaderValue`.",159,{"i":[{"n":"bytes"}],"o":{"g":["headervalue","invalidheadervaluebytes"],"n":"result"}}],[11,"from_shared_unchecked","","Convert a `Bytes` directly into a `HeaderValue` without validating.",159,{"i":[{"n":"bytes"}],"o":{"n":"headervalue"}}],[11,"to_str","","Yields a `&str` slice if the `HeaderValue` only contains visible ASCII chars.",159,{"i":[{"n":"self"}],"o":{"g":["str","tostrerror"],"n":"result"}}],[11,"len","","Returns the length of `self`.",159,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"is_empty","","Returns true if the `HeaderValue` has a length of zero bytes.",159,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"as_bytes","","Converts a `HeaderValue` to a byte slice.",159,null],[11,"set_sensitive","","Mark that the header value represents sensitive information.",159,null],[11,"is_sensitive","","Returns `true` if the value represents sensitive data.",159,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"new","","Create an empty `HeaderMap`.",161,{"o":{"g":["headervalue"],"n":"headermap"}}],[11,"with_capacity","","Create an empty `HeaderMap` with the specified capacity.",161,{"i":[{"n":"usize"}],"o":{"n":"headermap"}}],[11,"len","","Returns the number of headers stored in the map.",161,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"keys_len","","Returns the number of keys stored in the map.",161,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",161,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"clear","","Clears the map, removing all key-value pairs. Keeps the allocated memory for reuse.",161,null],[11,"capacity","","Returns the number of headers the map can hold without reallocating.",161,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more headers to be inserted into the `HeaderMap`.",161,null],[11,"get","","Returns a reference to the value associated with the key.",161,{"i":[{"n":"self"},{"n":"k"}],"o":{"n":"option"}}],[11,"get_mut","","Returns a mutable reference to the value associated with the key.",161,{"i":[{"n":"self"},{"n":"k"}],"o":{"n":"option"}}],[11,"get_all","","Returns a view of all values associated with a key.",161,{"i":[{"n":"self"},{"n":"k"}],"o":{"n":"getall"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",161,{"i":[{"n":"self"},{"n":"k"}],"o":{"n":"bool"}}],[11,"iter","","An iterator visiting all key-value pairs.",161,{"i":[{"n":"self"}],"o":{"n":"iter"}}],[11,"iter_mut","","An iterator visiting all key-value pairs, with mutable value references.",161,{"i":[{"n":"self"}],"o":{"n":"itermut"}}],[11,"keys","","An iterator visiting all keys.",161,{"i":[{"n":"self"}],"o":{"n":"keys"}}],[11,"values","","An iterator visiting all values.",161,{"i":[{"n":"self"}],"o":{"n":"values"}}],[11,"values_mut","","An iterator visiting all values mutably.",161,{"i":[{"n":"self"}],"o":{"n":"valuesmut"}}],[11,"drain","","Clears the map, returning all entries as an iterator.",161,{"i":[{"n":"self"}],"o":{"n":"drain"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",161,{"i":[{"n":"self"},{"n":"k"}],"o":{"g":["entry","invalidheadername"],"n":"result"}}],[11,"insert","","Inserts a key-value pair into the map.",161,{"i":[{"n":"self"},{"n":"k"},{"n":"t"}],"o":{"n":"option"}}],[11,"append","","Inserts a key-value pair into the map.",161,{"i":[{"n":"self"},{"n":"k"},{"n":"t"}],"o":{"n":"bool"}}],[11,"remove","","Removes a key from the map, returning the value associated with the key.",161,{"i":[{"n":"self"},{"n":"k"}],"o":{"n":"option"}}],[11,"clone","","",145,{"i":[{"n":"self"}],"o":{"n":"dispositiontype"}}],[11,"fmt","","",145,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",145,{"i":[{"n":"self"},{"n":"dispositiontype"}],"o":{"n":"bool"}}],[11,"ne","","",145,{"i":[{"n":"self"},{"n":"dispositiontype"}],"o":{"n":"bool"}}],[11,"clone","","",146,{"i":[{"n":"self"}],"o":{"n":"dispositionparam"}}],[11,"fmt","","",146,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",146,{"i":[{"n":"self"},{"n":"dispositionparam"}],"o":{"n":"bool"}}],[11,"ne","","",146,{"i":[{"n":"self"},{"n":"dispositionparam"}],"o":{"n":"bool"}}],[11,"clone","","",144,{"i":[{"n":"self"}],"o":{"n":"contentdisposition"}}],[11,"fmt","","",144,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",144,{"i":[{"n":"self"},{"n":"contentdisposition"}],"o":{"n":"bool"}}],[11,"ne","","",144,{"i":[{"n":"self"},{"n":"contentdisposition"}],"o":{"n":"bool"}}],[11,"from_raw","","Parse a raw Content-Disposition header value",144,{"i":[{"n":"headervalue"}],"o":{"g":["parseerror"],"n":"result"}}],[11,"fmt","","",144,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"matches","","Matches language tags. The first language acts as a language range, the second one is used as a normal language tag. None fields in the language range are ignored. If the language tag has more extlangs than the range these extlangs are ignored. Matches are case-insensitive. `*` in language ranges are represented using `None` values. The language range `*` that matches language tags is created by the default language tag: `let wildcard: LanguageTag = Default::default();.`",142,{"i":[{"n":"self"},{"n":"languagetag"}],"o":{"n":"bool"}}],[11,"is_language_range","","Checks if it is a language range, meaning that there are no extension and privateuse tags.",142,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"canonicalize","","Returns the canonical version of the language tag.",142,{"i":[{"n":"self"}],"o":{"n":"languagetag"}}],[11,"clone","","",147,{"i":[{"n":"self"}],"o":{"n":"charset"}}],[11,"fmt","","",147,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",147,{"i":[{"n":"self"},{"n":"charset"}],"o":{"n":"bool"}}],[11,"ne","","",147,{"i":[{"n":"self"},{"n":"charset"}],"o":{"n":"bool"}}],[11,"fmt","","",147,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"from_str","","",147,{"i":[{"n":"str"}],"o":{"g":["charset"],"n":"result"}}],[11,"clone","actix_web::http","",139,{"i":[{"n":"self"}],"o":{"n":"contentencoding"}}],[11,"eq","","",139,{"i":[{"n":"self"},{"n":"contentencoding"}],"o":{"n":"bool"}}],[11,"fmt","","",139,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"is_compression","","Is the content compressed?",139,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"as_str","","Convert content encoding to string",139,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"quality","","default quality value",139,{"i":[{"n":"self"}],"o":{"n":"f64"}}],[11,"from","","",139,{"i":[{"n":"str"}],"o":{"n":"contentencoding"}}],[11,"clone","actix_web::http::header","",143,{"i":[{"n":"self"}],"o":{"n":"extendedvalue"}}],[11,"fmt","","",143,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"eq","","",143,{"i":[{"n":"self"},{"n":"extendedvalue"}],"o":{"n":"bool"}}],[11,"ne","","",143,{"i":[{"n":"self"},{"n":"extendedvalue"}],"o":{"n":"bool"}}],[11,"fmt","","",143,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"default","actix_web::http","Create default `NormalizePath` instance, append is set to true, merge is set to true and redirect is set to `StatusCode::MOVED_PERMANENTLY`",219,{"o":{"n":"normalizepath"}}],[11,"new","","Create new `NormalizePath` instance",219,{"i":[{"n":"bool"},{"n":"bool"},{"n":"statuscode"}],"o":{"n":"normalizepath"}}],[11,"handle","","",219,null],[11,"content_type","actix_web","Read the request content type. If request does not contain Content-Type header, empty str get returned.",151,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"encoding","","Get content type encoding",151,{"i":[{"n":"self"}],"o":{"g":["encodingref","contenttypeerror"],"n":"result"}}],[11,"mime_type","","Convert the request content type to a known mime type.",151,{"i":[{"n":"self"}],"o":{"g":["option","contenttypeerror"],"n":"result"}}],[11,"chunked","","Check if request has chunked transfer encoding",151,{"i":[{"n":"self"}],"o":{"g":["bool","parseerror"],"n":"result"}}],[11,"body","","Load http message body.",151,{"i":[{"n":"self"}],"o":{"n":"messagebody"}}],[11,"urlencoded","","Parse `application/x-www-form-urlencoded` encoded request's body. Return `UrlEncoded` future. Form can be deserialized to any type that implements `Deserialize` trait from serde.",151,{"i":[{"n":"self"}],"o":{"n":"urlencoded"}}],[11,"json","","Parse `application/json` encoded body. Return `JsonBody<T>` future. It resolves to a `T` value.",151,{"i":[{"n":"self"}],"o":{"n":"jsonbody"}}],[11,"multipart","","Return stream to http payload processes as multipart.",151,{"i":[{"n":"self"}],"o":{"n":"multipart"}}],[11,"readlines","","Return stream of lines.",151,{"i":[{"n":"self"}],"o":{"n":"readlines"}}],[11,"new","actix_web::dev","Create `MessageBody` for request.",220,{"i":[{"n":"t"}],"o":{"n":"messagebody"}}],[11,"limit","","Change max size of payload. By default max size is 256Kb",220,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"poll","","",220,{"i":[{"n":"self"}],"o":{"n":"poll"}}],[11,"new","","Create a new future to URL encode a request",221,{"i":[{"n":"t"}],"o":{"n":"urlencoded"}}],[11,"limit","","Change max size of payload. By default max size is 256Kb",221,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"poll","","",221,{"i":[{"n":"self"}],"o":{"n":"poll"}}],[11,"clone","actix_web::http","",140,{"i":[{"n":"self"}],"o":{"n":"connectiontype"}}],[11,"eq","","",140,{"i":[{"n":"self"},{"n":"connectiontype"}],"o":{"n":"bool"}}],[11,"fmt","","",140,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"status","actix_web::dev","Set HTTP status code of this response.",222,{"i":[{"n":"self"},{"n":"statuscode"}],"o":{"n":"self"}}],[11,"version","","Set HTTP version of this response.",222,{"i":[{"n":"self"},{"n":"version"}],"o":{"n":"self"}}],[11,"header","","Set a header.",222,{"i":[{"n":"self"},{"n":"k"},{"n":"v"}],"o":{"n":"self"}}],[11,"reason","","Set the custom reason for the response.",222,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"self"}}],[11,"content_encoding","","Set content encoding.",222,{"i":[{"n":"self"},{"n":"contentencoding"}],"o":{"n":"self"}}],[11,"force_close","","Force close connection, even if it is marked as keep-alive",222,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"chunked","","Enables automatic chunked transfer encoding",222,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"no_chunking","","Force disable chunked encoding",222,{"i":[{"n":"self"}],"o":{"n":"self"}}],[11,"content_type","","Set response content type",222,{"i":[{"n":"self"},{"n":"v"}],"o":{"n":"self"}}],[11,"content_length","","Set content length",222,{"i":[{"n":"self"},{"n":"u64"}],"o":{"n":"self"}}],[11,"cookie","","Set a cookie",222,{"i":[{"n":"self"},{"n":"cookie"}],"o":{"n":"self"}}],[11,"del_cookie","","Remove cookie",222,{"i":[{"n":"self"},{"n":"cookie"}],"o":{"n":"self"}}],[11,"if_true","","This method calls provided closure with builder reference if value is true.",222,{"i":[{"n":"self"},{"n":"bool"},{"n":"f"}],"o":{"n":"self"}}],[11,"if_some","","This method calls provided closure with builder reference if value is Some.",222,{"i":[{"n":"self"},{"n":"option"},{"n":"f"}],"o":{"n":"self"}}],[11,"write_buffer_capacity","","Set write buffer capacity",222,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"body","","Set a body and generate `HttpResponse`.",222,{"i":[{"n":"self"},{"n":"b"}],"o":{"n":"httpresponse"}}],[11,"streaming","","Set a streaming body and generate `HttpResponse`.",222,{"i":[{"n":"self"},{"n":"s"}],"o":{"n":"httpresponse"}}],[11,"json","","Set a json body and generate `HttpResponse`",222,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"httpresponse"}}],[11,"finish","","Set an empty body and generate `HttpResponse`",222,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"take","","This method construct new `HttpResponseBuilder`",222,{"i":[{"n":"self"}],"o":{"n":"httpresponsebuilder"}}],[11,"respond_to","","",222,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["httpresponse","error"],"n":"result"}}],[11,"from","","",222,{"i":[{"n":"clientresponse"}],"o":{"n":"httpresponsebuilder"}}],[11,"from","","",222,{"i":[{"n":"httprequest"}],"o":{"n":"httpresponsebuilder"}}],[11,"clone","","",223,{"i":[{"n":"self"}],"o":{"n":"connectioninfo"}}],[11,"default","","",223,{"o":{"n":"connectioninfo"}}],[11,"update","","Create ConnectionInfo instance for a request.",223,{"i":[{"n":"self"},{"n":"request"}]}],[11,"scheme","","Scheme of the request.",223,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"host","","Hostname of the request.",223,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"remote","","Remote IP of client initiated HTTP request.",223,{"i":[{"n":"self"}],"o":{"g":["str"],"n":"option"}}],[11,"limit","","Change max size of payload. By default max size is 256Kb",224,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"error_handler","","Set custom error handler",224,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"self"}}],[11,"default","","",224,{"o":{"n":"self"}}],[11,"new","","Create `JsonBody` for request.",225,{"i":[{"n":"t"}],"o":{"n":"self"}}],[11,"limit","","Change max size of payload. By default max size is 256Kb",225,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"self"}}],[11,"poll","","",225,{"i":[{"n":"self"}],"o":{"g":["jsonpayloaderror"],"n":"poll"}}],[11,"fmt","","",226,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"clone","","",226,{"i":[{"n":"self"}],"o":{"n":"params"}}],[11,"is_empty","","Check if there are any matched patterns",226,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"len","","Check number of extracted parameters",226,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"get","","Get matched parameter by name without type conversion",226,{"i":[{"n":"self"},{"n":"str"}],"o":{"g":["str"],"n":"option"}}],[11,"unprocessed","","Get unprocessed part of path",226,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"query","","Get matched `FromParam` compatible parameter by name.",226,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"result"}}],[11,"iter","","Return iterator to items in parameter container",226,{"i":[{"n":"self"}],"o":{"n":"paramsiter"}}],[11,"index","","",226,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"str"}}],[11,"index","","",226,{"i":[{"n":"self"},{"n":"usize"}],"o":{"n":"str"}}],[11,"fmt","","",227,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"new","","Create payload stream.",227,null],[11,"unread_data","","Put unused data back to payload",227,{"i":[{"n":"self"},{"n":"bytes"}]}],[11,"set_read_buffer_capacity","","Set read buffer capacity",227,{"i":[{"n":"self"},{"n":"usize"}]}],[11,"poll","","",227,{"i":[{"n":"self"}],"o":{"g":["option","payloaderror"],"n":"poll"}}],[11,"clone","","",227,{"i":[{"n":"self"}],"o":{"n":"payload"}}],[11,"new","","Create new `PayloadBuffer` instance",228,{"i":[{"n":"s"}],"o":{"n":"self"}}],[11,"get_mut","","Get mutable reference to an inner stream.",228,{"i":[{"n":"self"}],"o":{"n":"s"}}],[11,"readany","","Read first available chunk of bytes",228,{"i":[{"n":"self"}],"o":{"g":["option","payloaderror"],"n":"poll"}}],[11,"can_read","","Check if buffer contains enough bytes",228,{"i":[{"n":"self"},{"n":"usize"}],"o":{"g":["option","payloaderror"],"n":"poll"}}],[11,"get_chunk","","Return reference to the first chunk of data",228,{"i":[{"n":"self"}],"o":{"g":["option","payloaderror"],"n":"poll"}}],[11,"read_exact","","Read exact number of bytes",228,{"i":[{"n":"self"},{"n":"usize"}],"o":{"g":["option","payloaderror"],"n":"poll"}}],[11,"drop_bytes","","Remove specified amount if bytes from buffer",228,{"i":[{"n":"self"},{"n":"usize"}]}],[11,"copy","","Copy buffered data",228,{"i":[{"n":"self"},{"n":"usize"}],"o":{"g":["option","payloaderror"],"n":"poll"}}],[11,"read_until","","Read until specified ending",228,null],[11,"readline","","Read bytes until new line delimiter",228,{"i":[{"n":"self"}],"o":{"g":["option","payloaderror"],"n":"poll"}}],[11,"unprocessed","","Put unprocessed data back to the buffer",228,{"i":[{"n":"self"},{"n":"bytes"}]}],[11,"remaining","","Get remaining data from the buffer",228,{"i":[{"n":"self"}],"o":{"n":"bytes"}}],[11,"new","","Create new resource with specified resource definition",229,{"i":[{"n":"resourcedef"}],"o":{"n":"self"}}],[11,"name","","Set resource name",229,{"i":[{"n":"self"},{"n":"str"}]}],[11,"rdef","","Resource definition",229,{"i":[{"n":"self"}],"o":{"n":"resourcedef"}}],[11,"route","","Register a new route and return mutable reference to Route object. Route is used for route configuration, i.e. adding predicates, setting up handler.",229,{"i":[{"n":"self"}],"o":{"n":"route"}}],[11,"get","","Register a new `GET` route.",229,{"i":[{"n":"self"}],"o":{"n":"route"}}],[11,"post","","Register a new `POST` route.",229,{"i":[{"n":"self"}],"o":{"n":"route"}}],[11,"put","","Register a new `PUT` route.",229,{"i":[{"n":"self"}],"o":{"n":"route"}}],[11,"delete","","Register a new `DELETE` route.",229,{"i":[{"n":"self"}],"o":{"n":"route"}}],[11,"head","","Register a new `HEAD` route.",229,{"i":[{"n":"self"}],"o":{"n":"route"}}],[11,"method","","Register a new route and add method check to route.",229,{"i":[{"n":"self"},{"n":"method"}],"o":{"n":"route"}}],[11,"h","","Register a new route and add handler object.",229,{"i":[{"n":"self"},{"n":"h"}]}],[11,"f","","Register a new route and add handler function.",229,{"i":[{"n":"self"},{"n":"f"}]}],[11,"with","","Register a new route and add handler.",229,{"i":[{"n":"self"},{"n":"f"}]}],[11,"with_async","","Register a new route and add async handler.",229,{"i":[{"n":"self"},{"n":"f"}]}],[11,"middleware","","Register a resource middleware",229,{"i":[{"n":"self"},{"n":"m"}]}],[11,"default","","",230,{"o":{"n":"route"}}],[11,"filter","","Add match predicate to route.",230,{"i":[{"n":"self"},{"n":"t"}],"o":{"n":"self"}}],[11,"h","","Set handler object. Usually call to this method is last call during route configuration, so it does not return reference to self.",230,{"i":[{"n":"self"},{"n":"h"}]}],[11,"f","","Set handler function. Usually call to this method is last call during route configuration, so it does not return reference to self.",230,{"i":[{"n":"self"},{"n":"f"}]}],[11,"a","","Set async handler function.",230,{"i":[{"n":"self"},{"n":"h"}]}],[11,"with","","Set handler function, use request extractor for parameters.",230,{"i":[{"n":"self"},{"n":"f"}]}],[11,"with_config","","Set handler function. Same as `.with()` but it allows to configure extractor.",230,{"i":[{"n":"self"},{"n":"f"},{"n":"c"}]}],[11,"with_async","","Set async handler function, use request extractor for parameters. Also this method needs to be used if your handler function returns `impl Future<>`",230,{"i":[{"n":"self"},{"n":"f"}]}],[11,"with_async_config","","Set async handler function, use request extractor for parameters. This method allows to configure extractor.",230,{"i":[{"n":"self"},{"n":"f"},{"n":"c"}]}],[11,"clone","","",231,{"i":[{"n":"self"}],"o":{"n":"resourceinfo"}}],[11,"name","","Name os the resource",231,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"rdef","","This method returns reference to matched `ResourceDef` object.",231,{"i":[{"n":"self"}],"o":{"g":["resourcedef"],"n":"option"}}],[11,"match_info","","Get a reference to the Params object.",231,{"i":[{"n":"self"}],"o":{"n":"params"}}],[11,"url_for","","Generate url for named resource",231,{"i":[{"n":"self"},{"n":"request"},{"n":"str"},{"n":"u"}],"o":{"g":["url","urlgenerationerror"],"n":"result"}}],[11,"has_resource","","Check if application contains matching resource.",231,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"bool"}}],[11,"has_prefixed_resource","","Check if application contains matching resource.",231,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"bool"}}],[11,"default","","",232,{"o":{"n":"self"}}],[11,"handle","","Handle request",232,{"i":[{"n":"self"},{"n":"httprequest"}],"o":{"g":["httpresponse"],"n":"asyncresult"}}],[11,"recognize","","Query for matched resource",232,{"i":[{"n":"self"},{"n":"request"},{"n":"s"},{"n":"usize"}],"o":{"n":"resourceinfo"}}],[11,"fmt","","",136,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"clone","","",136,{"i":[{"n":"self"}],"o":{"n":"resourcetype"}}],[11,"eq","","",136,{"i":[{"n":"self"},{"n":"resourcetype"}],"o":{"n":"bool"}}],[11,"clone","","",233,{"i":[{"n":"self"}],"o":{"n":"resourcedef"}}],[11,"fmt","","",233,{"i":[{"n":"self"},{"n":"formatter"}],"o":{"n":"result"}}],[11,"new","","Parse path pattern and create new `Resource` instance.",233,{"i":[{"n":"str"}],"o":{"n":"self"}}],[11,"prefix","","Parse path pattern and create new `Resource` instance.",233,{"i":[{"n":"str"}],"o":{"n":"self"}}],[11,"external","","Construct external resource",233,{"i":[{"n":"str"}],"o":{"n":"self"}}],[11,"with_prefix","","Parse path pattern and create new `Resource` instance with custom prefix",233,{"i":[{"n":"str"},{"n":"str"},{"n":"bool"}],"o":{"n":"self"}}],[11,"rtype","","Resource type",233,{"i":[{"n":"self"}],"o":{"n":"resourcetype"}}],[11,"name","","Resource name",233,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"pattern","","Path pattern of the resource",233,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"is_match","","Is this path a match against this resource?",233,{"i":[{"n":"self"},{"n":"str"}],"o":{"n":"bool"}}],[11,"match_with_params","","Are the given path and parameters a match against this resource?",233,{"i":[{"n":"self"},{"n":"request"},{"n":"usize"}],"o":{"g":["params"],"n":"option"}}],[11,"match_prefix_with_params","","Is the given path a prefix match and do the parameters match against this resource?",233,{"i":[{"n":"self"},{"n":"request"},{"n":"usize"}],"o":{"g":["params"],"n":"option"}}],[11,"resource_path","","Build resource path.",233,{"i":[{"n":"self"},{"n":"u"},{"n":"str"}],"o":{"g":["string","urlgenerationerror"],"n":"result"}}],[11,"eq","","",233,{"i":[{"n":"self"},{"n":"resourcedef"}],"o":{"n":"bool"}}],[11,"hash","","",233,{"i":[{"n":"self"},{"n":"h"}]}],[11,"as_str","actix_web::error","Returns a description of this error as a string",26,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"error_response","actix_web::http::header","",176,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"error_response","","",178,{"i":[{"n":"self"}],"o":{"n":"httpresponse"}}],[11,"host","actix_web::actix::actix::dev::actors::resolver","",206,{"i":[{"n":"t"}],"o":{"n":"resolve"}}],[11,"host_and_port","","",206,{"i":[{"n":"t"},{"n":"u16"}],"o":{"n":"resolve"}}],[11,"host","","",207,{"i":[{"n":"t"}],"o":{"n":"connect"}}],[11,"host_and_port","","",207,{"i":[{"n":"t"},{"n":"u16"}],"o":{"n":"connect"}}],[11,"timeout","","Set connect timeout",207,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"connect"}}],[11,"new","","",200,{"i":[{"n":"resolverconfig"},{"n":"resolveropts"}],"o":{"n":"resolver"}}],[11,"new","","",190,{"i":[{"g":["socketaddr"],"n":"vecdeque"}],"o":{"n":"tcpconnector"}}],[11,"with_timeout","","",190,{"i":[{"g":["socketaddr"],"n":"vecdeque"},{"n":"duration"}],"o":{"n":"tcpconnector"}}],[11,"new","actix_web::actix::actix::dev::fut","",204,{"i":[{"n":"s"}],"o":{"n":"finish"}}],[11,"split","","Splits out the homogeneous type from an either of tuples.",114,null],[11,"new","actix_web::actix::actix::dev::msgs","",234,{"i":[{"n":"f"}],"o":{"n":"startactor"}}],[11,"new","","",235,{"i":[{"n":"f"}],"o":{"n":"execute"}}],[11,"exec","","Execute enclosed function",235,{"i":[{"n":"self"}],"o":{"n":"result"}}],[11,"start","actix_web::actix::actix","Start new sync arbiter with specified number of worker threads. Returns address of the started actor.",236,{"i":[{"n":"usize"},{"n":"f"}],"o":{"n":"addr"}}],[11,"wait","","",209,{"i":[{"n":"self"}],"o":{"n":"receiver"}}],[11,"set","","",209,null],[11,"alive","","Indicates if actor is alive",118,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"stopping","","Indicates if actor is stopped of stopping",118,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"with_receiver","","",187,{"i":[{"n":"addressreceiver"}],"o":{"n":"context"}}],[11,"run","","",187,{"i":[{"n":"self"},{"n":"a"}],"o":{"n":"addr"}}],[11,"into_future","","",187,{"i":[{"n":"self"},{"n":"a"}],"o":{"g":["context"],"n":"contextfut"}}],[11,"handle","","Handle of the running future",187,{"i":[{"n":"self"}],"o":{"n":"spawnhandle"}}],[11,"set_mailbox_capacity","","Set mailbox capacity",187,null],[11,"new","actix_web::actix::actix::io","",237,{"i":[{"n":"t"},{"n":"c"}],"o":{"n":"writer"}}],[11,"close","","Gracefully close sink",237,null],[11,"closed","","Check if sink is closed",237,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"set_buffer_capacity","","Set write buffer capacity",237,null],[11,"write","","Send item to a sink.",237,null],[11,"handle","","`SpawnHandle` for this writer",237,{"i":[{"n":"self"}],"o":{"n":"spawnhandle"}}],[11,"new","","",238,{"i":[{"n":"t"},{"n":"u"},{"n":"c"}],"o":{"n":"framedwrite"}}],[11,"from_buffer","","",238,{"i":[{"n":"t"},{"n":"u"},{"n":"bytesmut"},{"n":"c"}],"o":{"n":"framedwrite"}}],[11,"close","","Gracefully close sink",238,null],[11,"closed","","Check if sink is closed",238,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"set_buffer_capacity","","Set write buffer capacity",238,null],[11,"write","","Write item",238,null],[11,"handle","","`SpawnHandle` for this writer",238,{"i":[{"n":"self"}],"o":{"n":"spawnhandle"}}],[11,"start","actix_web::actix::actix","Start new supervised actor in current tokio runtime.",239,{"i":[{"n":"f"}],"o":{"n":"addr"}}],[11,"start_in_arbiter","","Start new supervised actor in arbiter's thread.",239,{"i":[{"n":"addr"},{"n":"f"}],"o":{"n":"addr"}}],[11,"new","","",214,{"i":[{"n":"addresssender"}],"o":{"n":"addr"}}],[11,"connected","","Indicates if actor is still alive",214,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"do_send","","Send message unconditionally",214,null],[11,"try_send","","Try send message",214,{"i":[{"n":"self"},{"n":"m"}],"o":{"g":["senderror"],"n":"result"}}],[11,"send","","Send asynchronous message and wait for response.",214,{"i":[{"n":"self"},{"n":"m"}],"o":{"n":"request"}}],[11,"recipient","","Get `Recipient` for specific message type",214,{"i":[{"n":"self"}],"o":{"n":"recipient"}}],[11,"into_inner","","",125,{"i":[{"n":"self"}],"o":{"n":"t"}}],[11,"new","actix_web::actix::actix::dev","Create new ContextParts instance",240,{"i":[{"n":"addresssenderproducer"}],"o":{"n":"contextparts"}}],[11,"stop","","Initiate stop process for actor execution",240,null],[11,"terminate","","Terminate actor execution",240,null],[11,"state","","Actor execution state",240,{"i":[{"n":"self"}],"o":{"n":"actorstate"}}],[11,"waiting","","Is context waiting for future completion",240,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"curr_handle","","Handle of the running future",240,{"i":[{"n":"self"}],"o":{"n":"spawnhandle"}}],[11,"spawn","","Spawn new future to this context.",240,{"i":[{"n":"self"},{"n":"f"}],"o":{"n":"spawnhandle"}}],[11,"wait","","Spawn new future to this context and wait future completion.",240,null],[11,"cancel_future","","Cancel previously scheduled future.",240,{"i":[{"n":"self"},{"n":"spawnhandle"}],"o":{"n":"bool"}}],[11,"capacity","","",240,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"set_mailbox_capacity","","",240,null],[11,"address","","",240,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"started","","",240,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"new","","",241,{"i":[{"n":"c"},{"n":"a"},{"n":"mailbox"}],"o":{"n":"contextfut"}}],[11,"ctx","","",241,{"i":[{"n":"self"}],"o":{"n":"c"}}],[11,"address","","",241,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"alive","","",241,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"next","","Get next handle",205,{"i":[{"n":"self"}],"o":{"n":"spawnhandle"}}],[11,"reply","","Create response",218,{"i":[{"n":"result"}],"o":{"n":"actorresponse"}}],[11,"async","","Create async response",218,{"i":[{"n":"t"}],"o":{"n":"actorresponse"}}],[11,"get","","Query registry for specific actor. Returns address of the actor. If actor is not registered, starts new actor and return address of newly created actor.",213,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"set","","Add new actor to the registry by address, panic if actor is already running",213,null],[11,"async","","Create async response",217,{"i":[{"n":"t"}],"o":{"n":"response"}}],[11,"reply","","Create response",217,{"i":[{"n":"result"}],"o":{"n":"response"}}],[11,"new","","",208,{"i":[{"n":"addressreceiver"}],"o":{"n":"mailbox"}}],[11,"capacity","","",208,{"i":[{"n":"self"}],"o":{"n":"usize"}}],[11,"set_capacity","","",208,null],[11,"connected","","",208,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"address","","",208,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"sender_producer","","",208,{"i":[{"n":"self"}],"o":{"n":"addresssenderproducer"}}],[11,"poll","","",208,null],[11,"new","","Create new system.",212,{"i":[{"n":"t"}],"o":{"n":"systemrunner"}}],[11,"current","","Get current running system.",212,{"o":{"n":"system"}}],[11,"with_current","","Execute function with system reference.",212,{"i":[{"n":"f"}],"o":{"n":"r"}}],[11,"stop","","Stop the system",212,null],[11,"arbiter","","System arbiter",212,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"registry","","Get current system registry.",212,{"i":[{"n":"self"}],"o":{"n":"systemregistry"}}],[11,"run","","This function will start tokio runtime and will finish once the `System::stop()` message get called. Function `f` get called within tokio runtime context.",212,{"i":[{"n":"f"}],"o":{"n":"i32"}}],[11,"do_send","","Send message",211,{"i":[{"n":"self"},{"n":"m"}],"o":{"g":["senderror"],"n":"result"}}],[11,"try_send","","Try send message",211,{"i":[{"n":"self"},{"n":"m"}],"o":{"g":["senderror"],"n":"result"}}],[11,"send","","Send message and asynchronously wait for response.",211,{"i":[{"n":"self"},{"n":"m"}],"o":{"n":"recipientrequest"}}],[11,"new","","",215,{"i":[{"g":["receiver"],"n":"option"},{"n":"option"}],"o":{"n":"recipientrequest"}}],[11,"timeout","","Set message delivery timeout",215,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"recipientrequest"}}],[11,"get","","Return address of the service. If service actor is not running it get started in the system.",210,{"i":[{"n":"self"}],"o":{"n":"addr"}}],[11,"set","","Add new actor to the registry by address, panic if actor is already running",210,null],[11,"timeout","","Set message delivery timeout",216,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"request"}}],[11,"builder","","Spawn new thread and run event loop in spawned thread. Returns address of newly created arbiter. Does not stop the system on panic.",201,{"o":{"n":"builder"}}],[11,"new","","Spawn new thread and run event loop in spawned thread. Returns address of newly created arbiter. Does not stop the system on panic.",201,{"i":[{"n":"t"}],"o":{"g":["arbiter"],"n":"addr"}}],[11,"name","","Returns current arbiter's name",201,{"o":{"n":"string"}}],[11,"current","","Returns current arbiter's address",201,{"o":{"g":["arbiter"],"n":"addr"}}],[11,"registry","","This function returns arbiter's registry,",201,{"o":{"n":"registry"}}],[11,"spawn","","Executes a future on the current thread.",201,null],[11,"spawn_fn","","Executes a future on the current thread.",201,null],[11,"start","","Start new arbiter and then start actor in created arbiter. Returns `Addr<Syn, A>` of created actor.",201,{"i":[{"n":"f"}],"o":{"n":"addr"}}],[11,"new","","",242,{"i":[{"n":"m"},{"g":["sender"],"n":"option"}],"o":{"n":"envelope"}}],[11,"with_proxy","","",242,{"i":[{"g":["envelopeproxy"],"n":"box"}],"o":{"n":"envelope"}}],[18,"GET","actix_web::http","GET",177,null],[18,"POST","","POST",177,null],[18,"PUT","","PUT",177,null],[18,"DELETE","","DELETE",177,null],[18,"HEAD","","HEAD",177,null],[18,"OPTIONS","","OPTIONS",177,null],[18,"CONNECT","","CONNECT",177,null],[18,"PATCH","","PATCH",177,null],[18,"TRACE","","TRACE",177,null],[11,"from_bytes","","Converts a slice of bytes to an HTTP method.",177,null],[11,"is_safe","","Whether a method is considered \"safe\", meaning the request is essentially read-only.",177,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"is_idempotent","","Whether a method is considered \"idempotent\", meaning the request has the same result if executed multiple times.",177,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"as_str","","Return a &str representation of the HTTP method",177,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"from_u16","","Converts a u16 to a status code.",160,{"i":[{"n":"u16"}],"o":{"g":["statuscode","invalidstatuscode"],"n":"result"}}],[11,"from_bytes","","Converts a &[u8] to a status code",160,null],[11,"as_u16","","Returns the `u16` corresponding to this `StatusCode`.",160,{"i":[{"n":"self"}],"o":{"n":"u16"}}],[11,"as_str","","Returns a &str representation of the `StatusCode`",160,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"canonical_reason","","Get the standardised `reason-phrase` for this status code.",160,{"i":[{"n":"self"}],"o":{"g":["str"],"n":"option"}}],[11,"is_informational","","Check if status is within 100-199.",160,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"is_success","","Check if status is within 200-299.",160,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"is_redirection","","Check if status is within 300-399.",160,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"is_client_error","","Check if status is within 400-499.",160,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"is_server_error","","Check if status is within 500-599.",160,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[18,"CONTINUE","","100 Continue [RFC7231, Section 6.2.1]",160,null],[18,"SWITCHING_PROTOCOLS","","101 Switching Protocols [RFC7231, Section 6.2.2]",160,null],[18,"PROCESSING","","102 Processing [RFC2518]",160,null],[18,"OK","","200 OK [RFC7231, Section 6.3.1]",160,null],[18,"CREATED","","201 Created [RFC7231, Section 6.3.2]",160,null],[18,"ACCEPTED","","202 Accepted [RFC7231, Section 6.3.3]",160,null],[18,"NON_AUTHORITATIVE_INFORMATION","","203 Non-Authoritative Information [RFC7231, Section 6.3.4]",160,null],[18,"NO_CONTENT","","204 No Content [RFC7231, Section 6.3.5]",160,null],[18,"RESET_CONTENT","","205 Reset Content [RFC7231, Section 6.3.6]",160,null],[18,"PARTIAL_CONTENT","","206 Partial Content [RFC7233, Section 4.1]",160,null],[18,"MULTI_STATUS","","207 Multi-Status [RFC4918]",160,null],[18,"ALREADY_REPORTED","","208 Already Reported [RFC5842]",160,null],[18,"IM_USED","","226 IM Used [RFC3229]",160,null],[18,"MULTIPLE_CHOICES","","300 Multiple Choices [RFC7231, Section 6.4.1]",160,null],[18,"MOVED_PERMANENTLY","","301 Moved Permanently [RFC7231, Section 6.4.2]",160,null],[18,"FOUND","","302 Found [RFC7231, Section 6.4.3]",160,null],[18,"SEE_OTHER","","303 See Other [RFC7231, Section 6.4.4]",160,null],[18,"NOT_MODIFIED","","304 Not Modified [RFC7232, Section 4.1]",160,null],[18,"USE_PROXY","","305 Use Proxy [RFC7231, Section 6.4.5]",160,null],[18,"TEMPORARY_REDIRECT","","307 Temporary Redirect [RFC7231, Section 6.4.7]",160,null],[18,"PERMANENT_REDIRECT","","308 Permanent Redirect [RFC7238]",160,null],[18,"BAD_REQUEST","","400 Bad Request [RFC7231, Section 6.5.1]",160,null],[18,"UNAUTHORIZED","","401 Unauthorized [RFC7235, Section 3.1]",160,null],[18,"PAYMENT_REQUIRED","","402 Payment Required [RFC7231, Section 6.5.2]",160,null],[18,"FORBIDDEN","","403 Forbidden [RFC7231, Section 6.5.3]",160,null],[18,"NOT_FOUND","","404 Not Found [RFC7231, Section 6.5.4]",160,null],[18,"METHOD_NOT_ALLOWED","","405 Method Not Allowed [RFC7231, Section 6.5.5]",160,null],[18,"NOT_ACCEPTABLE","","406 Not Acceptable [RFC7231, Section 6.5.6]",160,null],[18,"PROXY_AUTHENTICATION_REQUIRED","","407 Proxy Authentication Required [RFC7235, Section 3.2]",160,null],[18,"REQUEST_TIMEOUT","","408 Request Timeout [RFC7231, Section 6.5.7]",160,null],[18,"CONFLICT","","409 Conflict [RFC7231, Section 6.5.8]",160,null],[18,"GONE","","410 Gone [RFC7231, Section 6.5.9]",160,null],[18,"LENGTH_REQUIRED","","411 Length Required [RFC7231, Section 6.5.10]",160,null],[18,"PRECONDITION_FAILED","","412 Precondition Failed [RFC7232, Section 4.2]",160,null],[18,"PAYLOAD_TOO_LARGE","","413 Payload Too Large [RFC7231, Section 6.5.11]",160,null],[18,"URI_TOO_LONG","","414 URI Too Long [RFC7231, Section 6.5.12]",160,null],[18,"UNSUPPORTED_MEDIA_TYPE","","415 Unsupported Media Type [RFC7231, Section 6.5.13]",160,null],[18,"RANGE_NOT_SATISFIABLE","","416 Range Not Satisfiable [RFC7233, Section 4.4]",160,null],[18,"EXPECTATION_FAILED","","417 Expectation Failed [RFC7231, Section 6.5.14]",160,null],[18,"IM_A_TEAPOT","","418 I'm a teapot [curiously not registered by IANA but RFC2324]",160,null],[18,"MISDIRECTED_REQUEST","","421 Misdirected Request RFC7540, Section 9.1.2",160,null],[18,"UNPROCESSABLE_ENTITY","","422 Unprocessable Entity [RFC4918]",160,null],[18,"LOCKED","","423 Locked [RFC4918]",160,null],[18,"FAILED_DEPENDENCY","","424 Failed Dependency [RFC4918]",160,null],[18,"UPGRADE_REQUIRED","","426 Upgrade Required [RFC7231, Section 6.5.15]",160,null],[18,"PRECONDITION_REQUIRED","","428 Precondition Required [RFC6585]",160,null],[18,"TOO_MANY_REQUESTS","","429 Too Many Requests [RFC6585]",160,null],[18,"REQUEST_HEADER_FIELDS_TOO_LARGE","","431 Request Header Fields Too Large [RFC6585]",160,null],[18,"UNAVAILABLE_FOR_LEGAL_REASONS","","451 Unavailable For Legal Reasons [RFC7725]",160,null],[18,"INTERNAL_SERVER_ERROR","","500 Internal Server Error [RFC7231, Section 6.6.1]",160,null],[18,"NOT_IMPLEMENTED","","501 Not Implemented [RFC7231, Section 6.6.2]",160,null],[18,"BAD_GATEWAY","","502 Bad Gateway [RFC7231, Section 6.6.3]",160,null],[18,"SERVICE_UNAVAILABLE","","503 Service Unavailable [RFC7231, Section 6.6.4]",160,null],[18,"GATEWAY_TIMEOUT","","504 Gateway Timeout [RFC7231, Section 6.6.5]",160,null],[18,"HTTP_VERSION_NOT_SUPPORTED","","505 HTTP Version Not Supported [RFC7231, Section 6.6.6]",160,null],[18,"VARIANT_ALSO_NEGOTIATES","","506 Variant Also Negotiates [RFC2295]",160,null],[18,"INSUFFICIENT_STORAGE","","507 Insufficient Storage [RFC4918]",160,null],[18,"LOOP_DETECTED","","508 Loop Detected [RFC5842]",160,null],[18,"NOT_EXTENDED","","510 Not Extended [RFC2774]",160,null],[18,"NETWORK_AUTHENTICATION_REQUIRED","","511 Network Authentication Required [RFC6585]",160,null],[18,"HTTP_09","","`HTTP/0.9`",158,null],[18,"HTTP_10","","`HTTP/1.0`",158,null],[18,"HTTP_11","","`HTTP/1.1`",158,null],[18,"HTTP_2","","`HTTP/2.0`",158,null],[11,"new","","Creates a new `Cookie` with the given name and value.",156,{"i":[{"n":"n"},{"n":"v"}],"o":{"n":"cookie"}}],[11,"named","","Creates a new `Cookie` with the given name and an empty value.",156,{"i":[{"n":"n"}],"o":{"n":"cookie"}}],[11,"build","","Creates a new `CookieBuilder` instance from the given key and value strings.",156,{"i":[{"n":"n"},{"n":"v"}],"o":{"n":"cookiebuilder"}}],[11,"parse","","Parses a `Cookie` from the given HTTP cookie header value string. Does not perform any percent-decoding.",156,{"i":[{"n":"s"}],"o":{"g":["cookie","parseerror"],"n":"result"}}],[11,"parse_encoded","","Parses a `Cookie` from the given HTTP cookie header value string where the name and value fields are percent-encoded. Percent-decodes the name/value fields.",156,{"i":[{"n":"s"}],"o":{"g":["cookie","parseerror"],"n":"result"}}],[11,"encoded","","Wraps `self` in an `EncodedCookie`: a cost-free wrapper around `Cookie` whose `Display` implementation percent-encodes the name and value of the wrapped `Cookie`.",156,{"i":[{"n":"self"}],"o":{"n":"encodedcookie"}}],[11,"into_owned","","Converts `self` into a `Cookie` with a static lifetime. This method results in at most one allocation.",156,{"i":[{"n":"self"}],"o":{"n":"cookie"}}],[11,"name","","Returns the name of `self`.",156,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"value","","Returns the value of `self`.",156,{"i":[{"n":"self"}],"o":{"n":"str"}}],[11,"name_value","","Returns the name and value of `self` as a tuple of `(name, value)`.",156,null],[11,"http_only","","Returns whether this cookie was marked `HttpOnly` or not.",156,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"secure","","Returns whether this cookie was marked `Secure` or not.",156,{"i":[{"n":"self"}],"o":{"n":"bool"}}],[11,"same_site","","Returns the `SameSite` attribute of this cookie if one was specified.",156,{"i":[{"n":"self"}],"o":{"g":["samesite"],"n":"option"}}],[11,"max_age","","Returns the specified max-age of the cookie if one was specified.",156,{"i":[{"n":"self"}],"o":{"g":["duration"],"n":"option"}}],[11,"path","","Returns the `Path` of the cookie if one was specified.",156,{"i":[{"n":"self"}],"o":{"g":["str"],"n":"option"}}],[11,"domain","","Returns the `Domain` of the cookie if one was specified.",156,{"i":[{"n":"self"}],"o":{"g":["str"],"n":"option"}}],[11,"expires","","Returns the `Expires` time of the cookie if one was specified.",156,{"i":[{"n":"self"}],"o":{"g":["tm"],"n":"option"}}],[11,"set_name","","Sets the name of `self` to `name`.",156,null],[11,"set_value","","Sets the value of `self` to `value`.",156,null],[11,"set_http_only","","Sets the value of `http_only` in `self` to `value`.",156,null],[11,"set_secure","","Sets the value of `secure` in `self` to `value`.",156,null],[11,"set_same_site","","Sets the value of `same_site` in `self` to `value`.",156,null],[11,"set_max_age","","Sets the value of `max_age` in `self` to `value`.",156,null],[11,"set_path","","Sets the `path` of `self` to `path`.",156,null],[11,"set_domain","","Sets the `domain` of `self` to `domain`.",156,null],[11,"set_expires","","Sets the expires field of `self` to `time`.",156,null],[11,"make_permanent","","Makes `self` a \"permanent\" cookie by extending its expiration and max age 20 years into the future.",156,null],[11,"name_raw","","Returns the name of `self` as a string slice of the raw string `self` was originally parsed from. If `self` was not originally parsed from a raw string, returns `None`.",156,{"i":[{"n":"self"}],"o":{"g":["str"],"n":"option"}}],[11,"value_raw","","Returns the value of `self` as a string slice of the raw string `self` was originally parsed from. If `self` was not originally parsed from a raw string, returns `None`.",156,{"i":[{"n":"self"}],"o":{"g":["str"],"n":"option"}}],[11,"path_raw","","Returns the `Path` of `self` as a string slice of the raw string `self` was originally parsed from. If `self` was not originally parsed from a raw string, or if `self` doesn't contain a `Path`, or if the `Path` has changed since parsing, returns `None`.",156,{"i":[{"n":"self"}],"o":{"g":["str"],"n":"option"}}],[11,"domain_raw","","Returns the `Domain` of `self` as a string slice of the raw string `self` was originally parsed from. If `self` was not originally parsed from a raw string, or if `self` doesn't contain a `Domain`, or if the `Domain` has changed since parsing, returns `None`.",156,{"i":[{"n":"self"}],"o":{"g":["str"],"n":"option"}}],[11,"new","","Creates a new `CookieBuilder` instance from the given name and value.",157,{"i":[{"n":"n"},{"n":"v"}],"o":{"n":"cookiebuilder"}}],[11,"expires","","Sets the `expires` field in the cookie being built.",157,{"i":[{"n":"self"},{"n":"tm"}],"o":{"n":"cookiebuilder"}}],[11,"max_age","","Sets the `max_age` field in the cookie being built.",157,{"i":[{"n":"self"},{"n":"duration"}],"o":{"n":"cookiebuilder"}}],[11,"domain","","Sets the `domain` field in the cookie being built.",157,{"i":[{"n":"self"},{"n":"d"}],"o":{"n":"cookiebuilder"}}],[11,"path","","Sets the `path` field in the cookie being built.",157,{"i":[{"n":"self"},{"n":"p"}],"o":{"n":"cookiebuilder"}}],[11,"secure","","Sets the `secure` field in the cookie being built.",157,{"i":[{"n":"self"},{"n":"bool"}],"o":{"n":"cookiebuilder"}}],[11,"http_only","","Sets the `http_only` field in the cookie being built.",157,{"i":[{"n":"self"},{"n":"bool"}],"o":{"n":"cookiebuilder"}}],[11,"same_site","","Sets the `same_site` field in the cookie being built.",157,{"i":[{"n":"self"},{"n":"samesite"}],"o":{"n":"cookiebuilder"}}],[11,"permanent","","Makes the cookie being built 'permanent' by extending its expiration and max age 20 years into the future.",157,{"i":[{"n":"self"}],"o":{"n":"cookiebuilder"}}],[11,"finish","","Finishes building and returns the built `Cookie`.",157,{"i":[{"n":"self"}],"o":{"n":"cookie"}}]],"paths":[[3,"Form"],[3,"Json"],[4,"Binary"],[4,"Body"],[4,"Either"],[3,"App"],[3,"HttpContext"],[3,"Extensions"],[3,"Path"],[3,"Query"],[3,"HttpResponse"],[3,"State"],[3,"HttpRequest"],[3,"Scope"],[3,"ClientConnectorStats"],[4,"ClientConnectorError"],[4,"SendRequestError"],[3,"Connect"],[3,"Pause"],[3,"ClientConnector"],[3,"Connection"],[3,"SendRequest"],[3,"ClientRequest"],[3,"ClientRequestBuilder"],[3,"ClientResponse"],[4,"UrlParseError"],[4,"CookieParseError"],[4,"ParseError"],[4,"PayloadError"],[4,"MultipartError"],[4,"ExpectError"],[4,"ContentTypeError"],[4,"UrlencodedError"],[4,"JsonPayloadError"],[4,"ReadlinesError"],[4,"UriSegmentError"],[4,"UrlGenerationError"],[4,"StaticFileError"],[8,"ResponseError"],[3,"Error"],[3,"InternalError"],[3,"Directory"],[8,"StaticFileConfig"],[3,"DefaultConfig"],[3,"NamedFile"],[3,"ChunkedReadFile"],[3,"StaticFiles"],[4,"Started"],[4,"Response"],[4,"Finished"],[3,"Logger"],[4,"CorsError"],[4,"AllOrSome"],[3,"Cors"],[3,"CorsBuilder"],[4,"CsrfError"],[3,"CsrfFilter"],[3,"DefaultHeaders"],[3,"ErrorHandlers"],[8,"RequestIdentity"],[8,"Identity"],[8,"IdentityPolicy"],[3,"IdentityService"],[3,"CookieIdentityPolicy"],[4,"CookieSessionError"],[8,"RequestSession"],[3,"Session"],[3,"SessionStorage"],[3,"CookieSessionBackend"],[8,"Middleware"],[4,"MultipartItem"],[3,"Multipart"],[3,"Field"],[8,"Predicate"],[3,"AnyPredicate"],[3,"AllPredicate"],[3,"StopServer"],[4,"KeepAlive"],[3,"Request"],[3,"ServerSettings"],[3,"HttpServer"],[8,"HttpHandler"],[8,"HttpHandlerTask"],[8,"IntoHttpHandler"],[3,"TestServer"],[3,"TestServerBuilder"],[3,"TestApp"],[3,"TestRequest"],[3,"CloseReason"],[4,"ClientError"],[4,"CloseCode"],[4,"OpCode"],[4,"ProtocolError"],[4,"HandshakeError"],[4,"Message"],[3,"Client"],[3,"ClientHandshake"],[3,"ClientReader"],[3,"ClientWriter"],[3,"WebsocketContext"],[3,"Frame"],[3,"FramedMessage"],[8,"WsWriter"],[3,"WsStream"],[3,"ConnectAddr"],[4,"ResolverError"],[4,"SignalType"],[3,"Signal"],[3,"Subscribe"],[8,"ActorFuture"],[8,"ActorStream"],[8,"IntoActorFuture"],[8,"WrapFuture"],[8,"WrapStream"],[4,"Either"],[3,"StopArbiter"],[8,"Actor"],[4,"Running"],[4,"ActorState"],[8,"ContextFutureSpawner"],[8,"Supervised"],[4,"MailboxError"],[3,"MessageResult"],[8,"WriteHandler"],[8,"SystemService"],[4,"SendError"],[8,"ActorContext"],[8,"StreamHandler"],[8,"AsyncContextParts"],[8,"ResponseChannel"],[8,"ArbiterService"],[8,"Message"],[8,"ToEnvelope"],[8,"AsyncContext"],[8,"MessageResponse"],[8,"Handler"],[4,"ResourceType"],[8,"Handler"],[8,"FromParam"],[4,"ContentEncoding"],[4,"ConnectionType"],[4,"Entry"],[3,"LanguageTag"],[3,"ExtendedValue"],[3,"ContentDisposition"],[4,"DispositionType"],[4,"DispositionParam"],[4,"Charset"],[8,"AsyncResponder"],[8,"FromRequest"],[8,"Responder"],[8,"HttpMessage"],[3,"Drain"],[3,"FormConfig"],[3,"PayloadConfig"],[3,"AsyncResult"],[3,"Cookie"],[3,"CookieBuilder"],[3,"Version"],[3,"HeaderValue"],[3,"StatusCode"],[3,"HeaderMap"],[3,"OccupiedEntry"],[3,"GetAll"],[3,"HeaderName"],[3,"Drain"],[3,"Iter"],[3,"ValueDrain"],[3,"Keys"],[3,"ValueIterMut"],[3,"ValueIter"],[3,"Values"],[3,"IntoIter"],[3,"ToStrError"],[3,"InvalidHeaderNameBytes"],[3,"InvalidHeaderName"],[3,"InvalidHeaderValue"],[3,"Method"],[3,"InvalidHeaderValueBytes"],[3,"VacantEntry"],[3,"StreamAndThen"],[3,"StreamWrap"],[3,"StreamMap"],[3,"StreamTimeout"],[3,"StreamMapErr"],[3,"StreamThen"],[3,"SyncContext"],[3,"Context"],[3,"FutureResult"],[3,"AndThen"],[3,"TcpConnector"],[3,"MapErr"],[3,"FromErr"],[3,"Map"],[3,"Then"],[3,"FutureWrap"],[3,"Timeout"],[3,"StreamFold"],[3,"DropErr"],[3,"StreamFinish"],[3,"Resolver"],[3,"Arbiter"],[3,"ProcessSignals"],[3,"DefaultSignalsHandler"],[3,"Finish"],[3,"SpawnHandle"],[3,"Resolve"],[3,"Connect"],[3,"Mailbox"],[3,"Condition"],[3,"SystemRegistry"],[3,"Recipient"],[3,"System"],[3,"Registry"],[3,"Addr"],[3,"RecipientRequest"],[3,"Request"],[3,"Response"],[3,"ActorResponse"],[3,"NormalizePath"],[3,"MessageBody"],[3,"UrlEncoded"],[3,"HttpResponseBuilder"],[3,"ConnectionInfo"],[3,"JsonConfig"],[3,"JsonBody"],[3,"Params"],[3,"Payload"],[3,"PayloadBuffer"],[3,"Resource"],[3,"Route"],[3,"ResourceInfo"],[3,"Router"],[3,"ResourceDef"],[3,"StartActor"],[3,"Execute"],[3,"SyncArbiter"],[3,"Writer"],[3,"FramedWrite"],[3,"Supervisor"],[3,"ContextParts"],[3,"ContextFut"],[3,"Envelope"]]};
initSearch(searchIndex);
